2021-12-10  Kohei Yoshida  <kohei.yoshida@gmail.com>  [f7f9060e758109a8d4661691c044ee2a46074108]

	Add items for 0.17.1.


2021-12-10  Kohei Yoshida  <kohei.yoshida@gmail.com>  [5a459c8e70e38ccbf466ae2196aca2e2e48c4472]

	Fix make distcheck.


2021-12-08  Kohei Yoshida  <kohei.yoshida@gmail.com>  [82a5da70dae6b96a2f63dc1cc000aeae1fc1c276]

	Add a test case for ignore invalid sub structure.

	Also tweak the validator to allow elements when no rules are defined.

	This is related to #138.

2021-12-08  Kohei Yoshida  <kohei.yoshida@gmail.com>  [13fd8c214a34e7817afe493068f00d47a073ab09]

	Print short name in case an alias is not available.


2021-12-08  Kohei Yoshida  <kohei.yoshida@gmail.com>  [61126fb6ef8889cffa129ea34559fe6d12675f16]

	Introduce ORCUS_ODS_USE_THREADS env var to toggle threaded parsing.


2021-12-07  Kohei Yoshida  <kohei.yoshida@gmail.com>  [7ef047ae9ff3508d3c41749c55c893dcd2e1defb]

	Print ':' only when the namespace is not empty.

	Also add dump_state() to xmlns_context for debugging. Sometimes the
	code fails to fetch correct alias string from a namespace value.

2021-12-07  Kohei Yoshida  <kohei.yoshida@gmail.com>  [06f7d237fce4e47f388e58e721ac60e84b3f9b2e]

	Add even more rules.


2021-12-07  Kohei Yoshida  <kohei.yoshida@gmail.com>  [5345e4d55a2356d888c0811ea05cb9c03308936a]

	Add a whole bunch more rules.


2021-12-07  Kohei Yoshida  <kohei.yoshida@gmail.com>  [fde279c75ec388b2fea61900d3632e993df5d5c8]

	Define rules for <ss:Data> context.


2021-12-07  Kohei Yoshida  <kohei.yoshida@gmail.com>  [e26163ab7abfba598fb95133dc1457d1d021e032]

	Move up child element evaluation to the xml_context_base.

	And have the derived class provide the validation rules. This makes
	more sense.

	Also rename element_printer to xml_element_printer.

2021-12-07  Kohei Yoshida  <kohei.yoshida@gmail.com>  [6377c883c50d09e6aae2aea62dcb8e58a8bb59fd]

	No need to check XML structure in start_element(), now that it ...

	... is done in evaluate_child_element().

2021-12-07  Kohei Yoshida  <kohei.yoshida@gmail.com>  [7641764abc4a3b21f5825510d41d5e858aa1b545]

	More descriptive validation results.


2021-12-07  Kohei Yoshida  <kohei.yoshida@gmail.com>  [bb0ef631ca829e7a47039cdf397a4362bc8ce638]

	Move evaluate_child_element() above create_child_context().


2021-12-07  Kohei Yoshida  <kohei.yoshida@gmail.com>  [4242c31449a110bdad9fe6d34d638426b5cd8056]

	Extract the element printing logic and re-use it in xml_stream_handler.


2021-12-07  Kohei Yoshida  <kohei.yoshida@gmail.com>  [d06d31f182650cf74646b1177a313eb58a589de0]

	No reason why we wouldn't set it to all contexts on the stack.


2021-12-07  Kohei Yoshida  <kohei.yoshida@gmail.com>  [225f5ee352e861ce326f7576b72b8cd4c3a18385]

	This shouldn't be necessary since the ns cxt gets passed ...

	... from the parent context to the child via transfer_common(). For
	the invalid context, it gets set when in the stream handler's
	set_ns_context() method.

2021-12-06  Kohei Yoshida  <kohei.yoshida@gmail.com>  [96820dc40fc89ba2215b7e9ba4ef7ab26c2cfa60]

	Add some TODO items.


2021-12-06  Kohei Yoshida  <kohei.yoshida@gmail.com>  [bef436d0c99ccb55efc8fef30c0f1c216342774e]

	Now we can have xml_stream_handler create an invalid context directly.

	With this, there is no need to store this context in xml_stream_base.

2021-12-06  Kohei Yoshida  <kohei.yoshida@gmail.com>  [d6afee4ad69f51f523a45994db967c452d3086e2]

	Pass session_cxt and tokens to xml_stream_handler too.


2021-12-06  Kohei Yoshida  <kohei.yoshida@gmail.com>  [1702f665ce30940031c670456a1413d5cf090cf0]

	Add more valid rules.


2021-12-06  Kohei Yoshida  <kohei.yoshida@gmail.com>  [7f983dd85ed3bfbdc0747ca10e2e76486d1ef89d]

	<ss:Cell> to <ss:Data> is allowed.


2021-12-06  Kohei Yoshida  <kohei.yoshida@gmail.com>  [63e718cc1a4169cabf99592c26704967a0ea751e]

	print_element() to always print <>.


2021-12-06  Kohei Yoshida  <kohei.yoshida@gmail.com>  [32d14d7d8db63767161d396544b1174e12a10fa5]

	Tidy up the element structure validation rules.


2021-12-03  Kohei Yoshida  <kohei.yoshida@gmail.com>  [ebbfcbb8a3bc58e3305fc90c5a1faadcef6b4ef9]

	Print warning when an invalid element is encountered.


2021-12-03  Kohei Yoshida  <kohei.yoshida@gmail.com>  [4bfab6d792b4960144aae529c010389d98d4d161]

	Evaluate child element's validity ahead of time and make use of ...

	... an empty context to ignore the whole sub structure in case the
	child element is not valid.  Implemented only in xls_xml_context for
	now.

2021-12-03  Kohei Yoshida  <kohei.yoshida@gmail.com>  [caff6bd698bed25b957783e2eb5eb9d36e53bd4f]

	get_current_element() to not throw.


2021-12-03  Kohei Yoshida  <kohei.yoshida@gmail.com>  [b08628149729ee75d82df3ce947b5162e2c71cfd]

	We don't need non-const get_current_element() and get_parent_element().


2021-12-03  Kohei Yoshida  <kohei.yoshida@gmail.com>  [98866699519f14ccaecab01054a9e6cfe997ddc7]

	Add method docs.


2021-12-03  Kohei Yoshida  <kohei.yoshida@gmail.com>  [ab0376681244ddbe6cdaf23350adf3f93e0ec359]

	Add xml_empty_context to use it to ignore XML sub structures.


2021-12-03  Kohei Yoshida  <kohei.yoshida@gmail.com>  [889dde85e65e4460418fa8b000ae321304d29e86]

	Remove all traces of can_handle_element() virtual methods.


2021-12-02  Kohei Yoshida  <kohei.yoshida@gmail.com>  [f5b0a2e4542ec347ee4a9d796103dba198342f33]

	Remove can_handle_element() virtual method.

	By combining the role of can_handle_element() and create_child_context(),
	can_handle_element() is no longer needed.  The next step is to remove all
	the can_handle_element() methods from all the derived classes.

2021-12-02  Kohei Yoshida  <kohei.yoshida@gmail.com>  [26d8b8621db43667eb44f8d4159ea99b2d81137d]

	Re-generate ODF tokens based on v1.3 schema doc.

	Aside from the already deprecated 'process-content' token, v1.3 is
	a super set of v1.2 in terms of generated token set. So this should
	be a safe change.

2021-12-02  Kohei Yoshida  <kohei.yoshida@gmail.com>  [bf9e3219b8f753f2a81d86157c1bc299e5411e97]

	Skip relaxNG namespace.  This is only used in the schema doc.


2021-12-02  Kohei Yoshida  <kohei.yoshida@gmail.com>  [f03e8fec974ef4341043714d2a52f9f354fcce0e]

	A little cleanup


2021-12-02  Kohei Yoshida  <kohei.yoshida@gmail.com>  [1a1ffb361aed0f7cbbcf326f162fddb0fc020983]

	Add the option of generating token summary output.

	Useful for v1.2 to v1.3 comparison.

2021-12-02  Kohei Yoshida  <kohei.yoshida@gmail.com>  [6311423006f6c6cf4522fecb1638b51b62f6c242]

	Update the code to modern python and fix token generation.


2021-12-01  Kohei Yoshida  <kohei.yoshida@gmail.com>  [f6be585269e769233a01875dfc75192de11f03ea]

	Switch away from for_each() with function object.


2021-11-30  Kohei Yoshida  <kohei.yoshida@gmail.com>  [ee27f8ea326cfb5b304e46ceb7f84b441e090681]

	for_each to range for loop.


2021-11-30  Kohei Yoshida  <kohei.yoshida@gmail.com>  [a19ec1ab80af831cc2230bbc244d5e50e0452d32]

	Use namespace to group mapped values.


2021-11-30  Kohei Yoshida  <kohei.yoshida@gmail.com>  [81faf0b92dc296c751d220b60de7d69c99175e4c]

	for_each to range-based for loop.


2021-11-30  Kohei Yoshida  <kohei.yoshida@gmail.com>  [cf9a8a5a1f94765bd8c931af13e9c8d4bc40290b]

	More on pstring to std::string_view conversion.


2021-11-30  Kohei Yoshida  <kohei.yoshida@gmail.com>  [f108bc1625bce24a0d129a5fc8e2295ee8387012]

	pstring to std::string_view in xml_stream_handler.


2021-11-30  Kohei Yoshida  <kohei.yoshida@gmail.com>  [fdfaa98ac5125d6952b6d43f40998f196be9cb04]

	Use std::unique_ptr to wrap the root context instance.


2021-11-23  Kohei Yoshida  <kohei.yoshida@gmail.com>  [1e42935a443f6add4714affc57a35b2b5fc9235a]

	Set the next version to 0.17.1.


2021-11-23  Kohei Yoshida  <kohei.yoshida@gmail.com>  [e5bc949dbefd92dd0aef68f9cb35231ef3e09af3]

	Fix CMake's check target.


2021-11-23  Kohei Yoshida  <kohei.yoshida@gmail.com>  [134fe27bdc3d032da66cf5abf5030ebfa9e5c0d6]

	Fix the cmake build.


2021-11-19  Kohei Yoshida  <kohei.yoshida@gmail.com>  [0ed3e31c655f08dc5c774dd4598dd4a25505a94e]

	Introduce style_attrs_t<T> to simplify some types a bit.


2021-11-18  Kohei Yoshida  <kohei.yoshida@gmail.com>  [9513c43edc6bb439d490bcf9a988d3af516b45d8]

	Move this into a separate function like the other test groups.


2021-11-18  Kohei Yoshida  <kohei.yoshida@gmail.com>  [12fd70bcaaccb23a4df32025946e76bb07a583f7]

	Test for active flags on number format attributes.


2021-11-18  Kohei Yoshida  <kohei.yoshida@gmail.com>  [e23dc2f86a11ef1d3a895b54ae2a5f58bae541d7]

	Simplify the number format test code.


2021-11-18  Kohei Yoshida  <kohei.yoshida@gmail.com>  [a63c2ad2477c9bb4d7dc6c77a7efffa03a09d1af]

	Keep track of applied number format attributes and store that info.


2021-11-18  Kohei Yoshida  <kohei.yoshida@gmail.com>  [05a9bb17dec8b5895388f0cc196dcf5efa295645]

	Commit format code only when it's not empty. Otherwise use the default.


2021-11-18  Kohei Yoshida  <kohei.yoshida@gmail.com>  [0f31a7bc54cc82ccdafaf11b1f1adac7552ba017]

	Use override keywords.


2021-11-18  Kohei Yoshida  <kohei.yoshida@gmail.com>  [a7b59a58f0c8941c88020894b461c5a3bc4e0709]

	pstring to std::string_view.


2021-11-18  Kohei Yoshida  <kohei.yoshida@gmail.com>  [049fa8fd068702eda308166e83a05d970f902df5]

	Avoid repeatedly instantiating the number format context object.


2021-11-18  Kohei Yoshida  <kohei.yoshida@gmail.com>  [c1f1ee2b2c442c2003ec0771bcdc450d1f9bd3c8]

	Add active flags to number_format_t and store that in the backend.


2021-11-18  Kohei Yoshida  <kohei.yoshida@gmail.com>  [7a11d9d9673711843d4ed75eadc0e9feb30b34cf]

	Use to_bool().


2021-11-18  Kohei Yoshida  <kohei.yoshida@gmail.com>  [690676d6214a4de95d29420752eb0ef4884dc479]

	Class description.


2021-11-18  Kohei Yoshida  <kohei.yoshida@gmail.com>  [b906bda3a34e840f299b7670e084670a8a6e57cb]

	Add test cases for the rest of the protection styles.


2021-11-18  Kohei Yoshida  <kohei.yoshida@gmail.com>  [ba766652e39b8a1a63bf9605c37eb0fe7e42dc97]

	Only pass specified protection attributes during parsing...

	... and test the values for the "Hide Formula" style.

2021-11-18  Kohei Yoshida  <kohei.yoshida@gmail.com>  [c899a4727ef85003dea353c155814d46c9ea7f22]

	Create a test file for cell-protection styles, and set up a test function.

	Also add the active flags for protection_t and store that infor in the
	backend model.

2021-11-18  Kohei Yoshida  <kohei.yoshida@gmail.com>  [486317a6262a35b4db8e08a139a65c31a68db7be]

	Make the unexpected element error output more viewer friendly.


2021-11-18  Kohei Yoshida  <kohei.yoshida@gmail.com>  [40bfea71d98dc3447b184f66a5e4f4f122afe574]

	Add class annotations.


2021-11-18  Kohei Yoshida  <kohei.yoshida@gmail.com>  [594d9d22eb50b0e4cbb50f4539bfb82e777d9bf3]

	Add test code for border styles.

	Only the "Note" style in the standard styles has border attributes.

2021-11-18  Kohei Yoshida  <kohei.yoshida@gmail.com>  [1ec387914983bb95dc5443e41b2c81c3cae03032]

	Keep track of active states of border attributes.


2021-11-18  Kohei Yoshida  <kohei.yoshida@gmail.com>  [35662b1f4ddac35ec80e966a0f97f0683e07c21c]

	Simplify the code a bit.


2021-11-18  Kohei Yoshida  <kohei.yoshida@gmail.com>  [20a3efbcccc9c012f91c8cc44213347157b34825]

	Use value_type in lieu of std::make_pair(...).


2021-11-18  Kohei Yoshida  <kohei.yoshida@gmail.com>  [be7a595e8b8dc312c36900084ed11c6989fe7a76]

	Commit each property group only when they exist.

	Otherwise we'd be adding a whole bunch of duplicated default styles.
	An index of 0 is associated with the default style for that group,
	so using 0 is fine in case of empty property group.

2021-11-18  Kohei Yoshida  <kohei.yoshida@gmail.com>  [752a12afe0c0c02d0f64cb885b490c8744d756d1]

	Add test cases for fill properties for the rest of the standard styles.


2021-11-18  Kohei Yoshida  <kohei.yoshida@gmail.com>  [3eecdaa1dd4253f522440c5876076cc3547fccc9]

	When for RGB color values without A, set A to 255, not to 0.


2021-11-18  Kohei Yoshida  <kohei.yoshida@gmail.com>  [78d193b22e1c9d1e650d0ef5ad5ad1d597f04bbb]

	Add test cases for fill properties of "Note" style.


2021-11-18  Kohei Yoshida  <kohei.yoshida@gmail.com>  [8abe6858968377498c4139afa5da4059f3966842]

	Make the background color optional.


2021-11-18  Kohei Yoshida  <kohei.yoshida@gmail.com>  [6a50282e32b18d268d0cd239381b653ef76649c1]

	border_details -> border_details_t.

	This will prevent the type name and the variable name to be the same.

2021-11-18  Kohei Yoshida  <kohei.yoshida@gmail.com>  [cc8f5b0508d1039b2abdf9fa00895feab83f0dd8]

	Add fill_active_t and use it to keep track of active fill attributes.


2021-11-18  Kohei Yoshida  <kohei.yoshida@gmail.com>  [ddbed5d954d8ef0dce4d380f65357d55e53872bf]

	Switch from std::for_each to range-based for loop.


2021-11-18  Kohei Yoshida  <kohei.yoshida@gmail.com>  [7f43e353b51fea806b2344bb8a0587e4f2a34ee8]

	Early bail out on mp_styles being null.


2021-11-18  Kohei Yoshida  <kohei.yoshida@gmail.com>  [e506786779f7c3bbee5fc96c6ec31eb6ee01f409]

	Let's re-use xml_structure_error for this.


2021-11-18  Kohei Yoshida  <kohei.yoshida@gmail.com>  [331ad9cc53151c5b8a2527c0128c060c4a64c2a1]

	Handle table-cell-properties parsing in a separate method.


2021-11-18  Kohei Yoshida  <kohei.yoshida@gmail.com>  [d83bcd7cc65920ebe33853e3e100e09eebca558f]

	Add partial test case for the "Hyperlink" style properties.

	Also handle "font-color" underline color value, which re-uses the color
	of the font.

2021-11-18  Kohei Yoshida  <kohei.yoshida@gmail.com>  [0c3cbecddd3db3b066abb05681bcfb8884bc8ec4]

	Clean up and fix ODF's style:text-underline-style.

	There is no dot_dot_dot_dash. It is probably meant to be dot_dot_dash.

2021-11-18  Kohei Yoshida  <kohei.yoshida@gmail.com>  [5f62010ea02bee779cdbe038ba48df3d3beec131]

	Switch odf_helper class to namespace odf & do some cleanup.


2021-11-18  Kohei Yoshida  <kohei.yoshida@gmail.com>  [09354805f5c8e0c11e1ebfd535e376bf16aca5b6]

	Add checks for text properties.


2021-11-18  Kohei Yoshida  <kohei.yoshida@gmail.com>  [b7a9f8700f227a0631c91669f8864b512f8a6177]

	Add all styles entries with name checking.

	The properties will be evaluated later.

2021-11-18  Kohei Yoshida  <kohei.yoshida@gmail.com>  [134aa901e9a349e81eac6e589b0e42d6114bbf03]

	test_global.hpp must be included as the first header in every test.


2021-11-18  Kohei Yoshida  <kohei.yoshida@gmail.com>  [cf9601859cd7ba442208bedfb39a9bfd52f15d62]

	Test text properties for 'Heading 1'.

	Also mention the name of the style in case it's not found.

2021-11-18  Kohei Yoshida  <kohei.yoshida@gmail.com>  [8b5f6e62e47988e29e32d10ea1a0a5e1425ee3ac]

	Add function to simplify verification of active font attributes.


2021-11-18  Kohei Yoshida  <kohei.yoshida@gmail.com>  [cbfc4796b8c8dfb1036890300639f2dca4485fb8]

	Add active flag for the name attribute too.


2021-11-18  Kohei Yoshida  <kohei.yoshida@gmail.com>  [cc7cbf7960697fe97b219b4bb3bc16957f880263]

	Add test code to ensure correct active font attributes.

	Also, we shouldn't automatically use the font color for underline color
	in case the underline color is not specified. That should be left up to
	the client application.

2021-11-18  Kohei Yoshida  <kohei.yoshida@gmail.com>  [57cbacf8cfc04cea69fc333ac7462453d161fcfa]

	Use xml_elem_set_t for validation against multiple elements.

	Also fix some coding style with break.

2021-11-18  Kohei Yoshida  <kohei.yoshida@gmail.com>  [e4cf1db1e252f70f905cb725e0e5e74ebd62d927]

	Make strikethrough attributes optional.


2021-11-18  Kohei Yoshida  <kohei.yoshida@gmail.com>  [10bca6a9918b84d811b9bcadf3e1085050051c74]

	has_underline flag is probably meaningless.


2021-11-18  Kohei Yoshida  <kohei.yoshida@gmail.com>  [72352fd21c83bd2723c14e2a9fd7848ac5980534]

	Make underline attributes optional.


2021-11-18  Kohei Yoshida  <kohei.yoshida@gmail.com>  [9e01fbf64deb922426c4bc88114a2e279966b5ef]

	Add a missing header.


2021-11-18  Kohei Yoshida  <kohei.yoshida@gmail.com>  [0ffcc64137cb4d734f9c3063f38b1478e7d07fb4]

	Simplify the underline color handling logic with one less flag.


2021-11-18  Kohei Yoshida  <kohei.yoshida@gmail.com>  [512474b49097625212bb204daa912880f5e81418]

	Use color_rgb_t for underline color & make it optional.


2021-11-18  Kohei Yoshida  <kohei.yoshida@gmail.com>  [cd871067b37f64c7f9f49335df3aaa6306cadba6]

	Make color value optional & simplify its handling a bit.


2021-11-18  Kohei Yoshida  <kohei.yoshida@gmail.com>  [c07be816e5f5a62ecb756e4575fbf9ec1477ec06]

	Make font name, size, bold and italic values optional.

	This fixes one unit test case.

2021-11-18  Kohei Yoshida  <kohei.yoshida@gmail.com>  [de45db084d697916e1a9a9d3560d23cc6152244f]

	Use namespace to group related stuff.


2021-11-18  Kohei Yoshida  <kohei.yoshida@gmail.com>  [4e56fbb69c9dcafbd3f168b02d21b0d20a174ba7]

	spreadsheet -> ss


2021-11-18  Kohei Yoshida  <kohei.yoshida@gmail.com>  [faa55b6b42f5a9c321dacc6ee2e0842047b71053]

	Switch for_each with functor to range-based for loop.


2021-11-18  Kohei Yoshida  <kohei.yoshida@gmail.com>  [e714244cea2f535d36d6aaba08e460b4922ac46e]

	No using namespace std & fix header braces.


2021-11-18  Kohei Yoshida  <kohei.yoshida@gmail.com>  [e21774782146628c7e112da2e6d07246915f803b]

	Store active flags for font_t attribute values.

	Also set up a test framework for this.

2021-11-18  Kohei Yoshida  <kohei.yoshida@gmail.com>  [8c4f314d8d3f5ddb95e420c99faecfc152a30942]

	Use boost::filesystem to handle file paths.


2021-11-18  Kohei Yoshida  <kohei.yoshida@gmail.com>  [ed733e1c26f6c033f3b2a679dbad54a691382610]

	Remove m_ prefixes from struct members.


2021-11-18  Kohei Yoshida  <kohei.yoshida@gmail.com>  [4b9a2ae674c9fc911e2813275c596bbe49ec7b21]

	No more m_ prefixes on members of structs.


2021-11-18  Kohei Yoshida  <kohei.yoshida@gmail.com>  [a309312d6442ed34e127b5801ac937d36f3cd60d]

	Move mock_spreadsheet.* into test static lib.


2021-11-18  Kohei Yoshida  <kohei.yoshida@gmail.com>  [4d0abb255a0e615f7db86e814bcab642fa4e03dc]

	Rename orcus-odf-styles-context-test to orcus-test-import-ods.

	To be consistent with the rest of the tests in the same directory.

2021-11-18  Kohei Yoshida  <kohei.yoshida@gmail.com>  [0a03a307d9cc15450780d9ab7cdca7cde7f9adb8]

	The entire code (besides main) can be in anonymous namespace.


2021-11-18  Kohei Yoshida  <kohei.yoshida@gmail.com>  [9e216782e09da35665304933c9a51d4863fb1e5a]

	Set up a test model to simplify loading of styles.


2021-11-18  Kohei Yoshida  <kohei.yoshida@gmail.com>  [d59f11d296281154204d99d58f7508726107a479]

	const correctness & pass as reference not as a pointer.


2021-11-17  Caolán McNamara  <caolanm@redhat.com>  [17c502dc816158aec83e92e13e68f62c80fa7748]

	crashtesting: crash on passing null to std::string_view

	with many documents, e.g. moz377878-1.xhtml

2021-11-11  Caolán McNamara  <caolanm@redhat.com>  [19b3e2eb949240ce2f79d59b5433491f3cc3ca06]

	cid#364089 Uncaught exception


2021-11-11  Caolán McNamara  <caolanm@redhat.com>  [fd1e7d0dcc493dc4cd3e143c11e0b2f1c46ddd61]

	cid#364092 Uncaught exception


2021-11-11  Caolán McNamara  <caolanm@redhat.com>  [0fff7e0a27902ebbe759348c3e75968699ebb7fa]

	cid#364093 Uncaught exception


2021-11-11  Caolán McNamara  <caolanm@redhat.com>  [4be858d227504fab6d1b2a3f82e93c3378cd09b1]

	cid#364094 Uncaught exception


2021-11-11  Caolán McNamara  <caolanm@redhat.com>  [81afa784c85535850e539ed203d6dd1e548bcf86]

	cid#364090 Logically dead code


2021-11-11  Caolán McNamara  <caolanm@redhat.com>  [9b97d1d83715fe74b2942de387d088633bb18d40]

	cid#364091 Not restoring ostream format


2021-11-11  Caolán McNamara  <caolanm@redhat.com>  [0ab455332c226d9047035ddee16a317e0378101a]

	cid#364067 Uncaught exception

	suppress
	cid#364067 Uncaught exception
	cid#364064 Uncaught exception

	this makes ./configure --disable-spreadsheet-model 0 coverity warnings

2021-11-10  Caolán McNamara  <caolanm@redhat.com>  [0b5708a9fe0c4115f526ba36838b6725e4918af6]

	cid#364062 Uncaught exception


2021-11-10  Caolán McNamara  <caolanm@redhat.com>  [618e8716f7e441f9da62b3c0e4296d16701940c6]

	cid#364072 Uncaught exception


2021-11-09  Caolán McNamara  <caolanm@redhat.com>  [60dd68d0108f3b2a5c5bf4ab059cc0e611838807]

	cid#54447 Uninitialized pointer field


2021-11-09  Caolán McNamara  <caolanm@redhat.com>  [f1bfa7a1224d7ef54ea49703e95f54334786a767]

	cid#364070 Uninitialized scalar variable


2021-11-09  Caolán McNamara  <caolanm@redhat.com>  [d896dbae605420f98aaff1c7c34da1a42983cb59]

	cid364066 Missing move assignment operator


2021-11-09  Caolán McNamara  <caolanm@redhat.com>  [7241e81760d9e12f1f013c30b852bead2b2a7f0b]

	cid#54436 Uncaught exception


2021-11-09  Caolán McNamara  <caolanm@redhat.com>  [3e7e03c639797ebd6e3c744b59d202b37a63deac]

	cid#364068 Uninitialized scalar variable


2021-11-09  Caolán McNamara  <caolanm@redhat.com>  [4f29d4ed2255d758424f0667ab50a58fdc8660cb]

	cid#364063 drop unused variable


2021-11-09  Caolán McNamara  <caolanm@redhat.com>  [e80b0c36c404a941145b5ad4e7bc135bfe82c485]

	cid#364073 Uninitialized scalar field


2021-11-03  Kohei Yoshida  <kohei.yoshida@gmail.com>  [45fad9dff0731a278bee629fb088d4b5b7bd464b]

	Try using boost::filesystem instead of std::filesystem.

	std::filesystem still seems unreliable.

2021-11-03  Kohei Yoshida  <kohei.yoshida@gmail.com>  [bc2fc5c359b09f912ca4703da49d6749b397d50e]

	Unused variables.


2021-11-02  Kohei Yoshida  <kohei.yoshida@gmail.com>  [5bb64db5ecfd1dc3be3304092f4bdebff54deae5]

	Remove unused parameter warnings.


2021-10-29  Kohei Yoshida  <kohei.yoshida@gmail.com>  [bf4f3a43e18d670bcd1e9d9ba3be6933667cc56a]

	Update CHANGELOG.


2021-10-28  Kohei Yoshida  <kohei.yoshida@gmail.com>  [347ab944b31055c52a808cfa087dd83b231ee1f4]

	Set the version to 0.17.0.


2021-10-28  Kohei Yoshida  <kohei.yoshida@gmail.com>  [3410f561c2d883c0dfd3f870e2e318991ceeec7d]

	Fix cmake build for 'check' target.


2021-10-27  Kohei Yoshida  <kohei.yoshida@gmail.com>  [0828f365c5c20f1fabe45f16b9c799d40b347a84]

	We don't need TEST_BINS either.


2021-10-27  Kohei Yoshida  <kohei.yoshida@gmail.com>  [ed292f25af499df675169e238b788dfb7dbdbc6d]

	Fix make distcheck.

	Turns out we don't need these *.run files to set environment variables
	when we can simply use AM_TESTS_ENVIRONMENT instead.

2021-10-27  Kohei Yoshida  <kohei.yoshida@gmail.com>  [bfb29b7289e3c4bd7803a936871e3b3fdb78e1b8]

	Convert spaces to tabs for makefile.


2021-10-27  Kohei Yoshida  <kohei.yoshida@gmail.com>  [bd337588f051119f367e3b8b69525f8d697760d5]

	Replace the rest of boost::optional with std::optional.


2021-10-27  Kohei Yoshida  <kohei.yoshida@gmail.com>  [8f300171790b642743a2ca78f4db194dfff18594]

	Replace boost::optional with std::optional.

	This also helped remove the following warnings:

	xlsx_pivot_context.cpp:964:37: warning: ‘*((void*)& max_value +8)’ may be used uninitialized in this function [-Wmaybe-uninitialized]
	  964 |         m_pcache.set_field_max_value(*max_value);
	      |         ~~~~~~~~~~~~~~~~~~~~~~~~~~~~^~~~~~~~~~~~
	xlsx_pivot_context.cpp:961:37: warning: ‘*((void*)& min_value +8)’ may be used uninitialized in this function [-Wmaybe-uninitialized]
	  961 |         m_pcache.set_field_min_value(*min_value);
	      |         ~~~~~~~~~~~~~~~~~~~~~~~~~~~~^~~~~~~~~~~~

2021-10-27  Kohei Yoshida  <kohei.yoshida@gmail.com>  [de870554e43297e1db63b1d4e55f4c7a52a7ce9c]

	Add test case for utf-8 value parsing & implement move assignment.


2021-10-27  Kohei Yoshida  <kohei.yoshida@gmail.com>  [d28f63b2cd5b99f1677fc7040fa27a8ba2c736cd]

	Use std::unique_ptr for css_document_tree's pimpl, and simplify ...

	... test document loading.

2021-10-27  Kohei Yoshida  <kohei.yoshida@gmail.com>  [7f66db7253e4042a1f106050ec22f7f0fafc2084]

	Use boost::filesystem::path to handle file paths.


2021-10-27  Kohei Yoshida  <kohei.yoshida@gmail.com>  [de0aca38c48ca9b2f6eff8ec353e51b70dbe4d9a]

	Replace pstring with std::string_view and remove 'using namespace std'


2021-10-26  Kohei Yoshida  <kohei.yoshida@gmail.com>  [bb1b874aab2939bbcdf0584192ff6dff28e0c5ac]

	Retire clip() in favor of std::clamp().


2021-10-26  Kohei Yoshida  <kohei.yoshida@gmail.com>  [966c72f1258a36884bc32467b843393eac2694ff]

	Use std::isdigit().


2021-10-26  Kohei Yoshida  <kohei.yoshida@gmail.com>  [4b67ee4b204b72d34e72a0c5d933343affb51a82]

	Avoid shadowing of 'max_size'.


2021-10-26  Kohei Yoshida  <kohei.yoshida@gmail.com>  [528e35ea718913d454882fa1720bb7fc0c032e05]

	Remove is_name_char(). Is has limited usefulness.


2021-10-26  Kohei Yoshida  <kohei.yoshida@gmail.com>  [683012f54f5110562c4bfd016f537061697fedc7]

	Revise css property value parsing to allow valid utf-8 strings.


2021-10-26  Kohei Yoshida  <kohei.yoshida@gmail.com>  [5ca468a21142ae0f33bb523ec13c805e4d0feca6]

	css::parser_base::identifier() to take std::string_view.


2021-10-26  Kohei Yoshida  <kohei.yoshida@gmail.com>  [776289de7035069a61bea22eb49ddc7bef4f2011]

	Use std::isalpha() for alpha-numeric character test.

	But first cast it to unsigned char before calling std::isalpha, for
	safety.

2021-10-26  Kohei Yoshida  <kohei.yoshida@gmail.com>  [500c0b8441914ffa3104e34fbb96d0ed0f3285ed]

	Fix header includes to use <> for orcus public headers.


2021-10-26  Kohei Yoshida  <kohei.yoshida@gmail.com>  [a0f016bb1add86e153cd7ed3292f480eb116bc77]

	Remove write_to(). This is not all that useful.


2021-10-26  Kohei Yoshida  <kohei.yoshida@gmail.com>  [56ecd338b818e76d988057f6af5b49f96d80c065]

	is_in() to take std::string_view.

	Also use std::any_of() instead of manual loop.

2021-10-25  Kohei Yoshida  <kohei.yoshida@gmail.com>  [3f0194b513f99c894f186b05e7e5eb7f5fc7d0ef]

	Remove unnecessary check for the first char of a name.

	With the utf-8 parsing code doubling as a check for valid first
	character of a name, we don't need these extra checks anymore.

	This should fix #143.

2021-10-25  Kohei Yoshida  <kohei.yoshida@gmail.com>  [a252d4e521c8773c53fa65366688bfa513131c2e]

	Rename non-ascii -> utf8-1.


2021-10-25  Kohei Yoshida  <kohei.yoshida@gmail.com>  [18ce63710577dfe9f55b99648595cb503ba9933d]

	Quote key strings in presence of '#' or ': '.

	This is related to #14.

2021-10-25  Kohei Yoshida  <kohei.yoshida@gmail.com>  [28ba2d878b7394c625ebb28c24a9ba7abb54c9c7]

	Build fix for VS 2017.


2021-10-22  Kohei Yoshida  <kohei.yoshida@gmail.com>  [e5e747145957555d33b61cd1dd382e1251621d6f]

	Use literalinclude instead of copy-n-paste the code block.


2021-10-22  Kohei Yoshida  <kohei.yoshida@gmail.com>  [5e22dcf1a1eaa027c9ed59957009a3a3ad08ef1d]

	Add YAML option to the doc.


2021-10-21  Kohei Yoshida  <kohei.yoshida@gmail.com>  [a2a221a7178cba774b56356ea241255ecf9cf525]

	Add yaml option to the help output.


2021-10-21  Kohei Yoshida  <kohei.yoshida@gmail.com>  [3d0870372835a6d3f44fbcf515f70dc17c9c49d6]

	Update slickedit project.


2021-10-21  Kohei Yoshida  <kohei.yoshida@gmail.com>  [d560ef1fe0cfb756494a4b8ba4c026900522ca3d]

	I forgot to add this file...


2021-10-21  Kohei Yoshida  <kohei.yoshida@gmail.com>  [d1e748055b7281e3f98fdefbaaac2b92e303acfc]

	Add more yaml output controls.


2021-10-21  Kohei Yoshida  <kohei.yoshida@gmail.com>  [6c289a932d6dadbc2f8e0c769bed82a6ce3b96c0]

	Turn test_global.cpp into a static lib and reference it as a lib.

	This way we can avoid the possible forward imcompatibility warning of
	automake.

2021-10-21  Kohei Yoshida  <kohei.yoshida@gmail.com>  [43414037943bae59b87104b132a7db5c4f0b7187]

	Set up a framework to test json doc tree against yaml output.


2021-10-21  Kohei Yoshida  <kohei.yoshida@gmail.com>  [2a0820846a0d3b2d8e7787e44b1abe36dd22f80f]

	Use boost::filesystem instead of string to handle file paths.


2021-10-21  Kohei Yoshida  <kohei.yoshida@gmail.com>  [bbde1e1636d3971e53498b6fefd8bd929f937fcd]

	Remove using namespace std.


2021-10-21  Kohei Yoshida  <kohei.yoshida@gmail.com>  [0beb5b4bbd5092fe3e2e8748423c7e28f205fa5b]

	Don't start with a line break at root scope.


2021-10-21  Kohei Yoshida  <kohei.yoshida@gmail.com>  [fe1b2e9f47b66129b51b9d874204d82d7a1e6a0f]

	Re-use the "bullet" line in case the parent is an array.

	Instead of writing

	  -
	    key: value
	    key: value

	write

	  - key: value
	    key: value

2021-10-21  Kohei Yoshida  <kohei.yoshida@gmail.com>  [2004de9a27812913dd65b5a097d6bcb992feaef8]

	Put string value in quotes if it contains '#'.


2021-10-21  Kohei Yoshida  <kohei.yoshida@gmail.com>  [8ce9bdfa63e730be6c8735883dc868f9f431a71e]

	Dump all json value types in yaml output.


2021-10-21  Kohei Yoshida  <kohei.yoshida@gmail.com>  [ad88468b7bf0c8862596313e7da49ca44f2c006d]

	Set up 'yaml' output type for orcus-json with minimal dump function.

	No support for nested structures just yet.

2021-10-20  Kohei Yoshida  <kohei.yoshida@gmail.com>  [4e08ce88c4e9de5da6a6e8ffcb251f10cff4e103]

	Only remove the binaries, not the .run script files.

	This should fix #141.

2021-10-13  Kohei Yoshida  <kohei.yoshida@gmail.com>  [8fea3b3e0811891411b1ba66eb9e710f08de92ef]

	Set the doc version to 0.17.


2021-10-13  Kohei Yoshida  <kohei.yoshida@gmail.com>  [2d153266322a7be339510344ced901f2bd0bfec1]

	Use literalinclude for the JSON code examples.


2021-10-13  Kohei Yoshida  <kohei.yoshida@gmail.com>  [eee97476db14336e6a951d8076276f7a36e091b7]

	Use literalinclude for the rest of the section.


2021-10-13  Kohei Yoshida  <kohei.yoshida@gmail.com>  [07430422d3d7b08087567f5de1f4e5d9643642eb]

	Use literalinclude for the shared strings code examples.


2021-10-12  Kohei Yoshida  <kohei.yoshida@gmail.com>  [9126f3d82cf3b967d44928d940ccbb402ffb13d9]

	Add a sentence about 'ss' namespace alias.


2021-10-12  Kohei Yoshida  <kohei.yoshida@gmail.com>  [7e08e346391d66c79650ae4f0f89f8671f46568c]

	Use literalinclude for example code blocks with no string pool.


2021-10-12  Kohei Yoshida  <kohei.yoshida@gmail.com>  [359f115f6b1fc12418d92c59cb1318dfe51b20b7]

	Adjust the example code to remove using namespace.

	Also switch them to using INPUTDIR env var.

2021-10-12  Kohei Yoshida  <kohei.yoshida@gmail.com>  [1b879d08c1ea47b38f6f3aad91c35d18a4274c7e]

	Convert the first code example of user-defined custom doc class section.


2021-10-11  Kohei Yoshida  <kohei.yoshida@gmail.com>  [9a31d12063773a0e210e44e150e2ab150c060df0]

	Also cover the rest of the example code on the same page.


2021-10-11  Kohei Yoshida  <kohei.yoshida@gmail.com>  [2b054671e1390dcea30f6fa58f7671a77a1b06b9]

	Directly in clude example code verbatim from the source file.

	Also change how the input file path gets passed to the code, to make
	it look more presentable.

2021-10-08  Kohei Yoshida  <kohei.yoshida@gmail.com>  [e4c221827177c8ac3c96a41633d459eec314365b]

	Remove warnings in sphinx doc.


2021-10-07  Kohei Yoshida  <kohei.yoshida@gmail.com>  [e54ddafc4b73876d1238bf05f1ccfe2cc1d9c509]

	Move encryption_info.hpp header out of public location.


2021-10-07  Kohei Yoshida  <kohei.yoshida@gmail.com>  [e50c2fbe6281b7091a68a21083796a6fe41703f7]

	file_content interface to use std::string_view.


2021-10-07  Kohei Yoshida  <kohei.yoshida@gmail.com>  [1c5951dd3160d05157947e8c19d87b4206fdb5d9]

	memory_content to use std::string_view.


2021-10-07  Kohei Yoshida  <kohei.yoshida@gmail.com>  [0956260f9de0024e2d19296a24e6f8b68fbf6bb9]

	Modernize import_xlsx.


2021-10-07  Kohei Yoshida  <kohei.yoshida@gmail.com>  [d2b4288d43f60d4ccaa0a8f8d1aea3e99c9aad81]

	Modernize import_ods.


2021-10-07  Kohei Yoshida  <kohei.yoshida@gmail.com>  [885fbc68afca4f2eacd72a5ad6d51681d18b7865]

	append_record_value_character() to take std::string_view.


2021-10-07  Kohei Yoshida  <kohei.yoshida@gmail.com>  [51689c75cec0390b1535c2a8e8a4a2021a96fc10]

	Modernize orcus_gnumeric interface a bit.


2021-10-07  Kohei Yoshida  <kohei.yoshida@gmail.com>  [440924bbb22e6570e2c6cfe73c997702cf0eb4b0]

	yaml::document_tree::load() to take std::string_view.


2021-10-07  Kohei Yoshida  <kohei.yoshida@gmail.com>  [87b6a531a4c63917c310e8d7f7916d871325f70b]

	xml_structure_tree::parse() to take std::string_view.


2021-10-06  Kohei Yoshida  <kohei.yoshida@gmail.com>  [d7d6dad1d555f1482e9d2148cb52c5399fd0c595]

	Clean up orcus_csv public interfaces.


2021-10-06  Kohei Yoshida  <kohei.yoshida@gmail.com>  [b7ee2361d75ff2f2c21b9dfba720d3791d67a757]

	const char* to std::string_view in orcus_xml public interfaces.


2021-10-06  Kohei Yoshida  <kohei.yoshida@gmail.com>  [cfd3b3977a225833e175a134bde0cf53e9e4f327]

	Clean up to_double() and to_long() functions.


2021-10-06  Kohei Yoshida  <kohei.yoshida@gmail.com>  [09694ac4a3942082ad7672a371477f55e38f6f0b]

	const char* to std::string_view in pivot cache related interfaces.


2021-10-05  Kohei Yoshida  <kohei.yoshida@gmail.com>  [a110e4ddf6f351e9b618cdf49318330229302776]

	std::string_view in import_factory.


2021-10-05  Kohei Yoshida  <kohei.yoshida@gmail.com>  [95f5ecadf39e4000bdce16a8ad821d3580682d08]

	std::string_view in import_reference_resolver.


2021-10-05  Kohei Yoshida  <kohei.yoshida@gmail.com>  [5ecbd244cb7748d072475235d1a14060f0ea04dd]

	std::string_view in import_formula and import_array_formula.


2021-10-05  Kohei Yoshida  <kohei.yoshida@gmail.com>  [3e7f822096a224f0678227528710f5418903de8c]

	std::string_view in import_table.


2021-10-05  Kohei Yoshida  <kohei.yoshida@gmail.com>  [3ce9753754f82544099573c0cff21703401bc3a0]

	std::string_view in import_conditional_format.


2021-10-05  Kohei Yoshida  <kohei.yoshida@gmail.com>  [18fd94351da32e9a92cca0ec008ce08f088fe4b6]

	std::string_view in import_auto_filter.


2021-10-05  Kohei Yoshida  <kohei.yoshida@gmail.com>  [5e6d061d4648addb046988d04b0b6225925927dc]

	std::string_view in import_data_table.


2021-10-05  Kohei Yoshida  <kohei.yoshida@gmail.com>  [1e5d163240120956441885d70d805c0d50a87010]

	std::string_view in import_named_expression.


2021-10-04  Kohei Yoshida  <kohei.yoshida@gmail.com>  [935ecdd79004fad3a37be02062446131b65d7bb4]

	import_styles interface to all use std::string_view.


2021-10-04  Kohei Yoshida  <kohei.yoshida@gmail.com>  [8d2a4c23579a79993032d8e92e59f54a652a1429]

	set_auto() to take std::string_view.


2021-10-04  Kohei Yoshida  <kohei.yoshida@gmail.com>  [1402bb2778c0a0261bd4c6aca03af643270ccf88]

	More on replacing const char* to std::string_view.


2021-10-01  Kohei Yoshida  <kohei.yoshida@gmail.com>  [76a5cab6165c5671ee898653761f3993a5a2ed52]

	const char* -> std::string_view in import_shared_strings.


2021-10-01  Kohei Yoshida  <kohei.yoshida@gmail.com>  [b9e191c2cbd181874b59d92419e6b32eb4019380]

	const char* -> std::string_view in spreadsheet/types.hpp


2021-10-01  Kohei Yoshida  <kohei.yoshida@gmail.com>  [b8f5295e2e1ec7891dbb9ec8c7086cd5c0da1fee]

	Remove variant of string_pool::intern() that takes const char*.


2021-10-01  Kohei Yoshida  <kohei.yoshida@gmail.com>  [5f2add13301828fe71d15f88b9fcfa486ddee5d0]

	to_dump_format_enum() to take string_view.


2021-10-01  Kohei Yoshida  <kohei.yoshida@gmail.com>  [e65c9049cddadc81935ef976a3521e2f9744bb64]

	export_factory::get_sheet() to take std::string_view.


2021-10-01  Kohei Yoshida  <kohei.yoshida@gmail.com>  [ec5d6089fd21e0bde1fd9b9b191dd8b17773b9cb]

	import_filter::get_name() to return std::string_view.


2021-09-30  Kohei Yoshida  <kohei.yoshida@gmail.com>  [fa89b49601118f861d549c68f285d82563fc3ab5]

	read_stream() to take std::string_view.


2021-09-30  Kohei Yoshida  <kohei.yoshida@gmail.com>  [f90e11fc0bc60ed678e69fe73febdb6f125a605a]

	css::to_property_function() to take std::string_view.


2021-09-30  Kohei Yoshida  <kohei.yoshida@gmail.com>  [a1b4e10d37d38f226f133b780380a7343b75c897]

	css_document_tree::load() to take std::string_view.


2021-09-30  Kohei Yoshida  <kohei.yoshida@gmail.com>  [849eb511d8a465ffb47ba95adabba7c6037eaa93]

	Revise base64 API for modern C++.


2021-09-29  Kohei Yoshida  <kohei.yoshida@gmail.com>  [a15b69876ece2ed27ac15c595efb364c8ecefd5a]

	This can be const ref.


2021-09-29  Kohei Yoshida  <kohei.yoshida@gmail.com>  [b12549df863200a2ef744ed276c50f22bdc05c8a]

	Use ranged for loop in lieu of std::for_each.


2021-09-29  Kohei Yoshida  <kohei.yoshida@gmail.com>  [17937696ba483e8137dd9fc685c055c927ba9f96]

	Remove union from config and replace it with std::variant.

	This is the last union keyword in the public headers.

2021-09-29  Kohei Yoshida  <kohei.yoshida@gmail.com>  [9ce833e58cb8f76f862b5d47099637ddbc761a7e]

	Replace union with std::variant in css_selector.hpp.


2021-09-29  Kohei Yoshida  <kohei.yoshida@gmail.com>  [3c99831d84050adeb65f5a9aa5eb201b1f8fa85c]

	Replace union with std::variant in sax_token_parser_thread.hpp.


2021-09-29  Kohei Yoshida  <kohei.yoshida@gmail.com>  [911024d78e39aacf406fde7aecb75052cb8222d1]

	Fix the normal 'make' build. 'make check' worked fine.


2021-09-29  Kohei Yoshida  <kohei.yoshida@gmail.com>  [bf96563697ec404407354e51a74e9ea66a64cef1]

	Replace union with std::variant in parse_token type.


2021-09-29  Kohei Yoshida  <kohei.yoshida@gmail.com>  [7aa37823da7464676a9a616614bf8f1a6feb21f9]

	Replace union with std::variant in pivot.hpp.


2021-09-28  Kohei Yoshida  <kohei.yoshida@gmail.com>  [7a1fcf7d70b16fc61054d61d5c06dfb29f271bce]

	Move pstring.hpp header into a "private" location to hide it.


2021-09-28  Kohei Yoshida  <kohei.yoshida@gmail.com>  [a226511eaa6692e807f2cfa1a5262f1ca9e5a682]

	Remove pstring from document.hpp.

	I believe this is the last public header with pstring.

2021-09-28  Kohei Yoshida  <kohei.yoshida@gmail.com>  [283bc8183a2c7ed7bc986c04d7ffa25396187874]

	Remove pstring from shared_strings.hpp.


2021-09-28  Kohei Yoshida  <kohei.yoshida@gmail.com>  [7c9735f905ccff99161f6ab717662e3d43cb5500]

	Remove pstring from pivot.hpp.


2021-09-28  Kohei Yoshida  <kohei.yoshida@gmail.com>  [7cb8c3ccb37f2681b7f9c1127b7ed64f8f77c444]

	Remove pstring from sheet.hpp.


2021-09-28  Kohei Yoshida  <kohei.yoshida@gmail.com>  [d370f7f3bfc9136c375b62b531718f3bd5b10922]

	Remove pstring from styles.hpp.


2021-09-28  Kohei Yoshida  <kohei.yoshida@gmail.com>  [71d1a54eefa2ad4de075f89434311c777bab1610]

	Remove pstring from auto_filter.hpp.


2021-09-28  Kohei Yoshida  <kohei.yoshida@gmail.com>  [6f6eb66631250ebbc3c513b65355a134ba182a94]

	Remove pstring from the rest of the sax_parser header files.


2021-09-28  Kohei Yoshida  <kohei.yoshida@gmail.com>  [549ad4578712b046bbcbcd9e97ffbf95235f2a55]

	Remove pstring from sax_ns_parser.hpp.


2021-09-28  Kohei Yoshida  <kohei.yoshida@gmail.com>  [9d8e89ca2f9163c18d20034ae56f3654fe53a7c9]

	Remove pstring from sax_parser_base.hpp and sax_parser.hpp.


2021-09-28  Kohei Yoshida  <kohei.yoshida@gmail.com>  [6ce754fd138b5f9ce4b096cbde5c493b97f6449b]

	Remove pstring from orcus_json.hpp and orcus_xml.hpp.


2021-09-27  Kohei Yoshida  <kohei.yoshida@gmail.com>  [1a8356b503a3baa849263705ec1da0d462d6425a]

	Remove pstring from xml_namespace.*.


2021-09-27  Kohei Yoshida  <kohei.yoshida@gmail.com>  [e6fd7523271ad5df658b33831f6639691eeca376]

	Remove pstring from xml_structure_tree.hpp.


2021-09-27  Kohei Yoshida  <kohei.yoshida@gmail.com>  [12de6277cd582527073e0b48b1aa37e72acf1172]

	Remove pstring from types.hpp, and fix an avalanche of compilation issues.


2021-09-27  Kohei Yoshida  <kohei.yoshida@gmail.com>  [d6246f2731d7021c6f7140b6a95d0f0e4dbc886f]

	Remove pstring from tokens.hpp.


2021-09-25  Kohei Yoshida  <kohei.yoshida@gmail.com>  [a3bf970fed8375e30b748b5318cc3ba2b6f46b84]

	Fix the benchmark code build.


2021-09-25  Kohei Yoshida  <kohei.yoshida@gmail.com>  [2014c90a827b6a49f185815cd8c2165f01183d2f]

	pstring to std::string_view in stream.*.


2021-09-25  Kohei Yoshida  <kohei.yoshida@gmail.com>  [121f305f151cf7de01254e1aa281a01889cedff1]

	Replace pstring with std::string_view in the yaml parser code.


2021-09-25  Kohei Yoshida  <kohei.yoshida@gmail.com>  [52f2e13cf005cfc41b7cfd2ca36e6528af9cf743]

	Fix build on linux.


2021-09-25  Kohei Yoshida  <kohei.yoshida@gmail.com>  [5509c51a0950a2e705a2c2aa419868302c1f26f9]

	Some header include cleaning.


2021-09-25  Kohei Yoshida  <kohei.yoshida@gmail.com>  [774581ccb94b2be5f59e9847c96aabb7a66c8ac2]

	Fix assertions.


2021-09-25  Kohei Yoshida  <kohei.yoshida@gmail.com>  [792fcff84e106cccaa739183e41e044bde576013]

	Remove pstring from measurement.*, and fix one test failure vs string_pool.


2021-09-25  Kohei Yoshida  <kohei.yoshida@gmail.com>  [cc469682e3534644d08615d3b877a06a36436292]

	The intern(const char* str) variant is not needed.

	const char* can decay to std::string_view.

2021-09-25  Kohei Yoshida  <kohei.yoshida@gmail.com>  [134be911681fb2f725b4fe61cd92ec1c57fb193d]

	Remove pstring from string_pool.*.


2021-09-25  Kohei Yoshida  <kohei.yoshida@gmail.com>  [3292dd91152ed05465946d8eac66813586752f53]

	Remove pstring from json_document_tree.*.


2021-09-25  Kohei Yoshida  <kohei.yoshida@gmail.com>  [c3570e65ad5c0342f7c41f06b509e4c859fd72f0]

	Remove pstring from zip_archive.* & remove 'using namespace std'.


2021-09-25  Kohei Yoshida  <kohei.yoshida@gmail.com>  [2b42d04b1a1a3dff0e53cc5fa5530571f16f7953]

	Remove cmake warning.

	Here is the exact output of the warning:

	CMake Warning (dev) at C:/Program Files/CMake/share/cmake-3.21/Modules/FindPackageHandleStandardArgs.cmake:438 (message):
	  The package name passed to `find_package_handle_standard_args` (ZLIB) does
	  not match the name of the calling package (Zlib).  This can lead to
	  problems in calling code that expects `find_package` result variables
	  (e.g., `_FOUND`) to follow a certain pattern.

2021-09-24  Kohei Yoshida  <kohei.yoshida@gmail.com>  [fcbd0662c1d327bcaf8c37a2d791bc643e3fd351]

	Remove string_view from global.hpp.


2021-09-24  Kohei Yoshida  <kohei.yoshida@gmail.com>  [7fb3d5a9f41151927c494b7d90f9b4d82bfada31]

	Remove pstring from dom_tree.hpp.


2021-09-24  Kohei Yoshida  <kohei.yoshida@gmail.com>  [f53fc08354460ecac2dab02ffb8f1bf44f6a7bcd]

	Replace pstring with std::string_view in css_selector.hpp.


2021-09-24  Kohei Yoshida  <kohei.yoshida@gmail.com>  [2c354577a9db254c8f3a0c1e887c89de28b0481e]

	Use std::string_view in functions in css_types.hpp.


2021-09-23  Kohei Yoshida  <kohei.yoshida@gmail.com>  [402be06d1ec3d7e86590eda34af17444b5c9c33e]

	Adjust to API changes in ixion.


2021-09-09  Kohei Yoshida  <kohei.yoshida@gmail.com>  [81603a5a904cbbb58109876f31852db680edf36a]

	Use 32-bit unsigned integer as string ID's as opposed to size_t.

	This reflects the recent similar change in ixion.

2021-08-28  Kohei Yoshida  <kohei.yoshida@gmail.com>  [171731d01b9cb04a5594d8b9a5f00fc4bbef99b4]

	Query _M_IX86_FP preprocessor macro from MSVC.


2021-08-14  Kohei Yoshida  <kohei.yoshida@gmail.com>  [50439b35284c02223007ecc57b0ca92845982135]

	Remove doxygen warnings.


2021-08-14  Kohei Yoshida  <kohei.yoshida@gmail.com>  [5789bfbd386d2c68a05c1810cfc68eca909a94b1]

	Silence warning about deprecated <codecvt>.

	According to

	https://stackoverflow.com/questions/42946335/deprecated-header-codecvt-replacement

	There is currently no alternatives to this deprecated functionality.

2021-08-14  Kohei Yoshida  <kohei.yoshida@gmail.com>  [de4a36fbcae53348448c0edcccbfc4da1e949314]

	We no longer need this workaround for MSVC as of VS 2019.


2021-08-13  Kohei Yoshida  <kohei.yoshida@gmail.com>  [613072affe9a9fabda8a06111470dec969be06e7]

	Add sphinx-argparse as a requirement in conda.


2021-08-13  Kohei Yoshida  <kohei.yoshida@gmail.com>  [281b8235a69601d94d3620f7bcbfc364470e40a0]

	Update the doc build settings for readthedocs.io.


2021-08-12  Kohei Yoshida  <kohei.yoshida@gmail.com>  [1811332d3859d2b317292bbaff2dfed3cf3fcd54]

	Fix the 'check' target with cmake build.


2021-05-13  Kohei Yoshida  <kohei.yoshida@gmail.com>  [b2abd2359fd054de60ada09e04a3b0a0eace810f]

	Add #137.


2021-05-13  Kohei Yoshida  <kohei.yoshida@gmail.com>  [9a0da92c9fb9d910f2024b3d3aa312d8be783f4e]

	Add negative test cases, and fix one byte mis-handling.


2021-05-13  Kohei Yoshida  <kohei.yoshida@gmail.com>  [9cd8c3419e45798b1e2c272c17a595fe68fb2a7e]

	I don't need this note.


2021-05-13  Kohei Yoshida  <kohei.yoshida@gmail.com>  [d376c74042c232bfe7d67f1e009b36f9c6358745]

	Fix CI build.


2021-05-13  Kohei Yoshida  <kohei.yoshida@gmail.com>  [e9ca232de45e992fd4c8b3a37299647948fe188d]

	Re-structure the utf-8 parsing code for better clarity.

	Also fix the remaining byte check as well as two failing ranges.

2021-05-10  Kohei Yoshida  <kohei.yoshida@gmail.com>  [8735a55dbfe3f55919677db5eb5a0a98dc3e2cfe]

	Add a function to encode code points to utf-8, and use it in tests.

	Two code-point ranges still fail.

2021-05-10  Kohei Yoshida  <kohei.yoshida@gmail.com>  [1067b1451b57b13dca0bb6c6138104247745432a]

	Add positive tests for 3-byte ranges.

	But I now realize that this approach is flawed.

2021-05-08  Kohei Yoshida  <kohei.yoshida@gmail.com>  [96db3c5f8f5d32655b49690db056028ca55be9d0]

	Let's use a regular array.


2021-05-08  Kohei Yoshida  <kohei.yoshida@gmail.com>  [20df6bc9c5b2c06a1550d848114de4f493ea0e3c]

	Add positive tests for 2-char ranges.


2021-05-07  Kohei Yoshida  <kohei.yoshida@gmail.com>  [1d4092972d6f30b06da2a64f8c5f4f3c2534a79f]

	Clean up a bit.


2021-05-07  Kohei Yoshida  <kohei.yoshida@gmail.com>  [4e3af4f6e2e75c046d5d607c3281ee5c576c9cb1]

	Move the utf8 parsing helper code into separate sources...

	... and set up a test harness for it.

2021-05-04  Luboš Luňák  <l.lunak@centrum.cz>  [2c2215e94bd8fce4b9a93e986339aa6ae06d2cba]

	allow utf-8 in xml names (#137)

	https://www.w3.org/TR/2006/REC-xml11-20060816/#NT-NameStartChar
	has a list of all allowed characters.

2021-05-04  Kohei Yoshida  <kohei.yoshida@gmail.com>  [3e1f42aa1ad4c4bb53cb87a94e791da874bd33a4]

	Use gfortran-9.


2021-05-02  David Tardon  <dtardon@redhat.com>  [34f93cdc383432aeb34c31184de8a2fb5940e0c7]

	make FormatType conversion work with python 3.10

	The str() function for Enum returns only the member name since 3.10:
	https://docs.python.org/3.10/whatsnew/3.10.html#enum
	Let's just check separately the enum type name and the member name.

2021-05-02  David Tardon  <dtardon@redhat.com>  [87c29eaa90f1aaf769f0f1d1baee5a91e4e83596]

	replace hand-written search by STL algorithm


2021-05-02  David Tardon  <dtardon@redhat.com>  [022612302c5bc302e14570424dfa7602d3dada39]

	impl. operator+ in terms of operator+=


2021-05-02  David Tardon  <dtardon@redhat.com>  [3ea647aa76a8e9699ba6d8733137dc4059b41220]

	use std::string::append


2021-05-02  David Tardon  <dtardon@redhat.com>  [68fb35a4bac3d760a0a74ea7c61735f8c13ee0dc]

	use std::lexicographical_compare to impl. operator<

	The algorithm exists for this very purpose.

2021-05-02  David Tardon  <dtardon@redhat.com>  [a09bb35b3195c2a0cdf5e5d4b699513e0c72026e]

	replace hand-written string comparison by std::equal


2021-05-02  David Tardon  <dtardon@redhat.com>  [eda22698961fd1c5325ae0a5ec098a4d9907db02]

	replace a string literal by a constant

	This fixes test_module.py test with debug build with gcc 11. It "works"
	with optimized builds because the compiler apparently deduplicates the
	string literals...

2021-05-01  David Tardon  <dtardon@redhat.com>  [ba3d345fda0bf3f25b25b2d3723e93e49682c59d]

	catch exception by reference


2021-02-09  Kohei Yoshida  <kohei.yoshida@gmail.com>  [9c63f274506d70bdf92334670071756ebea4042a]

	Add assignment operators and swap method to xmlns_context.

	Also write test cases for them.

2021-02-09  Kohei Yoshida  <kohei.yoshida@gmail.com>  [0795a085f0181d8ea5d6e73ab43442a64e3e7402]

	Fix shadowed declaration of 'repo'.


2021-02-09  Kohei Yoshida  <kohei.yoshida@gmail.com>  [b62b4eb179f4d415eb8bcbd4d43f78442e11f926]

	Make xmlns_context moveable & add a default constructor to it.

	This fixes a build error with VS 2017.

2021-02-08  Kohei Yoshida  <kohei.yoshida@gmail.com>  [49764a9dc4b3cd03ff5bce149a7d3858972e0e0b]

	Let's not move the loaded_tree instances...

	I don't think xmlns_context is movable in its current state. Let's
	make that explicit.

2021-02-08  Kohei Yoshida  <kohei.yoshida@gmail.com>  [563a86575d452f5c1331366fdd2ec797b5e624c0]

	Prefix string literals with u8 to ensure they get parsed as utf-8.

	Otherwise the literals use the implementation's character set, which
	in my Windows environment appears to be Windows-1252.

2021-02-08  Kohei Yoshida  <kohei.yoshida@gmail.com>  [14a6c973c0d477ab4706084527d6de9d6c52b340]

	get_short_name(...) returns std::string. Let's not receive it with pstring

	Doing so apparently caused string buffer corruption which for some reason
	only manifested itself in the debug build with MSVC.

	This fixes #136.

2021-02-06  Kohei Yoshida  <kohei.yoshida@gmail.com>  [3713d0f8a522ae32a4a8d56a6a838407ed544dec]

	Update the CHANGELOG about the crasher fix.


2021-02-06  Kohei Yoshida  <kohei.yoshida@gmail.com>  [292b090ae2df166d1ab3275c91fd99e710091951]

	Ensure that the output stream object gets moved when the cmd_params...

	... object moves.

2021-02-05  Kohei Yoshida  <kohei.yoshida@gmail.com>  [c028c815d5b24990eee996dc85df04df35db93e6]

	Fix CMake build with VS 2017.


2021-01-10  Kohei Yoshida  <kohei.yoshida@gmail.com>  [3364eb5553960046d2aeebb7794084b60b3f1e42]

	Draw table borders in light gray color.


2021-01-10  Kohei Yoshida  <kohei.yoshida@gmail.com>  [1d8c62c8a028bc9c7db385b18802e84d12786123]

	Fix the rendering of neighboring merged cells (#133)


2021-01-10  Kohei Yoshida  <kohei.yoshida@gmail.com>  [25413a7250c9fad9a856a61e3d767c9de778f14c]

	Fix the test cases that had been broken by the addition of ...

	... the merged cell info in the check.txt files.

2021-01-10  Kohei Yoshida  <kohei.yoshida@gmail.com>  [f344546b71e8d8c6666c47dd4bf5b686c38ac37f]

	Include merged cell information when dumping the doc in check mode.

	This temporarily breaks some test cases due to extra information
	generated.

2021-01-10  Kohei Yoshida  <kohei.yoshida@gmail.com>  [dd9ab0d73f07daf01e580b1f11fb4c712114d0bc]

	Move the dumper code for 'check' format out into its own files.

	Als move the sheet_impl code into a separate set of files to allow
	access to it from check_dumper (and potentially other dumper classes
	in the future).

2021-01-09  Kohei Yoshida  <kohei.yoshida@gmail.com>  [3d2ab5fb76c1ce7aaa9d6cf957f6075cea6b1f6b]

	Use range-based for loop over std::for_each.


2021-01-08  hedmo  <hedmoo@yahoo.com>  [5e8fb255dc6bc9b7084a05b8dc24f31417542e5e]

	Update xlsx_revision_context.cpp to build with gcc-11


2021-01-08  hedmo  <hedmoo@yahoo.com>  [3bfa1a000e4639fe68781c584356ceea7c6b1a72]

	Update xls_xml_context.cpp to build with gcc-11


2021-01-08  hedmo  <hedmoo@yahoo.com>  [50506d534230d90de2b0a2af3fb072428c942a4e]

	Update orcus_xlsx.cpp to build with gcc-11


2021-01-08  Kohei Yoshida  <kohei.yoshida@gmail.com>  [2af5e916889896676f3cfda10e0f905f4dc8adc5]

	Insert a blank line to prevent the line above from being bolded ...

	... when converted to rst.

2021-01-08  Kohei Yoshida  <kohei.yoshida@gmail.com>  [83138a49e98aa26ea2b612661f66b7b40ee00c01]

	Write a script to parse and convert program-options' help output ...

	... to rst format, and update the CLI docs.

2021-01-08  Kohei Yoshida  <kohei.yoshida@gmail.com>  [2177a5d4a7f16b44a71b18238fc4c25658e576ec]

	Add bits about how the features are exposed.


2021-01-08  Kohei Yoshida  <kohei.yoshida@gmail.com>  [8bd4c97bb9de15abe555c12a33d5478dc21f957d]

	Rework the wording of the overview section a bit.


2021-01-07  Kohei Yoshida  <kohei.yoshida@gmail.com>  [484ae086201eaefc95ac82c4a8a198596301613d]

	Add a new test case for handling formulas with string results.

	Cover both recalc and non-recalc scenarios. (#134)

2021-01-07  Kohei Yoshida  <kohei.yoshida@gmail.com>  [3f6af4b3db3435ce9baf72dd0a3bec13d8caf24a]

	Handle cached string formula results properly.

	This change also changes the interface related to setting cached
	string formula values.  This reflects the recent change in ixion to
	store the string buffers directly with the formulas.

	This is related to #134.

2021-01-06  Kohei Yoshida  <kohei.yoshida@gmail.com>  [081f6b0862d71753e839bd5cad9e2ecdaae98c72]

	Pick up and store cached formula results for array formulas.

	Numeric and boolean values only for now.  Boolean values are not yet
	tested.  Related to #134.

2021-01-06  Kohei Yoshida  <kohei.yoshida@gmail.com>  [d37539c2edc07316b8a1e99aff71238d3df7e12b]

	Add a test input file containing formula cells with string results.


2021-01-06  Kohei Yoshida  <kohei.yoshida@gmail.com>  [697cf113cd11fd2d89cb397f6b334380957794ee]

	Add a test case for loading cached results for numeric shared formulas.


2021-01-06  Kohei Yoshida  <kohei.yoshida@gmail.com>  [574f35eea7a6744814377079fb5c3db45c0cf26a]

	Pick up and store numeric formula results for shared formulas.

	Also related to #134.

2020-12-19  Kohei Yoshida  <kohei.yoshida@gmail.com>  [2ccb6c3d9e21bec02fd4589e4f8f07bd1d4ab51b]

	Add a test case for xlsx loading with no recalculation on load.


2020-12-19  Kohei Yoshida  <kohei.yoshida@gmail.com>  [7a56b9ec3f3add03040157d8735e7f80966ff830]

	Pick up and store numeric formula results for non-shared formulas.

	Related to #134.

2020-12-19  Kohei Yoshida  <kohei.yoshida@gmail.com>  [d17b3990834039bf946b1631428f5db9649eb48d]

	Add test case for unprefixed attribute NOT belonging to default ...

	... namespace like unprefixed elements would. For more info, see

	https://stackoverflow.com/questions/3312390/xml-default-namespaces-for-unqualified-attribute-names

2020-12-19  Kohei Yoshida  <kohei.yoshida@gmail.com>  [5808158d908d77ccd5ae609455ed140092f273dd]

	Use address resolver to resolve cell addresses.


2020-12-19  Kohei Yoshida  <kohei.yoshida@gmail.com>  [7c248da75dca856c1e38bbff07f51fddcca5d1e2]

	Remove cell_attr_parser in favor of ranged for loop.


2020-12-19  Kohei Yoshida  <kohei.yoshida@gmail.com>  [b14610aa5a7157c87c90cae5b08e28f4c5a62c3f]

	Move the cell element start code into its own method.


2020-10-27  Kohei Yoshida  <kohei.yoshida@gmail.com>  [34865af2e65021dbc6f0b2f871f1adb3f6a4b592]

	Talk about mapping with map file.

	This concludes this tutorial.

2020-10-27  Kohei Yoshida  <kohei.yoshida@gmail.com>  [c0174a842380185a607443663172f4ebc9886b0f]

	Don't forget to set the row-header param to true.


2020-10-27  Kohei Yoshida  <kohei.yoshida@gmail.com>  [ddb1d069f06bdf3a2ee067e730f3d6606795bacf]

	Let's not print the detected mapping rules.


2020-10-27  Kohei Yoshida  <kohei.yoshida@gmail.com>  [fcd740e9b5578c760467848d31b7013e0b0bca77]

	Talk about json auto-mapping.


2020-10-27  Kohei Yoshida  <kohei.yoshida@gmail.com>  [a34ed48e63eab4ae1eca75fe6164c8ed99b1178d]

	Add more files to ignore.


2020-10-27  Kohei Yoshida  <kohei.yoshida@gmail.com>  [f4d83cfeb91b5f088bd872f7d84528cbbbaad105]

	Create a new page for JSON mapping, and talk about analyzing ...

	... the structure of JSON document.

2020-10-21  Kohei Yoshida  <kohei.yoshida@gmail.com>  [3be6b814a44067ff7321ac0dc2ccfae08fa1fbd2]

	Go over the map file structure and run the command again.


2020-10-21  Kohei Yoshida  <kohei.yoshida@gmail.com>  [de136ea8e1181985b3572b6f2e9833329a6ad8ca]

	Talk about map file generation.


2020-10-21  Kohei Yoshida  <kohei.yoshida@gmail.com>  [7ce2045c83fe1546feda6cfbd057975b1853221c]

	Use a more specific xmlns value for xml map files.


2020-10-21  Kohei Yoshida  <kohei.yoshida@gmail.com>  [6341f2a3019488b7af5f08f2856cc0de6d7014ec]

	Also make sure the map file exists if it's specified.


2020-10-21  Kohei Yoshida  <kohei.yoshida@gmail.com>  [b5d4387808201cccc015de54b26573c293927165]

	Make sure not to let exception leak when the input file is not there.


2020-10-20  Kohei Yoshida  <kohei.yoshida@gmail.com>  [59f182c5426c43f5e9c5799462b1eaa186e8dae7]

	Add auto-mapping section.


2020-10-20  Kohei Yoshida  <kohei.yoshida@gmail.com>  [c5d6f71763f8a7bdfc770c175f0f5a2a04de6b42]

	Cover orcus-xml's structure mode.


2020-10-19  Kohei Yoshida  <kohei.yoshida@gmail.com>  [ce8ec901b18b0d321fb334e54aafb62ff78251af]

	Create a new section for XML mapping tutorial, with sample XML.


2020-10-02  Kohei Yoshida  <kohei.yoshida@gmail.com>  [9bf763219f1f562bdca4700a952913d74f013e8b]

	Add the new op member for orcus.FormulaToken to the doc.


2020-10-01  Kohei Yoshida  <kohei.yoshida@gmail.com>  [63dfd2db910bf867b9d633aa3d61c43c5a1e8be9]

	Add another test case (#127)


2020-10-01  Kohei Yoshida  <kohei.yoshida@gmail.com>  [8435a3fa57f6a1d1f8826d496155d3f9d94a4726]

	Use pathlib instead of os.path & remove unused module imports.


2020-10-01  Kohei Yoshida  <kohei.yoshida@gmail.com>  [f70123b5e61d5050e0b41a536cae888ba1ed52f1]

	Add op member to orcus FormulaToken (#127)


2020-09-30  Kohei Yoshida  <kohei.yoshida@gmail.com>  [20bb0a704af470d53447fa6d3965a0a0642709d6]

	Set the new mdds API version requirement to 2.0.


2020-09-30  Kohei Yoshida  <kohei.yoshida@gmail.com>  [1579c12111074a50f2307b8fa749a68749af11ba]

	Set the new C++ baseline in cmake too. (#125)


2020-09-30  Kohei Yoshida  <kohei.yoshida@gmail.com>  [25a27fb94468f1fe06376a4ef18adf78ccc6b102]

	Replace all instances of orcus::make_unique with the one from ...

	... the std namespace.

2020-09-30  Kohei Yoshida  <kohei.yoshida@gmail.com>  [224583c4b055436e9548d7008505f2445bafbbe4]

	Raise the baseline to C++17. This is related to #125.


2020-09-29  Kohei Yoshida  <kohei.yoshida@gmail.com>  [fb5cd0c4bbcb7dc9bc49026f85ba90f56942dc05]

	Fix the gitlab-ci build.


2020-09-29  Kohei Yoshida  <kohei.yoshida@gmail.com>  [e97af620c7760f343e6749167ec1addb80ea1cfd]

	Make sure it builds against ixion-0.17.

	ixion-0.17 no longer has get_column(s) methods in model_context.

2020-09-29  Kohei Yoshida  <kohei.yoshida@gmail.com>  [f57b919553529f8ad976cc91395573e96ea2738d]

	Re-implement csv_dumper and json_dumper.

	The new implementation uses  ixion::model_iterator.

2020-09-29  Kohei Yoshida  <kohei.yoshida@gmail.com>  [3067613510c92da123270cd0ebfb32c30bab2ecc]

	Avoid using ixion::model_context::get_columns().

	This also simplifies the code quite a bit.

2020-09-28  Kohei Yoshida  <kohei.yoshida@gmail.com>  [d9407df13c2f0428bc8767a851647376e15f77ba]

	The sheet_range class is no longer used. Remove it.

	With this change, we need to increment the API version to 0.17.

2020-09-28  Kohei Yoshida  <kohei.yoshida@gmail.com>  [b98e2b922f7105d3476c034699d8e4adbae652ae]

	Re-implement orcus.SheetRows using ixion::model_iterator.


2020-09-26  Kohei Yoshida  <kohei.yoshida@gmail.com>  [6273dd57f1cbdf5000f1f439aac63e0add4b4f7f]

	Update CHANGELOG.


2020-09-26  Kohei Yoshida  <kohei.yoshida@gmail.com>  [99778a54c765e271805bb33134591936f8e87586]

	Set the version number to 0.16.1.


2020-09-24  Kohei Yoshida  <kohei.yoshida@gmail.com>  [0eb2e3f7e81275a14958fa3cab900501c37c404c]

	Check the size of void* and pass it as a compiler define.

	This is needed in order to link against libixion.  Related to #129.

2020-09-24  Kohei Yoshida  <kohei.yoshida@gmail.com>  [2f3fa91679b449d3079152fb847c71350815df49]

	Don't forget to initialize this struct member.

	This ended up becoming "true" on a 32-bit debian platform, though
	this is not strictly a 32-bit build issue...

	Related to #129.

2020-09-18  Kohei Yoshida  <kohei.yoshida@gmail.com>  [535ebd34724d8a8db5f0fe60bc9c0b1cdd83495f]

	This file is no longer there.


2020-09-11  Kohei Yoshida  <kohei.yoshida@gmail.com>  [6d34c41b661a9e8dddf6d08bf1f3c1fd4f5581da]

	Mark all untentionally unused variables.


2020-09-10  Kohei Yoshida  <kohei.yoshida@gmail.com>  [cd92973452a9e2f2e65cde70949d93de967d3a55]

	Tweak the wording to make it flow better.


2020-09-09  Kohei Yoshida  <kohei.yoshida@gmail.com>  [aff45bbb1ba44774cc9fc44214bf1e139ffcd725]

	Add some clarification as to why we have two different methods ...

	... for defining named expressions.

2020-09-03  Kohei Yoshida  <kohei.yoshida@gmail.com>  [c64e545d33125da374c9ee5e96f1c637eb7f036a]

	There is only one orcus.detect_format function.


2020-09-03  Kohei Yoshida  <kohei.yoshida@gmail.com>  [34cb20bd1c6a0900f7f4309f2531df1509ac50b4]

	Fix typos.


2020-09-03  Kohei Yoshida  <kohei.yoshida@gmail.com>  [bfa21be05172020e19d4cf19fb39e29beb93b65e]

	Add script to generate release note template.


2020-09-03  Kohei Yoshida  <kohei.yoshida@gmail.com>  [f871fd06ee7791ba8435b8038e411e3e4e80f683]

	Update CHANGELOG for the 0.16.0 items.


2020-09-03  Kohei Yoshida  <kohei.yoshida@gmail.com>  [913d0eab2e70214d3cd07dda1a92119d9187abe0]

	Up the version to 0.16.0.


2020-09-03  Kohei Yoshida  <kohei.yoshida@gmail.com>  [f4cc9124f70ce956aa95e088b1db3b3ffe82f14a]

	Fix make distcheck.


2020-09-02  Kohei Yoshida  <kohei.yoshida@gmail.com>  [1b504009150565d0d5e0e7323468dc5becc7cfae]

	Add dom-tree-test to cmake build.


2020-09-02  Kohei Yoshida  <kohei.yoshida@gmail.com>  [bed6e49587a829a112eaa099158e01660de5d45a]

	A few more test programs to rename, to match their names with ...

	... their corresponding source file names.

2020-09-02  Kohei Yoshida  <kohei.yoshida@gmail.com>  [985e763dc7c66b073374cc3e5b33f0c9e049fa18]

	Rename test programs to match their corresponding source file names.


2020-09-02  Kohei Yoshida  <kohei.yoshida@gmail.com>  [c047be8effdcdbf7de56da077538c3cf9ebdebcf]

	Add new test programs to cmake build.


2020-09-02  Kohei Yoshida  <kohei.yoshida@gmail.com>  [321a4897e4c22e7702351105bb264760599116be]

	Let's depend on the official release of ixion.


2020-09-02  Kohei Yoshida  <kohei.yoshida@gmail.com>  [046565afd1b7d6fb9496ded437a6328d19333dfd]

	Attempt to fix the build after the ixion API change (take 2).

	Also, no need to escape '#' in string literals.

2020-09-02  Kohei Yoshida  <kohei.yoshida@gmail.com>  [4527528e2878233298d49e0077b9942cb8f72387]

	Get it to build again after the ixion interface change.

	Also fix the check target in cmake build.

2020-08-20  Kohei Yoshida  <kohei.yoshida@gmail.com>  [93c2e69e35e218043bfa5ad258f339e03be1b4e2]

	We can enable these negative test cases now.

	The two we can't enable cause memory exhaustion due to too many
	open tokens for arrays and objects.

2020-08-20  Kohei Yoshida  <kohei.yoshida@gmail.com>  [650520b51dddd357d817832eb5a198308e898e79]

	Check for presence of unescaped control character in strings.

	JSON strings do not allow characters whose values are between 0x00
	and 0x1F, according to RFC 7159 Section 7.

2020-08-20  Kohei Yoshida  <kohei.yoshida@gmail.com>  [94cb46c366bd8284d39afd0c678d0ab29fae7aa3]

	Unnecessary break statements.


2020-08-20  Kohei Yoshida  <kohei.yoshida@gmail.com>  [232f571f947ece3c5788f2e8ecf35a67f220ab73]

	Throw an exception on empty input & write some test cases.

	Because this is a public function, we shouldn't be using assert()
	on the input validation. Also, we can remove the max_length == 0
	block since that is now handled as part of the input validation.

2020-08-20  Kohei Yoshida  <kohei.yoshida@gmail.com>  [05b6ba1e72a5f60dbc3ce538a15ac51beb73fd56]

	These can be now enabled.


2020-08-20  Kohei Yoshida  <kohei.yoshida@gmail.com>  [be1ae1c2d9993d756a698a877451a67b722ca318]

	JSON requires at least one digit before the decimal point.

	A number string such as -.123 is invalid in JSON string, but is
	accepted as valid in other places.

2020-08-19  Kohei Yoshida  <kohei.yoshida@gmail.com>  [f0dd87b85973b0e444142af74ce00491c6cb194d]

	We can use has_decimal to track whether we are before or after ...

	... the decimal point.

2020-08-19  Kohei Yoshida  <kohei.yoshida@gmail.com>  [1ea9ba242f7c20cc957e6ea9654fac70410d7e31]

	We can enable 5 more test cases.


2020-08-19  Kohei Yoshida  <kohei.yoshida@gmail.com>  [3b6199f2b422f9b654b5cd789fa04ff68c5e7692]

	We can just use the general trait type. No need to break down ...

	... the individual behavior differences between the generic parser
	and the json parser.

2020-08-19  Kohei Yoshida  <kohei.yoshida@gmail.com>  [124de6acd06fe51e049e68c479a4aa9231217ff1]

	A number in json must have at least one digit after the decimal ...

	... if the number string has a decimal point.

2020-08-19  Kohei Yoshida  <kohei.yoshida@gmail.com>  [7454f2cbe5f23ed65ab4c22d37d5b656aba5c282]

	We can enable this test case now.


2020-08-19  Kohei Yoshida  <kohei.yoshida@gmail.com>  [7ba63c33db8adfd9f1dd12c4f1a3b8dbe202717b]

	Rename variables and add comments for clarity.


2020-08-19  Kohei Yoshida  <kohei.yoshida@gmail.com>  [0c5c0229c49f2038c53e4794190d3ece6146d453]

	Apply JSON's own numeric parser for json::parser_base, and fix ...

	... all necessary bits to get all test cases pass.

2020-08-19  Kohei Yoshida  <kohei.yoshida@gmail.com>  [5227241a915ac1b4571bb9824ed240f4119420e0]

	Turn this into template specializations.


2020-08-18  Kohei Yoshida  <kohei.yoshida@gmail.com>  [ab763629692143a606bac1ae3dc3c0521394b4d8]

	Group parser state into a structure.


2020-08-17  Kohei Yoshida  <kohei.yoshida@gmail.com>  [63a499a724140bb4575255347b9266005859b55b]

	Parse leading zeros as invalid in json.

	For now, it's a regular if statement. I do need to turn this into
	template specialization.

2020-08-17  Kohei Yoshida  <kohei.yoshida@gmail.com>  [5ec6fa12529661d8085c9bc43c9a6f0030743c0f]

	Add a first failing test case for json numeric parsing.

	Not enabled yet.  I need to work on this.

2020-08-17  Kohei Yoshida  <kohei.yoshida@gmail.com>  [31c28e848b4331b5bad06e9c2c066608d7f55ee8]

	Slightly better error output.


2020-08-17  Kohei Yoshida  <kohei.yoshida@gmail.com>  [8bde20b0ec3769578c69a1c51b98e7d9692f938f]

	Annotate the test case categories.


2020-08-17  Kohei Yoshida  <kohei.yoshida@gmail.com>  [e4a443413ea52b3ce5032d1f4e0331c62a4a4437]

	We can use orcus::json_handler for this type of use cases.


2020-08-17  Kohei Yoshida  <kohei.yoshida@gmail.com>  [f1ffce6ec3d04a8c27276af8238750cd0ac0efba]

	Combine test cases from parser_global_test.cpp.


2020-08-17  Kohei Yoshida  <kohei.yoshida@gmail.com>  [92de9902a969f5ae2946e6fe6f3008ab2df80321]

	Remove duplicate code blocks.


2020-08-17  Kohei Yoshida  <kohei.yoshida@gmail.com>  [33aca3a22ecdcaeb446efdbc5917142c0bea1a4b]

	Add rudimentary test framework for numeric_parser class.

	We need to add lots more test cases for this...

2020-08-17  Kohei Yoshida  <kohei.yoshida@gmail.com>  [34fc96a9182d2b304c853399f416d69badf483f6]

	Move the numeric parsing code to a private template class.

	The idea is to make it configurable without sacrificing run-time
	performance.

2020-08-13  Kohei Yoshida  <kohei.yoshida@gmail.com>  [6c7f94c105ad534ed254fa60fe79335aeb12bc9c]

	Add documentation for orcus.detect_format().


2020-08-13  Kohei Yoshida  <kohei.yoshida@gmail.com>  [bf50fb5737d7aab48c085c14c88d019ab230839d]

	Change orcus.detect_format() to *only* take the stream parameter.

	And update the test code to test both passing the bytes and the file
	objects.

2020-08-13  Kohei Yoshida  <kohei.yoshida@gmail.com>  [87bc0ea3a392733780daf1e9622d8c471ea68aee]

	Make it so that if a file path is not given, it starts the ...

	... interpreter in interactive mode.

2020-08-13  Kohei Yoshida  <kohei.yoshida@gmail.com>  [f600410ee6f3c79942a9f70522fa6d30508e11f2]

	Rename the current function to indicate what it currently does.


2020-08-12  Kohei Yoshida  <kohei.yoshida@gmail.com>  [7aa417494e79a5ca4b407f1ff3b263e9690c1bcc]

	Update the doc.


2020-08-12  Kohei Yoshida  <kohei.yoshida@gmail.com>  [c294e3312f7f35afc8317fa7c0501295c1f324c6]

	Actually check the format parameter, and raise an exception if necessary.


2020-08-12  Kohei Yoshida  <kohei.yoshida@gmail.com>  [27ee5f0f4656f64eaaef5d3912a42b4d79522c90]

	When writing sheet content as csv, write it as string, not as bytes.

	Now test_csv_export passes again.

2020-08-12  Kohei Yoshida  <kohei.yoshida@gmail.com>  [e0a260a603b99745035ef71951ba1d11c6f8f40d]

	csv.read() to read from string, not bytes.

	Also, the recalc and error_policy parameters have been dropped.
	The test_csv_export test fails.

2020-08-12  Kohei Yoshida  <kohei.yoshida@gmail.com>  [be498a50d402448ee5e56cc17fa6ee4c1cf0999b]

	Abstract away the file loading part from run_test_dir(), and ...

	... use a different loader type for csv so that it reads from
	string instead of bytes.  This currently fails the test.

	While I'm at it, prevent the code from terminating by checking for
	bytes beforehand.

2020-08-11  Kohei Yoshida  <kohei.yoshida@gmail.com>  [23ac43a84dca30dd274cabb93ccc6478736ac9f9]

	Make sure the version number string is as expected.

	This is also related to #122.

2020-08-11  Kohei Yoshida  <kohei.yoshida@gmail.com>  [a164fb983f805a9e66ba8484c01af86714884d86]

	Add test files to slickedit project.


2020-08-11  Kohei Yoshida  <kohei.yoshida@gmail.com>  [762341282732995a818a3ff89ff2a008deabbead]

	Rename the test files to prefix with test_.


2020-08-11  Kohei Yoshida  <kohei.yoshida@gmail.com>  [2e20c9bd569496af2bde5c145d6796625fee6082]

	Convert tabs to spaces.


2020-08-11  Kohei Yoshida  <kohei.yoshida@gmail.com>  [f3e9da0f1921fe0022e892effe257f661d98155e]

	Add __version__ member to the orcus module.

	This is related to #122.

2020-08-10  Kohei Yoshida  <kohei.yoshida@gmail.com>  [5d4b310059d17f96cf3398b3b1b996d723e2d670]

	I believe the right terminology is packages, not modules.


2020-08-10  Kohei Yoshida  <kohei.yoshida@gmail.com>  [211de8924ebab4ec6b5e2de3cd757bbbb4036c53]

	Add documentation around cells and formula tokens.


2020-08-10  Kohei Yoshida  <kohei.yoshida@gmail.com>  [c75d754294d815cb8669107cedc61d73f24c4c63]

	Don't forget csv.


2020-08-10  Kohei Yoshida  <kohei.yoshida@gmail.com>  [8f55c95255e40041068ac864b83cfeaf2e3616e8]

	Add docs for the loaders for other document types.


2020-08-10  Kohei Yoshida  <kohei.yoshida@gmail.com>  [32154d896ec93bf334c4aa0dfd38b7614414f744]

	Add back the doc for a few classes that got dropped accidentally.

	Also revert back to the sphinx default style. Google style doesn't
	seem to work unless it's used in docstring.

2020-08-10  Kohei Yoshida  <kohei.yoshida@gmail.com>  [c7e424937bf8ec1a83c55b45f36c44c658b8bd5d]

	Update the doc on orcus.xlsx.read().


2020-08-10  Kohei Yoshida  <kohei.yoshida@gmail.com>  [df00c5792076245dc09758a00dde5fea1bd438ad]

	Re-organize the Python API doc based on package paths.


2020-08-08  Kohei Yoshida  <kohei.yoshida@gmail.com>  [1a8fe30e2482a3ad0c51e7b64771d452c1a01b5d]

	Update the doc to reflect the latest API. Still more to cover.


2020-08-08  Kohei Yoshida  <kohei.yoshida@gmail.com>  [bf4488f3cc5a200fafb8a8c02dc6134bfbaf5b52]

	Add more help contents to the bugzilla command.


2020-08-08  Kohei Yoshida  <kohei.yoshida@gmail.com>  [19cf430a302ff220453c059e7c04254ddc357aa2]

	Document the orcus.tools commands using sphinx-argparse extension.


2020-08-08  Kohei Yoshida  <kohei.yoshida@gmail.com>  [8e19aa33505759710b92a57e17dd163c91770793]

	Still trying to get the doc to build on the RTD site.


2020-08-08  Kohei Yoshida  <kohei.yoshida@gmail.com>  [39b8ffff7f3df89e0708bd112d4d4cb17d147105]

	Try to get the doc to build on the RTD site.


2020-08-08  Kohei Yoshida  <kohei.yoshida@gmail.com>  [a378823a106733d8c3cfbe7ffa6fa9335599777b]

	Re-organize the python section to make room for new contents.


2020-08-07  Kohei Yoshida  <kohei.yoshida@gmail.com>  [f5bf4f29fc0154cb2e6b18a9de25704333c15b04]

	Add bugzilla.py to Makefile.am.


2020-08-07  Kohei Yoshida  <kohei.yoshida@gmail.com>  [ba7e4d9a27a493f5187e0d184601a79e803fdea1]

	Make sure the data isn't empty.


2020-08-07  Kohei Yoshida  <kohei.yoshida@gmail.com>  [7034d672e4745a8aaf9bda14384e4ef445dc0864]

	Use fixed width and right-align the index for better visual.


2020-08-07  Kohei Yoshida  <kohei.yoshida@gmail.com>  [689b43001481ff53f9fad7c83447a31728e77bca]

	Handle '/' in query terms when caching to a file.


2020-08-07  Kohei Yoshida  <kohei.yoshida@gmail.com>  [92c277c8ba5fdc0d755cb4e278a84d836b0cca7d]

	Support arbitrary query terms.


2020-08-07  Kohei Yoshida  <kohei.yoshida@gmail.com>  [4e7f4a2832e4c3f44306fe819a091b3a6b3fb77a]

	Wrap all the functions with a class to avoid using globals.


2020-08-06  Kohei Yoshida  <kohei.yoshida@gmail.com>  [e6b6d8e7e93b2e7d75b0def4782681f79e7197c2]

	Parameterize the bugzilla URL and cache directory.


2020-08-06  Kohei Yoshida  <kohei.yoshida@gmail.com>  [d638bac507b3a07fe1641172082a97e6e28c03cc]

	Move the file to its new location.


2020-08-04  Kohei Yoshida  <kohei.yoshida@gmail.com>  [f3cf6924f2fa02c5600e4fb92844481714b42757]

	Add a section for the CSS parser and friends.

	And annotate the CSS related symbols a bit.

2020-08-04  Kohei Yoshida  <kohei.yoshida@gmail.com>  [190765d185395116d4315da94630d09511170212]

	Update the example doc for the low-level json parser in regards ...

	... to the base handler class being made available in the public
	header.

	This is related to #117.

2020-08-03  Kohei Yoshida  <kohei.yoshida@gmail.com>  [2b113efb40f4a3b54eb39f9a91c997f284782c67]

	I don't think we need two variants of append_field_link().


2020-08-03  Kohei Yoshida  <kohei.yoshida@gmail.com>  [6c4d940d81abc3c8fae2392b1dd8c0e3f5c31f05]

	Add another test case that involves attributes.


2020-08-03  Kohei Yoshida  <kohei.yoshida@gmail.com>  [0d6d7950728bda7c7e2582456f416c0990191e81]

	Read the label values from the map file and make use of them.

	And add a test case for it.

2020-08-03  Kohei Yoshida  <kohei.yoshida@gmail.com>  [aa1d6d8ba330eb84bc2043bb3d385fe0faff68e5]

	Add a variant of append_field_link that takes a label value, ...

	... store it in the proper place inside, and use it in lieu of the
	name of the linkable.

2020-08-03  Kohei Yoshida  <kohei.yoshida@gmail.com>  [317f7ca0cea93ae9ab4fcae77e73ba849adc72bb]

	Use xml_name_t and clean things up a bit.


2020-08-03  Kohei Yoshida  <kohei.yoshida@gmail.com>  [c66a4fb59f655bf39cccc6a14f832d5a3260bfc7]

	Use range-for loop.


2020-07-30  Kohei Yoshida  <kohei.yoshida@gmail.com>  [62dd75fc47cfa8fea66e661674055f46320f3792]

	Add another test case.


2020-07-30  Kohei Yoshida  <kohei.yoshida@gmail.com>  [c962218d287d36721d6eb7499336beac4815ed97]

	Add method docs to orcus_xml.


2020-07-30  Kohei Yoshida  <kohei.yoshida@gmail.com>  [e89597502e6e05f96f680e27626b151610e2448e]

	Support default namespace in the map definition file.

	This is related to #90.

2020-07-30  Kohei Yoshida  <kohei.yoshida@gmail.com>  [8959cfd81a1673fb50e007e66361218ef145336b]

	No need for double-nesting of if scopes.


2020-07-30  Kohei Yoshida  <kohei.yoshida@gmail.com>  [40c976e58bd77b9f7a1b119e96d92f9666d99f75]

	I think calling it push_element_scope() is more appropriate.


2020-07-28  Kohei Yoshida  <kohei.yoshida@gmail.com>  [b3e0d09d63bb8125cc8685900c1b8ea9037472c0]

	Sync the version numbers.


2020-07-28  Kohei Yoshida  <kohei.yoshida@gmail.com>  [1d21dc34521a7d600ad7eca3afe6afd87c577ea6]

	Use basic_ostream's write() to write pstring's content.

	This should be more efficient than creating a std::string
	instance (!) and writing that to ostream.

2020-07-28  Kohei Yoshida  <kohei.yoshida@gmail.com>  [89851d2a6e0c0585a49c43c35c37010409571c2b]

	Make xml_writer non-copyable but moveable.


2020-07-28  Kohei Yoshida  <kohei.yoshida@gmail.com>  [779c0903969cc20d7ccee2903f69a9d86040ff98]

	Add documentation for the xml_writer class.


2020-07-28  Kohei Yoshida  <kohei.yoshida@gmail.com>  [6b26ec3237fbc18b935007592adecc67f3193214]

	Properly encode contents when writing them.


2020-07-27  Kohei Yoshida  <kohei.yoshida@gmail.com>  [cb186d5504928173a2e323a77c019692d1b37a14]

	Add a new method to print xml_name_t value as string.


2020-07-27  Kohei Yoshida  <kohei.yoshida@gmail.com>  [a3afc669a7aca92a35019117fee431dd00532362]

	Use xml_name_t for the name in linkable.


2020-07-27  Kohei Yoshida  <kohei.yoshida@gmail.com>  [ea07a06721ee6a66e03139a89ebeb6f1b4e3c83b]

	Indent the exception messages to make them easier to read.


2020-07-27  Kohei Yoshida  <kohei.yoshida@gmail.com>  [23981a4bbb304a11ea1f188c6722366d69b379ae]

	Add a test case to cover invalid linking of non-leaf elements.


2020-07-27  Kohei Yoshida  <kohei.yoshida@gmail.com>  [741314ab68cf1695acfed1e06a22cc6144cfe590]

	Adjust test_invalid_map_definition() to load content from file.

	And introduce a loop to make it easier to add more invalid
	contents.

2020-07-27  Kohei Yoshida  <kohei.yoshida@gmail.com>  [ca2b6993bef259714edfe069a7f8d69212947c2a]

	Write tests for generating map definitions.


2020-07-27  Kohei Yoshida  <kohei.yoshida@gmail.com>  [bd126919a0077eb80b73d081f8ee056ba2e5319d]

	Use brace initializers to make it look a bit more concise.


2020-07-27  Kohei Yoshida  <kohei.yoshida@gmail.com>  [45a7d7e239541bf46a86cc6dde15c8f9a7d447f3]

	Set the linked range position to row=0 and column=0.


2020-07-27  Kohei Yoshida  <kohei.yoshida@gmail.com>  [0e49f2a99c62c28161b0b668431963ba6cd5f223]

	Re-use an existing xmlns_repository instance.


2020-07-27  Kohei Yoshida  <kohei.yoshida@gmail.com>  [e77c5b3cb01d9cc6c1a2c0a018b1a81542e1b678]

	Let's retire the doxygen documentation.


2020-07-26  Kohei Yoshida  <kohei.yoshida@gmail.com>  [100ff7b5d3abc99d5d0506a78d8e738f264339fa]

	Rename to write_map_definition, for consistency.


2020-07-26  Kohei Yoshida  <kohei.yoshida@gmail.com>  [51bc5125da227d133030c154d41b6f26ca86901f]

	Let's not use m_ prefix for members of impl struct.

	The impl member itself is already prefixed with mp_. It feels
	repetitive to use the m_ prefix in the impl member names too.

2020-07-26  Kohei Yoshida  <kohei.yoshida@gmail.com>  [f8764c737cd894cae4fcdaa90f24c749e83e587c]

	Use the namespace repo instance from orcus_xml::impl.

	But in order to have access to it, I first needed to move the impl
	class code into separate header/source file pair.

2020-07-26  Kohei Yoshida  <kohei.yoshida@gmail.com>  [6dda93e76a4b66a408f8b37cfb6461cf9d723168]

	Leftover forward declaration.


2020-07-25  Kohei Yoshida  <kohei.yoshida@gmail.com>  [44884ff33405ad3e4506b724bef77e6b67bb2206]

	Minor formatting tweak.


2020-07-25  Kohei Yoshida  <kohei.yoshida@gmail.com>  [443cf7dbd38318ce10bf6f301112813cc7535d33]

	No need to create an impl instance for the other object when moving.


2020-07-25  Kohei Yoshida  <kohei.yoshida@gmail.com>  [c5bf46c65ec3fbab26446a2128ff314b2f44bb73]

	Move the map-generation code into orcus_xml.


2020-07-25  Kohei Yoshida  <kohei.yoshida@gmail.com>  [6192bbd58fc10867b3bd844b312e547fc48e95a5]

	Implement add_content() method. Currently not used yet.


2020-07-25  Kohei Yoshida  <kohei.yoshida@gmail.com>  [dccbcadc2ab43fb4d0b66147579e17079f975656]

	Make the scope object move assignable.


2020-07-25  Kohei Yoshida  <kohei.yoshida@gmail.com>  [34b8d6284ed80f98f7a397bab37beaf453cc6ca4]

	Introduce RAII-based element scoping.

	This will eliminate the manual push-pop call pairs.

2020-07-25  Kohei Yoshida  <kohei.yoshida@gmail.com>  [20bfaf37957f0ac5fa63ef68d63c870260d51148]

	Pop all the elements on the stack when the writer instance is ...

	... being destroyed.

2020-07-24  Kohei Yoshida  <kohei.yoshida@gmail.com>  [92a8d7a8124d042d770afdb84cd5098855754e74]

	Slightly better handling of the default namespace value.


2020-07-24  Kohei Yoshida  <kohei.yoshida@gmail.com>  [a018838f61d8319cf8b7e5b28a861de9c7cd74a3]

	Intern all string instances.


2020-07-24  Kohei Yoshida  <kohei.yoshida@gmail.com>  [59d07a793bfd8faf794f401f2b40a325c75f47c8]

	Remove duplicated code blocks.


2020-07-24  Kohei Yoshida  <kohei.yoshida@gmail.com>  [f1e3b507a35f81a8c4e48298421a35c0a5fe9cb2]

	Handle self-closing elements.


2020-07-24  Kohei Yoshida  <kohei.yoshida@gmail.com>  [388ac1a3c583f8623fe2abd55f1751ea14d880bc]

	First shot at generating map file. Still lots of issues.


2020-07-23  Kohei Yoshida  <kohei.yoshida@gmail.com>  [29f134075ded741ff922bb8980ea322fcb69fe7a]

	Set up the basic structure for map generation.

	All I have to do now is to convert this flat output into an XML
	form.

2020-07-23  Kohei Yoshida  <kohei.yoshida@gmail.com>  [af394336ca0c05983e63e7dd46a100b0fc5a8fae]

	Adjust the cli parser code and make room for the map-gen mode.

	Not implemented yet.

2020-07-23  Kohei Yoshida  <kohei.yoshida@gmail.com>  [d739a02853d791fec0272c6df455a6bf5a9bcf78]

	Make use of the new 'has_content' attribute in the auto-mapping ...

	... and only auto-link those elements with actual contents.

2020-07-23  Kohei Yoshida  <kohei.yoshida@gmail.com>  [5638d09bc248ef7c2fb784e5311f96e4df0fd69c]

	Remove using namespace std and get the code to build.


2020-07-23  Kohei Yoshida  <kohei.yoshida@gmail.com>  [8f64eb3c475976c0d5406d1fb58454c1d0a6e1ac]

	Detect whether or not each element has content.


2020-07-23  Kohei Yoshida  <kohei.yoshida@gmail.com>  [85c2bd89e136a95f70fb88ec43118fc7c394ba23]

	Switch to using boost::filesystem & rename the executable to ...

	... match the source file.

2020-07-22  Kohei Yoshida  <kohei.yoshida@gmail.com>  [5358a1e6644baed9d6f80e417f8edb3cda7276a3]

	Let's not forget to add these files.


2020-07-22  Kohei Yoshida  <kohei.yoshida@gmail.com>  [f49a117a4aedf08bcabe57724cb34326cfdb2b1d]

	Fix orcus-json for map mode.

	It was creating an output *file* up-front when in fact we shouldn't
	for the map mode.  In map mode, we let the backend document decide
	whether to create an output file or an output directory.

2020-07-22  Kohei Yoshida  <kohei.yoshida@gmail.com>  [245c355daa3cb67dea11b327cd578014885e32a7]

	Add the rest of the test cases, minus 2.

	Two of the existing test cases didn't get added because they didn't
	have any linkable ranges in them.

2020-07-22  Kohei Yoshida  <kohei.yoshida@gmail.com>  [f22eeb203abda4691319dfc2a0f74e6e549e4fe2]

	Add the first test case for auto xml mapping.


2020-07-22  Kohei Yoshida  <kohei.yoshida@gmail.com>  [00b081e6962a73a1173d2746e0dcf10be0f276ff]

	Set up a new test spot for xml mapping with no map files.


2020-07-21  Kohei Yoshida  <kohei.yoshida@gmail.com>  [741ad7a4b6cdbd1a53fe757d7acade1a9259589b]

	I don't need this any more.


2020-07-21  Kohei Yoshida  <kohei.yoshida@gmail.com>  [29b753d17ba9089464a8ac1ccc02b866fc755731]

	Correctly handle attribute names with namespaces.


2020-07-21  Kohei Yoshida  <kohei.yoshida@gmail.com>  [7caa35079661d43597fa2678137a0b3c31a3a1b5]

	Do the same for get_attributes().


2020-07-21  Kohei Yoshida  <kohei.yoshida@gmail.com>  [6c55a68e279954744884651bbc430e23fefb9ae4]

	get_children() to return the list directly instead of using ...

	... an out-bound reference parameter.

2020-07-21  Kohei Yoshida  <kohei.yoshida@gmail.com>  [4aca3735d426d5c0853c923b992e010d885020e8]

	Implement automatic detection of linkable ranges in XML documents.


2020-05-23  Kohei Yoshida  <kohei.yoshida@gmail.com>  [77633c019d4c90bf80cb8470257c9a49e367f4f1]

	Add a new test case.


2020-05-23  Kohei Yoshida  <kohei.yoshida@gmail.com>  [b89de912c0317f8722d99fab53c1bcc3e7abfdce]

	Update the test file to include range reference to numeric cells.


2020-05-23  Kohei Yoshida  <kohei.yoshida@gmail.com>  [108d611e66c45cc69924def3dabd8d2687cb0aef]

	Defer all cell formula imports until the end of Workbook element.


2020-05-23  Kohei Yoshida  <kohei.yoshida@gmail.com>  [5e068133878586c72929cca865df20cfdf883d05]

	Use range-based for loop here too.


2020-05-23  Kohei Yoshida  <kohei.yoshida@gmail.com>  [fbb6b04358b8bc11b407b87e43c2f155702828ec]

	Replace use of function object in favor for range-based for loop.


2020-05-23  Kohei Yoshida  <kohei.yoshida@gmail.com>  [aaa12dae2e46e9b6b35e7ae89dae29202a67608f]

	Move the worksheet element handling code into its own methods.


2020-05-23  Kohei Yoshida  <kohei.yoshida@gmail.com>  [8d16788e169ec326db3e94f98a10bb7146574bb9]

	Get the cmake build fixed up. Also remove the unconditional lib prefix.


2020-05-23  Kohei Yoshida  <kohei.yoshida@gmail.com>  [048d13a28db069969ff1c065f883f40a6a5c9c8e]

	Fix the cmake build with MSVC.


2020-05-22  Kohei Yoshida  <kohei.yoshida@gmail.com>  [760a3e785350f182f144e4ab6a044575254c7c14]

	Add a test document that orcus currently fails to load.


2020-05-22  Kohei Yoshida  <kohei.yoshida@gmail.com>  [c3cd6e4dfc87c19adbe8eb4614922873887301a8]

	I found another one here too.


2020-05-22  Kohei Yoshida  <kohei.yoshida@gmail.com>  [cacaae52a457ce568a448143ec7ff072a0552f22]

	Minor fixes.

	I still need to generate the output file to signal the file has been
	"processed".

2020-05-22  Kohei Yoshida  <kohei.yoshida@gmail.com>  [6b61f74285fef9e039bc5882014549ef63fe127f]

	Another one for page field attributes.


2020-05-22  Kohei Yoshida  <kohei.yoshida@gmail.com>  [e142e72f6a1ed5decd85c968b4149dd2dca96d62]

	Another one.


2020-05-22  Kohei Yoshida  <kohei.yoshida@gmail.com>  [9ec730a72c19920f7b0f028335a9895eca95d27e]

	More on funcobj removal & unwanted debug output supression.


2020-05-22  Kohei Yoshida  <kohei.yoshida@gmail.com>  [3a4b70af847266481f74efe54e16998af3477a1c]

	More on supressing output when the debug flag is off.


2020-05-22  Kohei Yoshida  <kohei.yoshida@gmail.com>  [2c8fca24eb43926da82a77db4ea727382bc0c4b1]

	Remove another attr-parsing func object in favor of ranged for loop.

	And print stuff only when the debug flag is on.

2020-05-22  Kohei Yoshida  <kohei.yoshida@gmail.com>  [fb9c519648a0c0a2e78db0b1f5aa356b011437af]

	Output only when the debug flag is on.


2020-05-22  Kohei Yoshida  <kohei.yoshida@gmail.com>  [73f4dfdd5df1afd004de9d453af0cabe2e9ffde2]

	Remove this attribute handler func object...

	... in favor of range-based for loop.

2020-05-22  Kohei Yoshida  <kohei.yoshida@gmail.com>  [1a717ccdad986ac93277d26c1eb5108a3365ecb4]

	Support multi-processing in orcus.tools.file_processor.

	Though due to excessive memory usage, I could only use up to 2
	processes on my machine.

2020-05-21  Kohei Yoshida  <kohei.yoshida@gmail.com>  [915eb6e52277a1bec6e330faa689605467528db1]

	Adjust the documentation for the parser handler relocations.


2020-05-14  Kohei Yoshida  <kohei.yoshida@gmail.com>  [8d85b114db23ab12f9b45406eeb22b40460e324f]

	Add method to string_pool to return all interned strings.


2020-05-14  Kohei Yoshida  <kohei.yoshida@gmail.com>  [27e40efba817843461cfa50fff49df9b0ce81794]

	Complete xml_name_t and add some test code for it.


2020-05-11  Kohei Yoshida  <kohei.yoshida@gmail.com>  [1ef150f7602f100bc91d82f590204078afa348d7]

	This file does not exist.


2020-05-11  Kohei Yoshida  <kohei.yoshida@gmail.com>  [96cb30ab1335baf25d455b034dd0c7413e5cedf7]

	Finally, move the handler for yaml_parser into header.

	With this, parser_handlers is no more.

2020-05-11  Kohei Yoshida  <kohei.yoshida@gmail.com>  [a83b0d48eb1ed5adf4f0b1d7829ee9e5319232da]

	Move the handler for json_parser into public header.


2020-05-11  Kohei Yoshida  <kohei.yoshida@gmail.com>  [a1aa2ea7c67dd974087c9210f38c90d9ea24f5a6]

	Move handler for csv_parser into header space.


2020-05-11  Kohei Yoshida  <kohei.yoshida@gmail.com>  [af5345851f8f6b1320c2cf1ff481944b3bb76d32]

	Move the handler for css_parser into header space.


2020-05-11  Kohei Yoshida  <kohei.yoshida@gmail.com>  [0fac43815e517a4e99bff47861e0f7a6f91ca31a]

	Move the sax parser handlers into proper headers.

	Also move their test codes into src/parser/.

2020-05-08  Kohei Yoshida  <kohei.yoshida@gmail.com>  [2dd55209efabeb276a744b1e04a0049901ff3327]

	Make sure the read() methods can take mmap'ed streams.


2020-05-08  Kohei Yoshida  <kohei.yoshida@gmail.com>  [a34c4e6e76db222c17741ae61560bb5d13baefad]

	Allow the file processor module file to contain dashes.


2020-05-02  Kohei Yoshida  <kohei.yoshida@gmail.com>  [bdbf7d6c9783c6b987209acdfccfa9c7968be4c0]

	Adjust the test cases to reflect the new xpath parser rule.


2020-05-02  Kohei Yoshida  <kohei.yoshida@gmail.com>  [9e6d8c8041bd55f73c02fa39ec4aa1bf0c9b7eb9]

	Modify the logic of xpath_parser to handle '/@' for attributes.


2020-04-29  Kohei Yoshida  <kohei.yoshida@gmail.com>  [9d0928c7b42345f90ec05e9e2407be6092f2b9d5]

	Add this test to cmake too, but this is completely untested.


2020-04-29  Kohei Yoshida  <kohei.yoshida@gmail.com>  [d40a13e7efbf8bf639140fc4f9772a0bfc6af874]

	Add a test case for attribute.

	This one tests the current incorrect syntax. The correct syntax is
	coming next.

2020-04-29  Kohei Yoshida  <kohei.yoshida@gmail.com>  [0d291693005a24253c8e4dfc6461a6c74dea8b73]

	Add test file for xpath_parser.


2020-04-29  Kohei Yoshida  <kohei.yoshida@gmail.com>  [0916a95da9fb60e47c9929f55a7025e5449df290]

	Promote xpath_error into a top-level exception.


2020-04-29  Kohei Yoshida  <kohei.yoshida@gmail.com>  [549af501a72df3ce2e22e039ae9ef8d97e1b9579]

	Move xpath_parser into its own source file.


2020-04-29  Kohei Yoshida  <kohei.yoshida@gmail.com>  [80428da9592e2d7e3446131c57cedee86f1920f0]

	Prepend extra '/' with '@' for attribute nodes.


2020-04-28  Kohei Yoshida  <kohei.yoshida@gmail.com>  [4f0c51e8812e67f5dcfd6b4e9768f93e8633a35e]

	These files no longer exist.


2020-04-28  Kohei Yoshida  <kohei.yoshida@gmail.com>  [a0e65ef7f91a8e54466bdc794e21ae2473588e2c]

	Move this file to the orcus/ml-engine repo.

	Since this module is used primarily for future ML training, it should
	be in the other repo.

2020-04-28  Kohei Yoshida  <kohei.yoshida@gmail.com>  [988de1a1122fd93eff2fea622571c79474dfc36e]

	Allow skipping files per regex rules.

	This comes in handy esp. with those files that would otherwise take
	over 10 minutes to load and/or always end up killing the process due
	to massive memory usage.

2020-04-28  Kohei Yoshida  <kohei.yoshida@gmail.com>  [27b9095be1eb319b7ba91e717a35e05d2f7b14d3]

	Introduce a STRING_WITH_ERROR type for string cells containing ...

	... invalid string values.

2020-04-28  Kohei Yoshida  <kohei.yoshida@gmail.com>  [0d32a1cedd929f27690de3b0b09a3dfee2f40b99]

	Add a function to find a loader module per specified format type.


2020-04-27  Kohei Yoshida  <kohei.yoshida@gmail.com>  [68de888a42c3be3f7aa6e26ee7b1cf260a149989]

	Get these processor modules to work properly again after the relocation.


2020-04-27  Kohei Yoshida  <kohei.yoshida@gmail.com>  [53b51ec3e2ce2f21a1083beeacb04639bff8dda8]

	You still need this for this module to be executable.


2020-04-27  Kohei Yoshida  <kohei.yoshida@gmail.com>  [aa57f7b04abe62150be6884aa31a4a54a95db4e4]

	Move the file processor code into proper orcus module tree.


2020-03-29  Kohei Yoshida  <kohei.yoshida@gmail.com>  [d85dcbb86a0f51d5b3ed3ab15869cb54c7bd182c]

	Update for the 0.15.4 release.


2020-03-29  Kohei Yoshida  <kohei.yoshida@gmail.com>  [dcec0c56b0a435790fc8e189344a3de9287b1410]

	Reorganize the info a bit.

	Going forward, I'll be using GitLab's releases feature to provide
	source packages.

2020-03-28  hedmo  <hedmoo@yahoo.com>  [0d0d06207b1df25e7c855b85bd05a014f2e9f98c]

	Update json_map_tree.cpp


2020-03-27  Kohei Yoshida  <kohei.yoshida@gmail.com>  [da4ebdee489434d8cdbb1b460a9ebcf4583be341]

	Fix make distcheck.


2020-03-27  Kohei Yoshida  <kohei.yoshida@gmail.com>  [c19effb517bd759249c8e42adb0b5598c20c9cb8]

	Clean up the file entries in misc and slickedit...

	... and remove a project file that we no longer use.

2020-03-27  Kohei Yoshida  <kohei.yoshida@gmail.com>  [5c28b772124d1a395b5bbd301bbd0178a29cb3ba]

	Remove things that are no longer useful.


2020-03-27  Kohei Yoshida  <kohei.yoshida@gmail.com>  [7d54f256222fa8b208fcb306e21fa00419ddab4b]

	Remove specification and schema files.


2020-02-11  Kohei Yoshida  <kohei.yoshida@gmail.com>  [919b0d2195671fe90427ef22cdc4365129d76fdf]

	Fix the spelling error.


2020-02-06  Kohei Yoshida  <kohei.yoshida@gmail.com>  [4f983a09ec870805558fa2d542cf248722ba90e3]

	Make sure to escape all strings that may potentially contain special chars.


2020-02-06  Kohei Yoshida  <kohei.yoshida@gmail.com>  [fec272625b5876348076136c11a34fd9bf502766]

	Fix the handling of formula cells with error.


2020-02-06  Kohei Yoshida  <kohei.yoshida@gmail.com>  [10cdc98c636dddea2ccffd63af86317a09e14e6c]

	Write xml output by hand.


2020-02-05  Kohei Yoshida  <kohei.yoshida@gmail.com>  [a95bd7c0f784e6a6c316e45ab574046da196e86e]

	Change the name of the special name to include the source file name.

	Also encapculate the code that has dependency on xml.etree.

2020-02-05  Kohei Yoshida  <kohei.yoshida@gmail.com>  [f7617eee70dd1f69cda08606640941ca2b6bc130]

	Turn off token data generation.


2020-02-05  Kohei Yoshida  <kohei.yoshida@gmail.com>  [22506821a6a129b560374c90a7a56910e3d8310a]

	Stringify the tokens before shoving them to the dom.


2020-02-05  Kohei Yoshida  <kohei.yoshida@gmail.com>  [52385250889c212645d8a5e3ecdd13a6a1c6c6da]

	Directly write xml output files as we process the document files.


2020-02-05  Kohei Yoshida  <kohei.yoshida@gmail.com>  [d51134ea28667b778e3ef82796f9f7993c5f67f0]

	Add names() method that returns a set of named expression names.


2020-02-05  Kohei Yoshida  <kohei.yoshida@gmail.com>  [b4624e9e22e83370f5a03c09b82ab8d8a4cdd3b1]

	Remove 'named_expressions' member from orcus.Sheet.


2020-02-05  Kohei Yoshida  <kohei.yoshida@gmail.com>  [530207c026f836e50a71e0ace0df19e9d9d3a7e0]

	Implement named expressions iterator for sheets.


2020-02-04  Kohei Yoshida  <kohei.yoshida@gmail.com>  [56996749b2b9f47b044c4f67b696871d0ac87ea3]

	Remove named_expressions attribute from orcus.Document.


2020-02-04  Kohei Yoshida  <kohei.yoshida@gmail.com>  [f8ef0f6c388cb37ea69ad37ffb4c021143dc931c]

	No need to pass origin sheet ID.


2020-02-04  Kohei Yoshida  <kohei.yoshida@gmail.com>  [75ac9ac90f533171dd7508a2e228122f4667e7d7]

	Add support for built-in len().


2020-02-04  Kohei Yoshida  <kohei.yoshida@gmail.com>  [0ee17361b4a949794f150fc9c85965abd2a40978]

	Iterator to return a tuple of (name, exp).


2020-02-04  Kohei Yoshida  <kohei.yoshida@gmail.com>  [1d521c1ce07e57e6c2494370dcb6b215ee11c0b5]

	Initial implementation of named expressions iterator.


2020-02-04  Kohei Yoshida  <kohei.yoshida@gmail.com>  [93b89ed1bf7a5166a16ddb052ba078e48b136182]

	Add these files to slickedit project.


2020-02-04  Kohei Yoshida  <kohei.yoshida@gmail.com>  [8971979326c54e6c6138da9e0ba4266c8b0a4852]

	Add an empty implementation for orcus.NamedExpressions.

	I'll fill in the blanks later.

2020-02-04  Kohei Yoshida  <kohei.yoshida@gmail.com>  [8a00fb47f4725bfcfb5ef8261cdcdfcb213f3b66]

	Remove 'formula_tokens' member from orcus.NamedExpression.


2020-02-04  Kohei Yoshida  <kohei.yoshida@gmail.com>  [308a198461b34a859123dccbd932313db5be1c1e]

	Use formula token iterator for orcus.NamedExpression too.


2020-02-04  Kohei Yoshida  <kohei.yoshida@gmail.com>  [5c1ce9fb60c607a2bbed19768ec928b7141b4944]

	Remove formula_tokens member from orcus.Cell.


2020-02-04  Kohei Yoshida  <kohei.yoshida@gmail.com>  [0001e2dad59e0b6c9695982389742212fef702c4]

	Add a test case for orcus.FormulaTokens iterator.


2020-02-04  Kohei Yoshida  <kohei.yoshida@gmail.com>  [72f469c3321e759a7980c361bec195fe48e53508]

	Support built-in len() method on orcus.FormulaTokens object.


2020-02-04  Kohei Yoshida  <kohei.yoshida@gmail.com>  [b310570ed8a102c7370e3dfd5b390e9e35637247]

	Hook the formula tokens iterator to orcus.Cell.get_formula_tokens().


2020-02-04  Kohei Yoshida  <kohei.yoshida@gmail.com>  [13e177e6d25b6393f3a5a1368b4b643161c68bb8]

	Fill in the blanks. Still not tested.


2020-02-04  Kohei Yoshida  <kohei.yoshida@gmail.com>  [b9759990ebaa1beee5e3fcb34a46d268e0c08844]

	Let's not forget to add these files to slickedit project.


2020-02-03  Kohei Yoshida  <kohei.yoshida@gmail.com>  [da41e0ed2b55b3aa13e4fa6dd6e5296e91773cec]

	Skeleton implementation for orcus.FormulaTokens.


2020-02-03  Kohei Yoshida  <kohei.yoshida@gmail.com>  [6d0d59b42ae864e2aa5cd1fe8f728314bb854e50]

	This is no longer needed.


2020-02-03  Kohei Yoshida  <kohei.yoshida@gmail.com>  [5059e82dca13a7d7deb363099a65e653b05dc3f2]

	Add 'origin' attribute to orcus.NamedExpression type.


2020-02-03  Kohei Yoshida  <kohei.yoshida@gmail.com>  [d49f745fd7d244f2fe04729d3afc4f7a5aebe70c]

	We don't need this.


2020-02-03  Kohei Yoshida  <kohei.yoshida@gmail.com>  [49000b80a6adc3014aa833cd9efaa547842902b9]

	Pick up and store the named expression origins.

	Also, for a sheet-local name, use the index of the respective sheet
	as the default base sheet.

2020-02-03  Kohei Yoshida  <kohei.yoshida@gmail.com>  [bacbe35bfc3d5e1a2bc265452025b0e143765b19]

	Adjust the code for named expression change in ixion.


2020-02-03  Kohei Yoshida  <kohei.yoshida@gmail.com>  [d409fbeb79812c1f23a5c4d2034f32add8ab285c]

	Rename sheet_size() to get_sheet_count() for disambiguation.


2020-02-03  Kohei Yoshida  <kohei.yoshida@gmail.com>  [72b6997e22bb25b633f8df8d6ebda47bc09bdb50]

	Make adjustment to recent ixion change.

	Now we need to specify the desired sheet size at document construction
	time, and that gets applied to all future sheets.

2020-01-31  Kohei Yoshida  <kohei.yoshida@gmail.com>  [dd264e5e5cd069eeaa4d5295e67fd07d4ba6d6f8]

	New test file including named expressions with relative references.


2020-01-31  Kohei Yoshida  <kohei.yoshida@gmail.com>  [fff1c66f5705b5ccee16672a2a37dd5d5fe9496d]

	Leave UTF-8 strings alone.


2020-01-31  Kohei Yoshida  <kohei.yoshida@gmail.com>  [3e57e1624e431f2b5878e3f1d70dc95026558a08]

	Let's always output in XML. JSON is harder to read for this type of data.


2020-01-31  Kohei Yoshida  <kohei.yoshida@gmail.com>  [a6dd46ecc37e317c23c09058c372c7eace474b82]

	Make XML pretty print optional.

	As it turned out it was very expensive memory-wise.

2020-01-31  Kohei Yoshida  <kohei.yoshida@gmail.com>  [5242a58334d2f851e38eef09fdbf062f91a00e4f]

	Make token data output optional.


2020-01-31  Kohei Yoshida  <kohei.yoshida@gmail.com>  [8ecb07cabcde5eab02488ce56a00926e132e895d]

	I need to know which batch is being processed at any given moment.


2020-01-31  Kohei Yoshida  <kohei.yoshida@gmail.com>  [eef9f040dc30ec35f88c2ec866f9165d40e70fed]

	Flush the batch each time to reduce memory use.


2020-01-30  Kohei Yoshida  <kohei.yoshida@gmail.com>  [912ac35ad7f2e0eee9ff9fd6d31e0f4f6b1dbd1d]

	Fix the unit test code.


2020-01-30  Kohei Yoshida  <kohei.yoshida@gmail.com>  [98fe315af1e5d268164459f9fbbb2f5531e945c3]

	Use FormulaToken in named expressions and output them.


2020-01-30  Kohei Yoshida  <kohei.yoshida@gmail.com>  [8a3c6bbe56cd641466acf45318ccbbff50b6308c]

	Add this file to slickedit project.


2020-01-30  Kohei Yoshida  <kohei.yoshida@gmail.com>  [8fe79e835d70724a8e601b870128347166ef58a8]

	Apply the error policy to array formula import as well.


2020-01-30  Kohei Yoshida  <kohei.yoshida@gmail.com>  [b4331dd744f6f1dd1a76f99eb03fb3af442d3297]

	Extract formula token types.


2020-01-30  Kohei Yoshida  <kohei.yoshida@gmail.com>  [22fa8fddee2c34ec6a84512fa23457dfb9d3788f]

	Handle formulas with error properly when extracting formulas.

	Also fix a bug on token to string conversion.

2020-01-30  Kohei Yoshida  <kohei.yoshida@gmail.com>  [526e004cd1e84ff24250105a7f6d54eba3d23ee6]

	Let's create a separate cell type for formula cells with error.


2020-01-30  Kohei Yoshida  <kohei.yoshida@gmail.com>  [1cf1d2d02406ba5fbd48bdbe91726ba57da7c2ca]

	Make sure the error formula tokens are formed as intended.


2020-01-30  Kohei Yoshida  <kohei.yoshida@gmail.com>  [2df3ac4a30e3dee69120f17ccc92e96aa3a60103]

	Add a test case for formula cells with error.


2020-01-30  Kohei Yoshida  <kohei.yoshida@gmail.com>  [21d0e63ff76f8d17092c88fd658df0f1c0e252c6]

	Assign a correct formula token type.


2020-01-30  Kohei Yoshida  <kohei.yoshida@gmail.com>  [4366e29c51d6ad3823226e1f7631c85ce2701226]

	Switch to using orcus.FormulaToken in orcus.Cell.formula_tokens tuple.


2020-01-30  Kohei Yoshida  <kohei.yoshida@gmail.com>  [b86f02a5312e5790a8654d0da7e1df4682fea97d]

	Let's remove this for now.

	There is no internal sharing between Cell and other types, like Sheet,
	Document, and SheetRows.

2020-01-29  Kohei Yoshida  <kohei.yoshida@gmail.com>  [f034537b75af40cbd78e16b93d15db828c759856]

	Let's not forget to add these files.


2020-01-29  Kohei Yoshida  <kohei.yoshida@gmail.com>  [841aabdc17ecf1d2de9dec08385ef6d5d3580eaa]

	Create an empty implementation for orcus.FormulaToken type.


2020-01-29  Kohei Yoshida  <kohei.yoshida@gmail.com>  [e2e6a9d94cc32e21756bcf019d77a1e0cbee34b3]

	Use the skip error policy when mass-processing files.


2020-01-29  Kohei Yoshida  <kohei.yoshida@gmail.com>  [306eaa279af48dfc50da3ecb886e7465bb76cf37]

	Expose the error policy option via Python API, ...

	... and add a test case for it.

2020-01-29  Kohei Yoshida  <kohei.yoshida@gmail.com>  [c101eeb376e233343209e301330cf066e24f2093]

	Add a test case for importing formula cells with error.


2020-01-29  Kohei Yoshida  <kohei.yoshida@gmail.com>  [16605c2e1f1ee40e6ab405206447091390ff8421]

	Test case with intentionally incorrect formula expressions.


2020-01-29  Kohei Yoshida  <kohei.yoshida@gmail.com>  [adc2a1a8b48f7d24774754c39bab8fba46dc7e47]

	Fix the weird indentation.


2020-01-28  Kohei Yoshida  <kohei.yoshida@gmail.com>  [1b00d2b7b82f6595111fdc676433fa1cbe03a1a3]

	Add a new CLI parameter --error-policy to control formula cell failure.

	* skip to skip the offending cells and keep going.
	* fail to abort the loading process immediately.

2020-01-27  Kohei Yoshida  <kohei.yoshida@gmail.com>  [2fad6d6166900d283c8d9396f0de13dc87a70b58]

	Simplify the function a bit.


2020-01-27  Kohei Yoshida  <kohei.yoshida@gmail.com>  [364af279406eaca4c66686777d847dcde0f962ba]

	Extract a function for named expression dictionary population.


2020-01-27  Kohei Yoshida  <kohei.yoshida@gmail.com>  [f003b82fc939127d27e0d8e23ddcc4aab68f8838]

	Populate sheet-local named expressions dict.


2020-01-27  Kohei Yoshida  <kohei.yoshida@gmail.com>  [7713f4bf391ca93e5dfea6e4955cdff42ccfc4f5]

	Populate the global named expressions dict.


2020-01-27  Kohei Yoshida  <kohei.yoshida@gmail.com>  [47608118eefa742e90b4c9d21ba18b8872622d87]

	Adjust for the recent ixion change.


2020-01-25  Kohei Yoshida  <kohei.yoshida@gmail.com>  [879a8231c163345bcb37936012745992a2b529f1]

	Add a function to create named expression objects. Not used yet.


2020-01-24  Kohei Yoshida  <kohei.yoshida@gmail.com>  [d55d40f315f15adf537c163f2250fc7937058c7a]

	Add a boilerplate code for orcus.NamedExpression.


2020-01-24  Kohei Yoshida  <kohei.yoshida@gmail.com>  [50a908fa8ded8c0ded4eccd0bb7df7e71f0f06bc]

	Update this constant variable name.


2020-01-24  Kohei Yoshida  <kohei.yoshida@gmail.com>  [b00ade78025378e3f5477f7fc78c638e10e9a0e1]

	Create a dedicated context to handle (or ignore) table:dde-links tree.


2020-01-23  Kohei Yoshida  <kohei.yoshida@gmail.com>  [bb2cbe1e46b8e918142fee76c27c295ff1ae3300]

	I forgot those breaks.


2020-01-23  Kohei Yoshida  <kohei.yoshida@gmail.com>  [0850f1b2f67c53ad236c92a76b4d4610a60065f9]

	Import sheet-local named ranges and expressions as well.

	And add the file to the tested file list.

2020-01-23  Kohei Yoshida  <kohei.yoshida@gmail.com>  [ec8b2767a26b027925fe8a57b753658b8546fa09]

	Add this file to the list of tested files.


2020-01-23  Kohei Yoshida  <kohei.yoshida@gmail.com>  [29b1ded97dbf2e0bd835c4f3243d40d426eb09e6]

	Pick up named expressions as well. Not yet tested.


2020-01-23  Kohei Yoshida  <kohei.yoshida@gmail.com>  [79265813bb074bf7dcee616fc16cd5124edf3847]

	Add named-range to the list of tested ods files.


2020-01-23  Kohei Yoshida  <kohei.yoshida@gmail.com>  [d052efd831f0181f30af64acd28dff1379f098a6]

	Finally manage to import global named ranges from ods.

	Not tested yet & sheet-local named ranges or expresions are to be
	worked on later.

2020-01-22  Kohei Yoshida  <kohei.yoshida@gmail.com>  [0a92a7a74e2b57676e3fc98afcf2767a2aaf7b37]

	Add another named expression to clarify its syntax.

	It looks as though it uses ODFF syntax without the 'of:' prefix for
	named-expression, whereas named-range it uses something else...

2020-01-22  Kohei Yoshida  <kohei.yoshida@gmail.com>  [fc883366a14f144673320f126c916f7742c927e3]

	Update the test doc to add another named expression with references.


2020-01-22  Kohei Yoshida  <kohei.yoshida@gmail.com>  [2b9c1f101b61c1c8ac47e5a28b15c9b103871eab]

	Let's not forget destructor here.


2020-01-22  Kohei Yoshida  <kohei.yoshida@gmail.com>  [7283d207bdff64da76d0915931a6b44e209c062e]

	Attempt to import global named expressions.

	It fails on e.g. '.E1:.F5' type of range reference which is not exactly
	a Calc A1 flavor.

2020-01-22  Kohei Yoshida  <kohei.yoshida@gmail.com>  [7ffe1b993f964fd89c99120ae0f552d2bfd9e22e]

	Don't forget to switch reference context.


2020-01-22  Kohei Yoshida  <kohei.yoshida@gmail.com>  [8ce8d0ebfaf017e5a6be0045c88248bdc48bb892]

	Defer the base address resolution until the very end.

	But before processing the formula cell strings which rely on the named
	expressions being populated.

2020-01-22  Kohei Yoshida  <kohei.yoshida@gmail.com>  [44201237bcb27e239a1f59c47d1b2dc73891d4de]

	Reference resolver to return src (sheet-row-column) addresses.


2020-01-22  Kohei Yoshida  <kohei.yoshida@gmail.com>  [d791d99447bdf8d1825d94f593312daf05ed45d6]

	Pick up named ranges and store them for later processing.


2020-01-22  Kohei Yoshida  <kohei.yoshida@gmail.com>  [300bcbbef3677dd95baaccd4f3846078ed964417]

	Keep track of current sheet scope.

	Mostly so that we know when we are NOT in a sheet scope.

2020-01-22  Kohei Yoshida  <kohei.yoshida@gmail.com>  [c03d5528b279176b2e99671e82a0cccc159852a6]

	Adjust the import_named_expression interface ...

	... to prepare for importing an optional base position parameter.

2020-01-22  Kohei Yoshida  <kohei.yoshida@gmail.com>  [b546990b8a7b95ff759b6c335d5bbc34fc567696]

	Use different resolver type for parsing named expression strings.


2020-01-22  Kohei Yoshida  <kohei.yoshida@gmail.com>  [e378f483ecc15e6fc4ab3f64f5266d1f7e53e99b]

	Introduce the concept of formula reference context.

	This is meant to primarily serve the ODS format where it uses different
	formula reference grammar for named expressions and possibly others.

2020-01-21  Kohei Yoshida  <kohei.yoshida@gmail.com>  [afdf5526dd7c33ab9a75c0558c86315d244a01fb]

	Set up a skeleton for future handling of named ranges.


2020-01-21  Kohei Yoshida  <kohei.yoshida@gmail.com>  [5db518a58058c0d1c2131658da9ff3b6da1e3e4f]

	Consistent styles...


2020-01-21  Kohei Yoshida  <kohei.yoshida@gmail.com>  [42368e821fd422b625203ae82e011a2132965157]

	Let's use std::deque over std::vector<std::unique_ptr<...>>.


2020-01-21  Kohei Yoshida  <kohei.yoshida@gmail.com>  [9fa143cb9b1ececb65b2d018d0b20bc06ef77778]

	Style names can be transient esp. when the name contains encoded chars.


2020-01-21  Kohei Yoshida  <kohei.yoshida@gmail.com>  [8a573a4395a12c3754fa4166b21e05d7b20323df]

	Add a few test files containing named ranges and expressions.


2020-01-17  Kohei Yoshida  <kohei.yoshida@gmail.com>  [24413fd27908fd9abdefcba4cd302fa319c0f8a9]

	Add a batch mode to split the output into a set of more manageable size outputs.


2020-01-16  Kohei Yoshida  <kohei.yoshida@gmail.com>  [d5ebaae3d478931fd83428b46470844fb060965e]

	Add sheet and formula counts to the output tree as attributes.


2020-01-16  Kohei Yoshida  <kohei.yoshida@gmail.com>  [ef6cefd15c91b6ef99eddbbfa4b0bc7bf130836f]

	Support xml output option.


2020-01-16  Kohei Yoshida  <kohei.yoshida@gmail.com>  [4d52d320068d30777206eb25cfc99989108532fb]

	Add code to aggregate all formula data into a single file.

	It's in json format for now.  I will probably add XML as an option.

2020-01-16  Kohei Yoshida  <kohei.yoshida@gmail.com>  [926a8fad22bbc9223f8d147dd471f99a3516f482]

	Add a new processor module to extract formula expression data.


2020-01-16  Kohei Yoshida  <kohei.yoshida@gmail.com>  [820ea373618710defdc7df802e0e5d3f5098a236]

	Adjust process-files.py to orcus.Cell objects & user processor module.

	The processor module is responsible for processing each document loaded.

2020-01-16  Kohei Yoshida  <kohei.yoshida@gmail.com>  [844cd6355f01466e3c8100524bea3cf56aa5fda3]

	Move the XML token related files into their own directory.


2020-01-15  Kohei Yoshida  <kohei.yoshida@gmail.com>  [7987b4590cb8d7bda08f23b1ac0a2a2a87662f35]

	Add test case for python's detect_format() function.


2020-01-15  Kohei Yoshida  <kohei.yoshida@gmail.com>  [88fb5befd4e7ed5292eed0aa2eb71a0b4e061893]

	Add a tuple of individual tokens to the Cell class.


2020-01-15  Kohei Yoshida  <kohei.yoshida@gmail.com>  [ee5e9b9f11ddb95984c3c53e21d93020b116e10b]

	Have detect_format() return an enum FormatType value instead of a string.


2020-01-15  Kohei Yoshida  <kohei.yoshida@gmail.com>  [da8c1beeb6ca4ce7cea62a78ff56d40329bef27f]

	Get make check to pass again.


2020-01-15  Kohei Yoshida  <kohei.yoshida@gmail.com>  [d243f7435537695b0780e8a1cdc9b5b5a32fad27]

	Specify type during cell object creation.


2020-01-15  Kohei Yoshida  <kohei.yoshida@gmail.com>  [d2fd8978657511492d9e6afc1d726267595c1b6f]

	Convert formula cells, and add 'formula' member to orcus.Cell.


2020-01-14  Kohei Yoshida  <kohei.yoshida@gmail.com>  [99fef3d152a6bf654d74946eb065cbcb473e9396]

	Convert numeric cells to use orcus.Cell.


2020-01-14  Kohei Yoshida  <kohei.yoshida@gmail.com>  [344b62e70bf99842b43782234a9fd6f5451021ce]

	Start replacing cell tuple objects with objects of orcus.Cell type.

	So far I've covered empty, boolean and string cells.

2020-01-14  Kohei Yoshida  <kohei.yoshida@gmail.com>  [bf21c15798817fc088c64f5fdb21037d9ea10549]

	Add 'type' member to the Cell class. For now, it stays UNKNOWN.


2020-01-14  Kohei Yoshida  <kohei.yoshida@gmail.com>  [5a86560a328288d8c24ac3be68da469d735ae1b6]

	Remove repeated code blocks.


2020-01-14  Kohei Yoshida  <kohei.yoshida@gmail.com>  [dc952f7b9305d422cdaf6690c05ef456c041c45c]

	Create a skeleton for orcus.Cell python class.


2020-01-14  Kohei Yoshida  <kohei.yoshida@gmail.com>  [ac14469afcd86a81ac7f7a6e58dc410b376bfdff]

	Support valgrind as run-mode.


2020-01-14  Kohei Yoshida  <kohei.yoshida@gmail.com>  [7c11e930f64326ad9710027d723a468dc61fce36]

	Fix memory leak.

	Also keep the number_formatting_style instance within the context
	instance, since it's only used within it.

2020-01-13  Kohei Yoshida  <kohei.yoshida@gmail.com>  [f627a4df1f498ec9a1c2bd7223c1e2f89896ccba]

	Handle attribute without namespace correctly.

	c.f. https://www.w3.org/TR/REC-xml-names/#defaulting

	When an element name does not have an explicit namespace, it takes
	the current default namespace (if one is defined). An attribute name,
	on the other hand, do NOT use the current default namespace when it
	does not have an explicit namespace given; the decision should be up
	to the element it belongs to, according to the above specification.

	This issue mostly affects those ods and xlsx files generated by 3rd
	party software that makes liberal use of default namespaces.

2020-01-13  Kohei Yoshida  <kohei.yoshida@gmail.com>  [9a878b9c6966d2f219d3fbd7865bb8cadf025959]

	Display current row.


2020-01-13  Kohei Yoshida  <kohei.yoshida@gmail.com>  [d0bce251005f69c2b999089654eb0f0460cd61bf]

	Ensure that it's a row style before accessing its union data member.


2020-01-13  Kohei Yoshida  <kohei.yoshida@gmail.com>  [10b7b347eddb328c74263f34f7e0f23bd8c121da]

	table:table element may occur under table:dde-link as well.

	In which case the element may not have a 'name' attribute.

2020-01-13  Kohei Yoshida  <kohei.yoshida@gmail.com>  [524ba0e3d16069361465e1269b880676951707a6]

	Explicitly check the element namespace.


2020-01-13  Kohei Yoshida  <kohei.yoshida@gmail.com>  [e50fd76d23e2646ed6ccd6e5e39dd8fe1e558e27]

	Bail out on empty sheet names.


2020-01-11  Ryo ONODERA  <ryo@tetera.org>  [7d2ae0b6e47aa0c1fc43a91300d82c5394420162]

	Improve POSIX shell portability

	DO not use bash syntax.

2020-01-10  Kohei Yoshida  <kohei.yoshida@gmail.com>  [76084ea9f2db98c2786756f484eb394430e56387]

	Handle attribute values with encoded chars surrounded by single quotes.


2020-01-10  Kohei Yoshida  <kohei.yoshida@gmail.com>  [876421904797a1c2a87cd4c2514da24c11d06b2a]

	Zero is zero even after the conversion.


2020-01-10  Kohei Yoshida  <kohei.yoshida@gmail.com>  [17e5ed79d5f5aed9acaf613bc87dd1b5f9190709]

	Use lambda function over old-style function object.


2020-01-10  Kohei Yoshida  <kohei.yoshida@gmail.com>  [d2e983e7d430c5342515abb202079f40eb287858]

	table-column can occur under table-columns.

	Also replace the use of xml_elem_stack_t with xml_elem_set_t in its
	vicinity.

2020-01-10  Kohei Yoshida  <kohei.yoshida@gmail.com>  [d4099cbc05dfd9afd953dda6ff9fb631218122f6]

	Gracefully fail formula registration for now.


2020-01-10  Kohei Yoshida  <kohei.yoshida@gmail.com>  [273cb53ddb125d2dee017334f1d0146b8aa53377]

	A little code cleanup.


2020-01-10  Kohei Yoshida  <kohei.yoshida@gmail.com>  [f08fb8b4c383e3b60e2e6a9827f91297665a89fd]

	There may be multpile pivot caches for the same worksheet range.


2020-01-10  Kohei Yoshida  <kohei.yoshida@gmail.com>  [ca8fc729429f2a99308463b55f04f655f8fb211f]

	Sometimes multiple pivot caches get created for the same table name.


2020-01-10  Kohei Yoshida  <kohei.yoshida@gmail.com>  [5c88fdfb5c8fb3420a6e87ecfabd4a62d9881b9c]

	Support importing of pivot caches associated with table names.


2020-01-09  Kohei Yoshida  <kohei.yoshida@gmail.com>  [41fc4843dbb6dacd8edac2740e0fb27a82002daf]

	Turns out sometimes we will find empty namespace values in the wild.


2020-01-09  Kohei Yoshida  <kohei.yoshida@gmail.com>  [df637055a4d3efdd97265833a8ca12a73a17067d]

	More on updating the expectations of the XML structure.


2020-01-09  Kohei Yoshida  <kohei.yoshida@gmail.com>  [318d2de4a71a4cb02e379c5672b7710185d1bd29]

	Add another anchor type to the list of expected parents.


2020-01-09  Kohei Yoshida  <kohei.yoshida@gmail.com>  [7117abc0e679634d60947c9299d96541c60fb69d]

	More on updating the expected XML structure in xlsx contexts.


2020-01-08  Kohei Yoshida  <kohei.yoshida@gmail.com>  [2af9df2f5bedfc63cbbd6e0b29802bf620589aa4]

	Always allow markup compatibility related elements.


2020-01-08  Kohei Yoshida  <kohei.yoshida@gmail.com>  [6bf51b2d6a3d81f28a6011b38f9332db681bde10]

	Update the OOXML tokens list to include OOXML MC tokens.


2020-01-08  Kohei Yoshida  <kohei.yoshida@gmail.com>  [ac58a5d0302986a3f0b070280efb93224dd64469]

	Allow extra tokens to be added to the list.

	This is to add the extra token names used by OOXML markup compatibility
	and extensibility framework.

2020-01-08  Kohei Yoshida  <kohei.yoshida@gmail.com>  [47cb4dc2ac3bd0b7967e692a42d029d163808033]

	Turns out I don't make use of schema types.


2020-01-08  Kohei Yoshida  <kohei.yoshida@gmail.com>  [f8e6e5e8deb4184dc8c7756de1eba20c6f9c8ee5]

	Update this python code to today's standard, in full on Python 3.


2020-01-08  Kohei Yoshida  <kohei.yoshida@gmail.com>  [8b8f4c290088193da8835fe7ed4cb78eee24ff93]

	Let's be explicit about the namespaces.


2020-01-08  Kohei Yoshida  <kohei.yoshida@gmail.com>  [41b5ddbd8179f25e5a9857ac38f4b66de6952981]

	cfRule may contain a formula element.


2020-01-08  Kohei Yoshida  <kohei.yoshida@gmail.com>  [d7ed99bbac03897e99dab4e7fbf4e95c234676b0]

	Update the expected parent element rules.

	cxnSp element represents a connection shape.

2020-01-06  Kohei Yoshida  <kohei.yoshida@gmail.com>  [9b5592fde0ec5f03ef04caa2070944d66d5a643c]

	Add another test case for python ods API.


2020-01-06  Kohei Yoshida  <kohei.yoshida@gmail.com>  [166c43c323017f62f9b99627305cd2f09ef57345]

	Add more test cases for the Python API on xlsx.


2020-01-06  Kohei Yoshida  <kohei.yoshida@gmail.com>  [2c7a7ca0145f82e8e3106d93101408bb804bac45]

	Make sure the test documents load fine without recalc turned on.


2020-01-06  Kohei Yoshida  <kohei.yoshida@gmail.com>  [45a39e0b85dd3ba22b376618e764cbacea17a68a]

	Enable Git LFS.


2020-01-06  Kohei Yoshida  <kohei.yoshida@gmail.com>  [e091bddd728acaf434ea8b0e90e5fb7f5a80f5b5]

	Set dummy cached results for array formulas when not doing recalc.


2020-01-06  Kohei Yoshida  <kohei.yoshida@gmail.com>  [65d5c4d2a46f31cebba2642f4504f211f2389f8e]

	Add variant of set_grouped_formula() that takes cached results.


2020-01-06  Kohei Yoshida  <kohei.yoshida@gmail.com>  [871853b4770b277103f3e0b8898ce101c94f7831]

	Let's not forget to handle the result value here too.


2020-01-06  Kohei Yoshida  <kohei.yoshida@gmail.com>  [2412f96e5ceb9457b407ea1b5e3f9ceb73eb4647]

	Tiny cleanup.


2020-01-03  Kohei Yoshida  <kohei.yoshida@gmail.com>  [43c9bfaabd911cb41ecd43aa6fef47f3dd8a9b9b]

	Add a 'recalc' argument to python's read() function for all format types.

	It's optional and False by default.  The current test code has to set it
	to True in order for some of the python unit test cases to pass.

2020-01-03  Kohei Yoshida  <kohei.yoshida@gmail.com>  [291300d00b76a8e97ef35a5ec0744a128f04b43f]

	Prepare for parsing multiple arguments from python's stream read function.

	For now it's still handling the only argument that is 'stream'.

2020-01-03  Kohei Yoshida  <kohei.yoshida@gmail.com>  [c3600293b2ee0e9dafa604269622c7ecdc6979ab]

	The correct place to set the recalc mode on.

	This is in line with what the CLI versions do.

2020-01-03  Kohei Yoshida  <kohei.yoshida@gmail.com>  [fe5567faa69442222f53ad58239b11e24ba9d373]

	Re-word the method doc.


2020-01-03  Kohei Yoshida  <kohei.yoshida@gmail.com>  [1fea71f26fe2a52c0c57437989665bcfbf03b665]

	recalc_formula_cells() do not need to be virtual.


2020-01-03  Kohei Yoshida  <kohei.yoshida@gmail.com>  [896f4d91ae207f231d8e45a97cfbeff4dc9691c8]

	Move the recalc-on-load flag to the import factory class.


2020-01-03  Kohei Yoshida  <kohei.yoshida@gmail.com>  [40560c08fc2de7b5e85284f42240d684e017bc87]

	Prepare for setting formulas with cached results.

	And up the required ixion API version to 0.16 going forward.

2020-01-03  Kohei Yoshida  <kohei.yoshida@gmail.com>  [483e96aae13bd6d2e3b152eef78d44220cc38340]

	We definitely broke API compat. Up the API version.

	It's based on what `git diff -r 1.5.3 -- include` says.

2020-01-03  Kohei Yoshida  <kohei.yoshida@gmail.com>  [68d0e25e73e019b229aabaee221bac01e7dcf939]

	Up the required ixion version & set the version up to 0.15.99.


2020-01-03  Kohei Yoshida  <kohei.yoshida@gmail.com>  [dd9b13ab30cd2661e8602c91281d71974c12270f]

	We don't need this extra flag as a loader configuration option.

	It's strictly an option with the document store, and the loader should
	only focus on importing formula cell contents as stored in the file.

2020-01-03  Kohei Yoshida  <kohei.yoshida@gmail.com>  [5533905cae4bbd524723fc5cba83d3e78467b3c9]

	Make the recalculation of formula cells off by default.


2020-01-03  Kohei Yoshida  <kohei.yoshida@gmail.com>  [a19030ac2a752998a83bb7436524341b08601135]

	Let's make this flag a boolean type.

	Not sure why I used uint16_t originally, but seems to make little sense.

2020-01-03  Kohei Yoshida  <kohei.yoshida@gmail.com>  [af736e5884494715a662fde697b2b96af5692bd9]

	Introduce a recalc-on-load option. Not used yet.


2019-12-20  Kohei Yoshida  <kohei.yoshida@gmail.com>  [5f1f1f942fc22d5c0f2a07847c7a7f0dbc2cb076]

	Print ratios only when the total > 0.


2019-12-20  Kohei Yoshida  <kohei.yoshida@gmail.com>  [419ad871c484bc4c428526b160ad5ebcb27e860e]

	Handle documents containing DDE links.


2019-12-20  Kohei Yoshida  <kohei.yoshida@gmail.com>  [175e097f7757e7cff5ba2b4edd8ff2af4101399b]

	table:table-column can occur under table:table-header-columns.


2019-12-20  Kohei Yoshida  <kohei.yoshida@gmail.com>  [f277f9433f40df8724e1fcb59a36b813cd667b6b]

	table:table-row can occur under table:table-header-rows.


2019-12-20  Kohei Yoshida  <kohei.yoshida@gmail.com>  [43429a2acf4da9c00b0cc8584fdc87db1676ee17]

	Correctly handle file names with spaces in them.


2019-12-20  Kohei Yoshida  <kohei.yoshida@gmail.com>  [b5c6d7ab7ca06b250f7cafa0b7bb57f130dd4a4c]

	text-properies may occur under text:list-level-style-bullet too.


2019-12-20  Kohei Yoshida  <kohei.yoshida@gmail.com>  [b1668ffdb150f8dbef98598999f3e8f374d8390e]

	text-properies may occur under text:list-level-style-number.

	But let's not handle it in such cases just yet.

2019-12-20  Kohei Yoshida  <kohei.yoshida@gmail.com>  [669275c2ed423e1e5f1ddaee371e770820aaf26d]

	Add separate method for handling text-properties element.


2019-12-20  Kohei Yoshida  <kohei.yoshida@gmail.com>  [105721af0a2782932b2e2f661107274a9389fb78]

	table:column and table:row can occur under table:table-column-group and table:table-row-group.


2019-12-20  Kohei Yoshida  <kohei.yoshida@gmail.com>  [bffaed71aded56cfab6174a77430fc65c7afef85]

	Use bool_switch to handle boolean flags.


2019-12-19  Kohei Yoshida  <kohei.yoshida@gmail.com>  [c7fc7ff7fe746257ff17ae549daf84d7577153ad]

	Prevent exception here.


2019-12-19  Kohei Yoshida  <kohei.yoshida@gmail.com>  [0652056d3b899cc9dbf43f0e409d1699c8193e47]

	Re-org slickedit workspace structure and add python and shell scripts.


2019-12-18  Kohei Yoshida  <kohei.yoshida@gmail.com>  [f3b2401c30574c7eb68bf292a7d2c40b1523e413]

	Add option to display some simple stats of the results.


2019-12-18  Kohei Yoshida  <kohei.yoshida@gmail.com>  [8276274b896b980e660767d62b21535e834decb4]

	Add option to remove result files from a directory tree.


2019-12-18  Kohei Yoshida  <kohei.yoshida@gmail.com>  [0dee2bae66ef8f8f9b2bae0d2fdad5d173eed219]

	Fix run-python.sh to correctly pass arguments to executable.


2019-11-25  Kohei Yoshida  <kohei.yoshida@gmail.com>  [7d65474b3e5dd1aa8e8cf2bda30b07b286696142]

	Use the name resolver owned by the document.

	Now all tests do pass.

2019-11-25  Kohei Yoshida  <kohei.yoshida@gmail.com>  [0244ee76d696bf797d4f3de8317631df9a93438f]

	Store formula expression strings in sheet_rows objects.

	TODO: test/python/xls_xml.py still fails. I'll fix this later.

2019-11-25  Kohei Yoshida  <kohei.yoshida@gmail.com>  [37f4c910268834982b09e9b0f5035c9a9732dca4]

	Include cell types when iterating over sheet cells via Python API.


2019-11-22  Kohei Yoshida  <kohei.yoshida@gmail.com>  [91c51ebe1152f40bafdf1cdfcf2380f6e8785a8f]

	Add a mechanism to parse and display the results of processed files.


2019-11-22  Kohei Yoshida  <kohei.yoshida@gmail.com>  [b19a5c4a5c11730b9c48d2c23b9cda44a9257bf2]

	Capture and cache the results of file processing.


2019-11-20  Kohei Yoshida  <kohei.yoshida@gmail.com>  [9f5a366ef15abd6db13ddce1103900da598394e6]

	Add file count to its output.


2019-11-20  Kohei Yoshida  <kohei.yoshida@gmail.com>  [a705557292695ebca3399837dc26c2adb62b275d]

	Sometimes the count attribute is not present.

	In which case, let's not set the count value to avoid segfault.
	This resolves #102.

2019-11-20  Kohei Yoshida  <kohei.yoshida@gmail.com>  [2babdbbf7fc59015c4ec6b4892bf28a6be8dd709]

	More on properly managing object's references.


2019-11-19  Kohei Yoshida  <kohei.yoshida@gmail.com>  [32de9c6e36a408476bfd27687d3d53e56b137227]

	Stop another memory leak, for the same reason as the previous one.


2019-11-19  Kohei Yoshida  <kohei.yoshida@gmail.com>  [8e2bf85e492497d376869d3b07272f7bbf10d537]

	Stop memory leak.

	Turns out PyTypeObject.tp_new returns a new object with ref count of
	1.  No need to increment its ref count before returning it to the caller.

2019-11-19  Kohei Yoshida  <kohei.yoshida@gmail.com>  [5efa585de8b2a8f5180f6cc63f82f2e8f04c3676]

	Add a test case for the threaded sax parser.

	This one covers a use case where an exception gets thrown in the
	main thread.

2019-11-19  Kohei Yoshida  <kohei.yoshida@gmail.com>  [67098c70a27db3455d371c35da1b7e198aacfa24]

	Abort the parsing thread when the main thread throws an exception.


2019-11-19  Kohei Yoshida  <kohei.yoshida@gmail.com>  [ec768684aaa7c80329dd2a259b622952f28d6c58]

	Turn the parsing state from boolean to tri-state.

	To introduce an abort state.

2019-11-19  Kohei Yoshida  <kohei.yoshida@gmail.com>  [480da2bc87caad82eca0df71a61b2e7d281b9f59]

	Process parse error tokens and add a test case for it.


2019-11-19  Kohei Yoshida  <kohei.yoshida@gmail.com>  [97400cf0ee524251ba47db6f44643d94776e1537]

	Catch and tokenize parse error exceptions.


2019-11-18  Kohei Yoshida  <kohei.yoshida@gmail.com>  [baf9d57db281961598964a9ac66b57dc0ec83a2f]

	Call ixion::init() only once per process.


2019-11-15  Kohei Yoshida  <kohei.yoshida@gmail.com>  [0be01f52df54c972bd2d9e37cea54ed14237aa46]

	Don't forget to initialize ixion.


2019-11-15  Kohei Yoshida  <kohei.yoshida@gmail.com>  [91467b2a4d0944372db941683a8cf261959220c6]

	Display the exception name.


2019-11-15  Kohei Yoshida  <kohei.yoshida@gmail.com>  [fee0b10900d32833efe8b41fd04af91af2145aa4]

	Catch exception and keep going.


2019-11-15  Kohei Yoshida  <kohei.yoshida@gmail.com>  [e8ab49ea0330991d118320593afc89b651eb35ae]

	Catch C++ exception and translate it to a python one.


2019-11-14  Kohei Yoshida  <kohei.yoshida@gmail.com>  [3a6a91248d2946e53100e83e1af26cb0a6815308]

	Load the document and dump its content.


2019-11-14  Kohei Yoshida  <kohei.yoshida@gmail.com>  [e39fce08e085606ea6cfbd0307727d7dba565d9d]

	Use std::unique_ptr to manage stream PyObject instances.


2019-11-14  Kohei Yoshida  <kohei.yoshida@gmail.com>  [5a392910badf1d10b8419f01c3db6ceb04f02e58]

	Let's not forget to delete the bytes object when finished.


2019-11-14  Kohei Yoshida  <kohei.yoshida@gmail.com>  [932d1344bf2e73f1f852d64372c4d55c45bcf7d9]

	Add orcus.detect_format python function & use it from process-files.py.

	Also, try to treat the object as bytes if possible, in case it's not a
	buffer object with read() method.

2019-11-14  Kohei Yoshida  <kohei.yoshida@gmail.com>  [facaa9b00815467b6d22ab4a2f8d1bcd09b42cbe]

	Recursively traverse files from a root directory.

	It's still a skeleton. More to come.

2019-11-13  Kohei Yoshida  <kohei.yoshida@gmail.com>  [b4107089e21e3aa106c92f4125f09013a807d639]

	Annotate the code a bit.


2019-11-12  Kohei Yoshida  <kohei.yoshida@gmail.com>  [1074b47d72561ca6783142ddd5a46d938c97e611]

	Use thread pool to speed up the fetching of the attachments.


2019-11-12  Kohei Yoshida  <kohei.yoshida@gmail.com>  [511b6e30e0ae4d0bef5eec6ff52478cb023b53ff]

	Abstract away the bugzilla URL, and add --limit parameter.


2019-11-12  Kohei Yoshida  <kohei.yoshida@gmail.com>  [153ddaf75a843884f45fbec393594047ecf7ed46]

	Manage to download the attachments for real.

	Also cache the response contents from the remote server, to prevent
	us from hitting it too frequently.

2019-11-11  Kohei Yoshida  <kohei.yoshida@gmail.com>  [a5afbefd3963f3e15a5f8e20d57682b8912fcb49]

	Start a script that uses TDF's bugzilla API to get a list of bug ID's.

	Eventually we want to download all attachments, but this is just a
	starter...

2019-11-11  Kohei Yoshida  <kohei.yoshida@gmail.com>  [af5a3d424efebcf61f3725e70dc14502fa7947f1]

	Remove now pointless wrapper scripts.

	Use libtool directly on the executables instead.

2019-10-09  Kohei Yoshida  <kohei.yoshida@gmail.com>  [15c02dd7f5c9f9e68e260cddf4c99b7dea5392bf]

	Add the URL's to the 0.15.3 packages.


2019-10-09  Kohei Yoshida  <kohei.yoshida@gmail.com>  [1a58f64290b2d1297728dcdc117085fbf312c95a]

	Fix make distcheck.


2019-10-09  Kohei Yoshida  <kohei.yoshida@gmail.com>  [2e3830798a727cefd826ee2d33ecdfb897db72e4]

	Up the version to 0.15.3.


2019-10-08  Kohei Yoshida  <kohei.yoshida@gmail.com>  [9f1bf9327520b1d738c77e8743c393f8f4737842]

	I think I'll just do a release next. Let's close the change log.


2019-10-08  Kohei Yoshida  <kohei.yoshida@gmail.com>  [a84c31bc78c28b5d110e2586a7e475be3182bc35]

	Add this to CHANGELOG.


2019-10-08  Kohei Yoshida  <kohei.yoshida@gmail.com>  [85edd04198e531797d978f4110d471059a9dbe96]

	Use the closest row group element as the anchor element.

	And finally add the latest test case to the list of auto-tested cases.

2019-10-08  Kohei Yoshida  <kohei.yoshida@gmail.com>  [710ced8945f3400695d8b73a93e61f333b7741b6]

	It's no longer necessary to track common range parent with data member.

	All of that happens only within the commit() call.  A local variable will
	do just fine.

2019-10-08  Kohei Yoshida  <kohei.yoshida@gmail.com>  [4b6c11295b037d20cf84881b1bad8a30d47df7a0]

	mp_cur_range_ref is no longer necessary.


2019-10-08  Kohei Yoshida  <kohei.yoshida@gmail.com>  [78a0258d470b3fe078ff5bd6ba64aa824c2f3e03]

	Pass the position to start_range(), and not pass it to the rest of the methods.

	The API looks a bit cleaner this way. Plus now it makes more sense.

2019-10-07  Kohei Yoshida  <kohei.yoshida@gmail.com>  [1ad2b4c173076b233c50553ed03d52f65f58d93a]

	Delay the insertion of range field links until the commit_range() call.

	This ensures that by the time we are ready to insert the range field
	links, all of the range row groups have been inserted.

2019-10-07  Kohei Yoshida  <kohei.yoshida@gmail.com>  [bbc53ea0bf38babc85c90b311e021ca2fb34b9ec]

	Add a test case that currently fails to work properly.


2019-10-07  Kohei Yoshida  <kohei.yoshida@gmail.com>  [3ad78536f1ac85e6b4d9818baf6f19a7e6e4b936]

	Add this item.


2019-10-07  Kohei Yoshida  <kohei.yoshida@gmail.com>  [c18ea901cb13909257951ecbf6282810294ec419]

	Create a shared header for all test codes.

	And globally disable NDEBUG so that assert gets triggered even in
	release builds.

2019-10-06  Kohei Yoshida  <kohei.yoshida@gmail.com>  [615ed37f46bb1e0c82610c6866a446680a6fb06d]

	Add this test file to the list of automatic test cases.


2019-10-06  Kohei Yoshida  <kohei.yoshida@gmail.com>  [3fb28d456c58004c0e94e4f82ef7f5a7ecfef69a]

	xls-xml: correctly handle table offset position.

	Pick up the following properties:

	  * ss:TopCell
	  * ss:LeftCell

	from each Table element which specify the top-left position of the
	table structure.

2019-10-06  Kohei Yoshida  <kohei.yoshida@gmail.com>  [86a37bce87727e440149c1d5d68e66e13fdcef91]

	New test file for xls-xml filter.

	This one originates from:
	https://bugs.documentfoundation.org/show_bug.cgi?id=118227

	and is slightly re-formatted for ease of read.

2019-08-29  Kohei Yoshida  <kohei.yoshida@gmail.com>  [7e08a01c20a9aa96dddd8b4717a4914c2e36fcb4]

	0.15.2 is now released & adjust the category names.


2019-08-28  Kohei Yoshida  <kohei.yoshida@gmail.com>  [5d77169f98b2422ca5855c0a289d8752dc5a0b74]

	Add links to the 0.15.2 packages.


2019-08-28  Kohei Yoshida  <kohei.yoshida@gmail.com>  [5219f48293980bc859a67164fc68e6ce7c9f619a]

	Fix make distcheck.


2019-08-28  Kohei Yoshida  <kohei.yoshida@gmail.com>  [a679bbae80c2422ce18805b2fdf4fd181c12f990]

	Update CHANGELOG.


2019-08-28  Kohei Yoshida  <kohei.yoshida@gmail.com>  [122b8e2645194110ea915c11511574e1e06d40f5]

	Let's test these named number formats for real.

	Also, replace a UTF-8 euro symbol with its escaped bytes.

2019-08-28  Kohei Yoshida  <kohei.yoshida@gmail.com>  [232719067350e715ba16bffc23771a91a941914d]

	Add more formats.


2019-08-28  Kohei Yoshida  <kohei.yoshida@gmail.com>  [022a476c2614aef22411db091dfe59f15ef64f52]

	No point having this entry since there would be no translation.


2019-08-28  Kohei Yoshida  <kohei.yoshida@gmail.com>  [3160df38b187cf93df73e38517ff345196bcf10c]

	Convert named number format values to their respective codes.

	This is related to #98.

2019-08-27  Kohei Yoshida  <kohei.yoshida@gmail.com>  [15afc33d99c2a15af3833fcc762829e20a2646b8]

	Update the CHANGELOG for 0.15.2 items.


2019-08-27  Stephan Bergmann  <sbergman@redhat.com>  [1c9b1c20cad59237377a27f9f87db63a6a700d1c]

	Comment the workarounds

	...added by a124e3b46f5430fa1c13c5500f3cad6ed147f068 "Blind fix attempt for
	older macOS builds", in case they can ever be removed again when building
	against old libc++ is no longer relevant.

	The underlying issue in libc++ should be fixed with <https://github.com/llvm/
	llvm-project/commit/292617e7003efdbc4dd84bc49423dc662f856fb6> "[libc++] Fix
	PR20855 -- libc++ incorrectly diagnoses illegal referenc…" since LLVM 7.

2019-08-26  Kohei Yoshida  <kohei.yoshida@gmail.com>  [0eeb11739d5f6d55ba8f610a6420e61b1ca44b77]

	Add a TODO comment as a future action item.


2019-08-26  Kohei Yoshida  <kohei.yoshida@gmail.com>  [06381b2971e5e5b3fa0707af075f6349d845274c]

	Work on picking up the number formats entries from xlsx.

	There is one issue; however, in that xlsx uses number format codes to
	identify the number format strings, whereas other style elements use
	ordering as the identifiers.  I need to think a bit about how to handle
	this...

2019-08-26  Kohei Yoshida  <kohei.yoshida@gmail.com>  [800615b0b51d09a8ff7f23701512367c40b84ad3]

	Set up a test case for xlsx import of number format strings.

	It currently fails.

2019-08-26  Kohei Yoshida  <kohei.yoshida@gmail.com>  [9a22b162b9733372eb698bc33d5212661e794be2]

	Add a first test case for importing number formats.

	Also make sure to intern the format strings before storing them.

2019-08-26  Kohei Yoshida  <kohei.yoshida@gmail.com>  [d2102e54c2515f24a1a566a83d73dd37bcba6952]

	Add method docs to clarify the roles of these methods.


2019-08-26  Kohei Yoshida  <kohei.yoshida@gmail.com>  [aed8b59ca5a27d4e90aab1d83da522725d0039ea]

	The conditions between can_handle_element() and create_child_context() ...

	... MUST be identical at all times.

2019-08-26  Kohei Yoshida  <kohei.yoshida@gmail.com>  [edca971c1077196f8fe768d1a61cd2628529bdc1]

	text/xml is also a valid mime type for XML documents.

	And according to google search, application/xml and text/xml are
	equivalent of each other.

2019-08-26  Kohei Yoshida  <kohei.yoshida@gmail.com>  [35735e090e10321b0d4d0c9499eb6b284cf0da71]

	Add test files for importing number format entries.


2019-08-26  Kohei Yoshida  <kohei.yoshida@gmail.com>  [3e6fd08a2228e72eb144a76207b8bd671161cf2d]

	xls-xml: pick up number format entries during import.

	Not tested yet.

2019-08-23  orbea  <orbea@riseup.net>  [8e984d774b4df960f61f4113956babf1515a8f5f]

	Fix build with gcc5.


2019-08-23  Kohei Yoshida  <kohei.yoshida@gmail.com>  [aaaec1b15725b8821907382fa30bb6fd00a9b53f]

	Probably this should be a top-level item, not a child of orcus-xml.


2019-08-23  Kohei Yoshida  <kohei.yoshida@gmail.com>  [2414012065fd3d49ed0fc2f79b5e04f6ef7aef6d]

	Up the version to 0.15.2.


2019-08-23  Kohei Yoshida  <kohei.yoshida@gmail.com>  [2272137abd48cf4777311640b3c760c4f1524c05]

	Add Stephan's bit.


2019-08-23  Stephan Bergmann  <sbergman@redhat.com>  [a124e3b46f5430fa1c13c5500f3cad6ed147f068]

	Blind fix attempt for older macOS builds

	...like <https://ci.libreoffice.org/job/gerrit_mac/40711/> (which builds with
	MacOSX10.13.sdk, but not sure with what Clang and libc++ versions):

	> In file included from xml_map_tree.cpp:8:
	> In file included from ./xml_map_tree.hpp:11:
	> In file included from ../../include/orcus/pstring.hpp:14:
	> In file included from /Applications/Xcode.app/Contents/Developer/Toolchains/XcodeDefault.xctoolchain/usr/include/c++/v1/string:470:
	> In file included from /Applications/Xcode.app/Contents/Developer/Toolchains/XcodeDefault.xctoolchain/usr/include/c++/v1/string_view:169:
	> In file included from /Applications/Xcode.app/Contents/Developer/Toolchains/XcodeDefault.xctoolchain/usr/include/c++/v1/__string:56:
	> In file included from /Applications/Xcode.app/Contents/Developer/Toolchains/XcodeDefault.xctoolchain/usr/include/c++/v1/algorithm:643:
	> In file included from /Applications/Xcode.app/Contents/Developer/Toolchains/XcodeDefault.xctoolchain/usr/include/c++/v1/memory:653:
	> /Applications/Xcode.app/Contents/Developer/Toolchains/XcodeDefault.xctoolchain/usr/include/c++/v1/tuple:227:10: error: static_assert failed "Attempted to construct a reference element in a tuple with an rvalue"
	>         {static_assert(__can_bind_reference<_Tp>(),
	>          ^             ~~~~~~~~~~~~~~~~~~~~~~~~~~~
	> /Applications/Xcode.app/Contents/Developer/Toolchains/XcodeDefault.xctoolchain/usr/include/c++/v1/tuple:385:13: note: in instantiation of function template specialization 'std::__1::__tuple_leaf<2, const orcus::pstring &, false>::__tuple_leaf<orcus::pstring, void>' requested here
	>             __tuple_leaf<_Uf, _Tf>(_VSTD::forward<_Up>(__u))...,
	>             ^
	> /Applications/Xcode.app/Contents/Developer/Toolchains/XcodeDefault.xctoolchain/usr/include/c++/v1/tuple:738:15: note: in instantiation of function template specialization 'std::__1::__tuple_impl<std::__1::__tuple_indices<0, 1, 2, 3, 4>, orcus::xml_map_tree &, const char *, const orcus::pstring &, orcus::xml_map_tree::element_type, orcus::xml_map_tree::reference_type>::__tuple_impl<0, 1, 2, 3, 4, orcus::xml_map_tree &, const char *, const orcus::pstring &, orcus::xml_map_tree::element_type, orcus::xml_map_tree::reference_type, orcus::xml_map_tree &, const char *&, orcus::pstring, orcus::xml_map_tree::element_type, orcus::xml_map_tree::reference_type>' requested here
	>             : __base_(typename __make_tuple_indices<sizeof...(_Up)>::type(),
	>               ^
	> xml_map_tree.cpp:216:13: note: in instantiation of function template specialization 'std::__1::tuple<orcus::xml_map_tree &, const char *, const orcus::pstring &, orcus::xml_map_tree::element_type, orcus::xml_map_tree::reference_type>::tuple<orcus::xml_map_tree &, const char *&, orcus::pstring, orcus::xml_map_tree::element_type, orcus::xml_map_tree::reference_type, false, false>' requested here
	>             element::args_type(
	>             ^
	> 1 error generated.
	> Makefile:1804: recipe for target 'liborcus_0.15_la-xml_map_tree.lo' failed
	> make[5]: *** [liborcus_0.15_la-xml_map_tree.lo] Error 1

	(while building orcus as part of LibreOffice).

	(Using "nm" instead of a more descriptive variable name "name" to avoid
	-Wshadow warnings like

	> xml_map_tree.cpp: In member function ‘orcus::xml_map_tree::element* orcus::xml_map_tree::element::get_or_create_child(orcus::xml_map_tree&, orcus::xmlns_id_t, const orcus::pstring&)’:
	> xml_map_tree.cpp:214:16: warning: declaration of ‘name’ shadows a member of ‘orcus::xml_map_tree::element’ [-Wshadow]
	>   214 |     auto const name = sp.intern(_name.get(), _name.size()).first;
	>       |                ^~~~
	> In file included from xml_map_tree.cpp:8:
	> xml_map_tree.hpp:126:17: note: shadowed declaration is here
	>   126 |         pstring name;
	>       |                 ^~~~

	)

2019-08-23  Kohei Yoshida  <kohei.yoshida@gmail.com>  [aa3a5fa62b188e8c7511ae3843c5896df97de8f6]

	Add this bug fix to CHANGELOG.


2019-08-23  Kohei Yoshida  <kohei.yoshida@gmail.com>  [c00bb21d96db956fd42253acd5e083f9168b91e3]

	Add a test case for this.


2019-08-23  Kohei Yoshida  <kohei.yoshida@gmail.com>  [d5e1cc2587c697cdbb440749f98a738402cf998e]

	Correctly identify the anchor element of a linked node.


2019-08-21  Kohei Yoshida  <kohei.yoshida@gmail.com>  [c1b7a2d97c4aa695952d7b52971a83aa68983c61]

	Add links to the 0.15.1 packages.


2019-08-21  Kohei Yoshida  <kohei.yoshida@gmail.com>  [83ee4f09e489010a1bc8dfbcd4011d2ccf279996]

	Add method doc to fill_down_cells().


2019-08-20  Kohei Yoshida  <kohei.yoshida@gmail.com>  [d1a7c6bfd64c6102ff4d59c253a743db6e8a04d3]

	Finish up CHANGELOG for the upcoming 0.15.1 release.


2019-08-20  Kohei Yoshida  <kohei.yoshida@gmail.com>  [865e660e33585c9ab1bd2aac6fe3b73927218a7f]

	linkable is a struct, not a class.


2019-08-20  Kohei Yoshida  <kohei.yoshida@gmail.com>  [f3538986f9ff18b5371a0ec8e049567b0c3b7f8e]

	Up the version to 0.15.1.


2019-08-20  Kohei Yoshida  <kohei.yoshida@gmail.com>  [b1fdb3d0f1f7165c047566b51bfbaf4dc530e882]

	Use object pool on range_reference as well. I think this is the last one.


2019-08-20  Kohei Yoshida  <kohei.yoshida@gmail.com>  [dd9f6ff67cb34897c3360a40c80bc3122fdcf6ab]

	Switch to using object_pool on element instances as well.


2019-08-20  Kohei Yoshida  <kohei.yoshida@gmail.com>  [2d887329526558fe3c3f75087831805120c0b111]

	Switch element constructor to using std::tuple.

	This is in preparation for using object pool on element.

2019-08-20  Kohei Yoshida  <kohei.yoshida@gmail.com>  [f1e8dc4c62ebd2bc5639347336d0948e6db321e9]

	Use object pool for attribute instances.

	One caveat is that boost::object_pool's construct() can only support up to
	3 arguments.  One workaround is to switch to using std::tuple to reduce
	the number of arguments to one then call construct() on that, which is exactly
	what I'm doing here.

2019-08-19  Kohei Yoshida  <kohei.yoshida@gmail.com>  [170c7893524e6244296f0e349002264ab2cd2394]

	get_or_create_child can now simply return the element pointer.


2019-08-19  Kohei Yoshida  <kohei.yoshida@gmail.com>  [05e12ad685594d3b8d517c9146b53e1b14c0522b]

	Move the reference data up into linkable, and clean up the code a bit.


2019-08-19  Kohei Yoshida  <kohei.yoshida@gmail.com>  [2bfd5f90bf7bab783dbf1e7e1cbc6b0a679ca7af]

	Refactor the linked element handling code for clarity.


2019-08-16  Kohei Yoshida  <kohei.yoshida@gmail.com>  [ba80955aeb32bb86ea8cc2765530bab9e0b51c87]

	Use object_pool for cell_reference and field_in_range instances as well.


2019-08-16  Kohei Yoshida  <kohei.yoshida@gmail.com>  [2b1417f6a2d5655c954204c126daf3524403a5e5]

	Use object_pool for element_store_type objects.


2019-08-15  Kohei Yoshida  <kohei.yoshida@gmail.com>  [5cbce8c9ada219f18c7a707a435b0574f6396693]

	Add some changes which will go into the next release (0.15.1 most likely).


2019-08-15  Stephan Bergmann  <sbergman@redhat.com>  [1e024e37c59574965e1b07bc5097c014d4625227]

	Fix linking of newly created element

	(see downstream <https://gerrit.libreoffice.org/#/c/77519/> "Fix linking of
	newly created element in liborcus 0.15.0")

2019-08-15  Kohei Yoshida  <kohei.yoshida@gmail.com>  [6a40c30658a8727d87ae0ac244c95d6e18dde75a]

	Sigh... Another typo.


2019-08-15  Kohei Yoshida  <kohei.yoshida@gmail.com>  [aa7a5e3f802d9e80c27147cea706927cb7e2be11]

	Let's mention the new required method in the import_sheet interface.


2019-08-15  Kohei Yoshida  <kohei.yoshida@gmail.com>  [6e4160af14491cabf4a018df6463161cf57b25a6]

	Fix a typo.  So much intern() calls affect my English spelling.


2019-08-15  Kohei Yoshida  <kohei.yoshida@gmail.com>  [4c12dc4e02d824c81dce401f8aba76b1cae3e92c]

	Add the 0.15.0 tag line.  That version is out in the wild now.


2019-08-14  Kohei Yoshida  <kohei.yoshida@gmail.com>  [56514d538a0b018e910ce4d0f134bfb38a5f82b9]

	Unused private member.


2019-08-14  Kohei Yoshida  <kohei.yoshida@gmail.com>  [1b11a47a3681015afda7f04b21f798e416ed6a84]

	Let's not forget the override keyword here...


2019-08-14  Kohei Yoshida  <kohei.yoshida@gmail.com>  [fff0bdf3b9d214d4e406f91d085f38d4a372f389]

	Properly initialize these values, and keep valgrind memcheck happy.


2019-08-13  Kohei Yoshida  <kohei.yoshida@gmail.com>  [32ff7b049033ab6b40ebfe7f900df29bfddb27e8]

	element.child_elements is valid only for unlinked element type.


2019-08-13  Kohei Yoshida  <kohei.yoshida@gmail.com>  [edfa29e40a7d1b937f95d66e35ceff4d73e71ebb]

	Really kill orcus-xml-dump.


2019-08-13  Kohei Yoshida  <kohei.yoshida@gmail.com>  [1846f57da57794abe3e64d447f8d5611a279a37c]

	Let's use volatile keyword here too.  It's a simpler solution.

	This reverts commit 00e1d67350e7d85c05e8b1f8f49a265af78f85e3, and add
	volatile keyword to prevent aggressive compiler optimization.

2019-08-13  Kohei Yoshida  <kohei.yoshida@gmail.com>  [6698019746b562b173cf1bb849e4e85fb0044461]

	Use of volatile keyword here fixes the test failure on 32-bit debian.

	Perhaps the compiler is too aggressive on optimizing the double values
	causing the equality check to fail?

2019-08-13  Kohei Yoshida  <kohei.yoshida@gmail.com>  [a55f15cb9fd63a9b37e2c181c57e90c570292948]

	Use std::deque here to avoid strange segfault issue on 32-bit debian...

	The original code (with vector) for some reason crashes only on 32-bit
	debian platforms.  No such issue with deque.

2019-08-13  Kohei Yoshida  <kohei.yoshida@gmail.com>  [00e1d67350e7d85c05e8b1f8f49a265af78f85e3]

	Use a more reliable method to compare two double-precision values.

	This hits especially hard on 32-bit platforms.

2019-08-08  Kohei Yoshida  <kohei.yoshida@gmail.com>  [7306fdbc47574bfdff4341e69173447c45148341]

	Add links to the 0.15.0 packages.


2019-08-08  Kohei Yoshida  <kohei.yoshida@gmail.com>  [cac3852073f54d14a8fae0b6cd03e4e79df66df8]

	Up the version to 0.15.0.


2019-08-08  Kohei Yoshida  <kohei.yoshida@gmail.com>  [65797dc173272a1ee1a4dc7be24cbf80e595d0fe]

	Populated CHANGELOG based on the tickets tucked under 0.15.0 milestone.

	I hope I got everything here...

2019-08-08  Kohei Yoshida  <kohei.yoshida@gmail.com>  [bd1d8bad33dd22daa8922b38068877e5a9241d44]

	Update AUTHORS.


2019-08-06  Kohei Yoshida  <kohei.yoshida@gmail.com>  [b67e82d9b2908dff7f6e82d4fb93e4d775ffdc39]

	Flattern the code a bit by reversing logic.


2019-08-06  Kohei Yoshida  <kohei.yoshida@gmail.com>  [97eba52b4dd448345a6f6687333e3a0e9fce9a30]

	Share the logic of output stream creation between orcus-json and orcus-xml.


2019-08-06  Kohei Yoshida  <kohei.yoshida@gmail.com>  [f8347e9d89d14c9cf3fadcb0a4dccd3952ffa080]

	Move the orcus-xml-dump functionality into orcus-xml.

	This addresses #96.

2019-08-05  Kohei Yoshida  <kohei.yoshida@gmail.com>  [93a52be3507622a71f8c65d6aae769bbae41ec43]

	Fix make distcheck.


2019-08-05  Kohei Yoshida  <kohei.yoshida@gmail.com>  [d3db6695e02d61ce4b565f4e9ffb3d491a9f980f]

	Add json-map-tree-test to cmake.


2019-08-05  Kohei Yoshida  <kohei.yoshida@gmail.com>  [42e4550aa3bd3424cec0a320e33098e7e9113cee]

	Add another test case that contains multiple ranges and row-groups.


2019-08-05  Kohei Yoshida  <kohei.yoshida@gmail.com>  [e59e9763d1f5c0785f60467db01461eaadd35a67]

	Two more test cases.


2019-08-05  Kohei Yoshida  <kohei.yoshida@gmail.com>  [f775a0f4aa609d9d32612729e907c40e656f3dcd]

	Add the first test case.


2019-08-02  Kohei Yoshida  <kohei.yoshida@gmail.com>  [87c768a0cf67874a2e4cb573215f4d0381f44154]

	Ignore this artifact.


2019-08-02  Kohei Yoshida  <kohei.yoshida@gmail.com>  [91eaeccec82845b72e5ae08d2be63ac077e7f706]

	Be explicit about where to put an inline file.


2019-08-02  Kohei Yoshida  <kohei.yoshida@gmail.com>  [22a7d0adbe8ea3526d41769f9a9e12806922affc]

	Remove a compiler warning with MSVC.


2019-08-02  Kohei Yoshida  <kohei.yoshida@gmail.com>  [629b50ab1380b0d87fb690ac3020476856ea4aaf]

	Fix the check target for cmake build.


2019-08-02  Kohei Yoshida  <kohei.yoshida@gmail.com>  [d3f0a34788f3825c461d1944aa697f4f0c467dab]

	Potentially skip whitespace chars before and after the '=' of an attr.

	This fixes #95.

2019-08-02  Kohei Yoshida  <kohei.yoshida@gmail.com>  [ac171c352dd78ae102fbf55eda124ab55dec1cdf]

	Add a test case that currently fails.  This is related to #95.


2019-08-01  Kohei Yoshida  <kohei.yoshida@gmail.com>  [f9f5d9efb17dc3dd0d7e49c5ccee2ca48e58aa62]

	Add header files to cmake scripts & add API version to libs.


2019-08-01  Kohei Yoshida  <kohei.yoshida@gmail.com>  [82100a7717e0b011a70000e76597f435a6fd054b]

	Add install targets.


2019-08-01  Kohei Yoshida  <kohei.yoshida@gmail.com>  [ae96775517543c6560357dbf5e9aac0c0715471d]

	Add all cmake scripts to slickedit workspace.


2019-08-01  Kohei Yoshida  <kohei.yoshida@gmail.com>  [4cb0de2f8c939edb793a1e39dff4a4d820f9afc9]

	Spaces to indent, not tabs.


2019-08-01  Kohei Yoshida  <kohei.yoshida@gmail.com>  [dd272345e22038d1c668b19fe236b1af7c0f4883]

	Let's just use auto here...  I think I'm justified.


2019-08-01  Kohei Yoshida  <kohei.yoshida@gmail.com>  [614e9cfa6bfac2a690520a278c8ff59390db6a60]

	Add test cases for orcus_xls_xml::read_stream(...)...

	... in order to make sure that the automatic conversion to utf-8
	still works via read_steam() as well.

2019-08-01  Kohei Yoshida  <kohei.yoshida@gmail.com>  [6609c69ba6db499a089447dff7c3ce9167f01fbc]

	Implement memory_content class to represent in-memory content.

	This one is similar to pstring, but differs in that it can handle
	conversion of stream encoding to utf-8.

2019-08-01  Kohei Yoshida  <kohei.yoshida@gmail.com>  [f9aabfddb0d7c88a8d8120d23743452f5ff7a88f]

	Move the impl of read_stream() to the impl class.


2019-08-01  Kohei Yoshida  <kohei.yoshida@gmail.com>  [e179075cc8f6e0dc1ee7ac6aa6db7f9d52710168]

	Modernize it a bit.


2019-08-01  Kohei Yoshida  <kohei.yoshida@gmail.com>  [d56fb140d211c2800c0da3970721ae46d18be177]

	Use separate object pool to manage node instances, and store their pointers.


2019-07-31  Kohei Yoshida  <kohei.yoshida@gmail.com>  [4e2a10b95a9efd11ecd4d2e0a3975e0e53edd2fe]

	Get orcus to build on Windows (with cmake).

	MSVC's std::deque apparently cannot work with forward-declared types, but
	std::vector works fine.

2019-07-31  Kohei Yoshida  <kohei.yoshida@gmail.com>  [998570d2a1ede145da54baef2026add211d540dc]

	Remove dump-check mode. This is now handled as output format type.

	Also enhance the descriptions of the output formats.

2019-07-31  Kohei Yoshida  <kohei.yoshida@gmail.com>  [f0c64a7f0b26021a73f77dcb0f200cbf4936ea71]

	No need to do this check here.

	All necessary checks on the output file/directory are now done within
	document::dump().

2019-07-31  Kohei Yoshida  <kohei.yoshida@gmail.com>  [c83e61c1628410181a52439025a69e31b12bb868]

	Move the structure dumping code into a separate function.


2019-07-31  Kohei Yoshida  <kohei.yoshida@gmail.com>  [8c9b7d67e54d59bc06c8dc57798905f1f35e8371]

	Rename dump-document to map.

	Also fix inproper error message when the output format is not specified.

	This is related to #93.

2019-07-31  Kohei Yoshida  <kohei.yoshida@gmail.com>  [75835dc64092f405b6a94883e82dcb3e08813d1b]

	Rename xml-structure to just structure.

	Related to #93.

2019-07-30  Kohei Yoshida  <kohei.yoshida@gmail.com>  [671285dc5e15f3e202ba1d587929a2b506e1093a]

	Make sure we throw an invalid_map_error on parsing invalid map file.

	This is also in line with how it works in orcus_json.

2019-07-30  Kohei Yoshida  <kohei.yoshida@gmail.com>  [2a1a0eca6beb4d1c16f060a674ec994139f1f533]

	Let's call it just 'path', not 'xpath'.

	This is also to make it inline with json mapping.

2019-07-30  Kohei Yoshida  <kohei.yoshida@gmail.com>  [e8994e2cc787169db4bcceed9f09abebadaae209]

	Simplify the code a bit.


2019-07-30  Kohei Yoshida  <kohei.yoshida@gmail.com>  [47665a5d61135de08810add9ae7c7b642e227a0e]

	Move the code that reads XML map file into orcus_xml as a new method.

	This is in line with how orcus_json class is structured.

2019-07-30  Kohei Yoshida  <kohei.yoshida@gmail.com>  [69d08a4115f086bf9725f0d11d5a5c71e4387cf1]

	Add method docs for json::structure_tree::walker.


2019-07-30  Kohei Yoshida  <kohei.yoshida@gmail.com>  [92d6a98ab99d0a928da3e22d4475eb24c23d3727]

	Ensure that the row group nodes are always of array type.


2019-07-30  Kohei Yoshida  <kohei.yoshida@gmail.com>  [33592c6b0c210ae43a52e0506c853898d941d1bd]

	Rename the method and bind it to row-group nodes.


2019-07-29  Kohei Yoshida  <kohei.yoshida@gmail.com>  [5e66d16d5fa55b4fc79b6a192141c4e0ed9e291c]

	Better exception message in node::push_back().


2019-07-27  Kohei Yoshida  <kohei.yoshida@gmail.com>  [a411025f8baa91030bdf36283496d664b25ef613]

	Finally implement map file generation.


2019-07-26  Kohei Yoshida  <kohei.yoshida@gmail.com>  [a8e0c46a4cdb54bbe1c90f1e7143e598aa914094]

	Perhaps better to use a separate "implicit array" type to handle ...

	... implicit array values, and leave the real array type alone.

2019-07-26  Kohei Yoshida  <kohei.yoshida@gmail.com>  [3b9df72733910fe23deab80f28e4af5b58d791bf]

	Fix a bug in json::document_tree wrt empty array initialization.

	And add a test case to go with it.

2019-07-26  Kohei Yoshida  <kohei.yoshida@gmail.com>  [9c8ded7aab7de03268abd4bfb7c284607c9b80b7]

	Set up a hook for writing a JSON map file for map-gen mode.

	Still WIP.

2019-07-26  Kohei Yoshida  <kohei.yoshida@gmail.com>  [2a29a924d598a02f720cee670a140ebfb1787b7e]

	Make the range detection code a function of structure_tree.


2019-07-26  Kohei Yoshida  <kohei.yoshida@gmail.com>  [f879d7b05db896083589cc987207fd088fca7c33]

	Remove unused data members.


2019-07-26  Kohei Yoshida  <kohei.yoshida@gmail.com>  [129aee647be4f293b1601b36883942e9f963f10f]

	Add a hook for new 'map-gen' mode. Implementation will come later.


2019-07-25  Kohei Yoshida  <kohei.yoshida@gmail.com>  [8dc0f2573a09d5f1ae819a0afe2e78e3c0dc4903]

	Move structure_mapper so that it can be re-used.

	Also, abstract out the range handling code and have the caller provide
	it instead.

2019-07-25  Kohei Yoshida  <kohei.yoshida@gmail.com>  [a233fe8afd17dedbf6d27fcc33d133817f958464]

	Move the map definition rule detection code inside orcus_json.


2019-07-25  Kohei Yoshida  <kohei.yoshida@gmail.com>  [9fff3abb7e9f4d88dcea10fc7460f2b1038f1275]

	Import the detected ranges for real.

	So far it works well enough for the input files I've tested with.

2019-07-24  Kohei Yoshida  <kohei.yoshida@gmail.com>  [66156a03c0ceba27a7d36bedbe3d195360bddb1c]

	Pave the way for pushing linked ranges.


2019-07-24  Kohei Yoshida  <kohei.yoshida@gmail.com>  [d6045974a5e3e26ede50210ab32b1076ab55d80a]

	Slightly better wording.


2019-07-24  Kohei Yoshida  <kohei.yoshida@gmail.com>  [bf3520039b2c10d3f583ce5973a4aa54a3683e59]

	Fix the row-group path generation logic.


2019-07-24  Kohei Yoshida  <kohei.yoshida@gmail.com>  [c9c4a53bdcd103dc0600a38157787db4c6a6f524]

	Fix the field path construction logic.

	We shouldn't skip the root node; instead, we should skip the array
	that is an immediate parent of the value.

2019-07-24  Kohei Yoshida  <kohei.yoshida@gmail.com>  [34e1ab1db3ceaa8e461f26649fc1c878e89beeb9]

	One misplaced closing brace...


2019-07-24  Kohei Yoshida  <kohei.yoshida@gmail.com>  [a98f41283584b9f64d8fd6079fc52f0e26aeb463]

	Implement the logic of generating all necessary map paths.

	So far only tested with JSON with arrays.

2019-07-24  Kohei Yoshida  <kohei.yoshida@gmail.com>  [548cb119905ec6ea869607796529afa0ba488f12]

	Annotate some data members of the structure node.


2019-07-24  Kohei Yoshida  <kohei.yoshida@gmail.com>  [2eae900761427dc4d282673914b406579b095dc3]

	Wrong naming convention...


2019-07-23  Kohei Yoshida  <kohei.yoshida@gmail.com>  [91f9feb9aab7464cc06f314e3e8f652369f03917]

	Add another test case for json structure output.


2019-07-23  Kohei Yoshida  <kohei.yoshida@gmail.com>  [af7008ce1ea4ef00f6108b58e7a654463f40557c]

	json structure tree to keep track of array positions of value nodes.

	An array position of a value node is recorded in the structure tree
	only when that position always contains a value node and never a node
	of non-value type.

2019-07-23  Kohei Yoshida  <kohei.yoshida@gmail.com>  [79c475d1cc131c99968d1170adbaa4e99a531325]

	Use a class to keep track of some traversal state.


2019-07-22  Kohei Yoshida  <kohei.yoshida@gmail.com>  [ec9ab5a642eb933d73a8e7738c2e19678b4fbab3]

	Code the basic logic of traversing through the structure tree.


2019-07-22  Kohei Yoshida  <kohei.yoshida@gmail.com>  [35c61f9c6ab98ff38f1b02658c90723468ba045f]

	Start setting up a way to traverse the structure tree.

	Still WIP.

2019-07-22  Kohei Yoshida  <kohei.yoshida@gmail.com>  [c13f0e5475ac1fe69e5ba4eb436aef840558c557]

	Set up a hook for automatic mapping.

	It gets invoked when the user specifies a map mode without an explicit
	map file path.

2019-07-22  Kohei Yoshida  <kohei.yoshida@gmail.com>  [bd1e7c6696472f7b55fb3f9f57c014e64e47c98c]

	Let's not forget a line break at the end.


2019-07-19  Kohei Yoshida  <kohei.yoshida@gmail.com>  [d153ea4c254f7454a2fd9a1a27df8f51cd62152a]

	Don't forget to call finalize().


2019-07-19  Kohei Yoshida  <kohei.yoshida@gmail.com>  [778703f49df7e838b5967d61ea9121d84c10b42f]

	Add the ability to specify custom field labels.


2019-07-19  Kohei Yoshida  <kohei.yoshida@gmail.com>  [f55ab1e05158adbbb86a169636c464a6384af31d]

	New test case for importing array of arrays with header labels.


2019-07-19  Kohei Yoshida  <kohei.yoshida@gmail.com>  [06b4a44f323e793a08c40045e02e5aec6a267c08]

	Read the row-header attribute from the map file and make use of it.

	Also add a test case for this.

2019-07-18  Kohei Yoshida  <kohei.yoshida@gmail.com>  [85e20916a5f9681396de982789be98f124d55d73]

	Pick up the last object key value, and use if as the field label.

	If that field is associated with an object key that is.

2019-07-18  Kohei Yoshida  <kohei.yoshida@gmail.com>  [e9faff9b90c04b52381111c1e471715a2e7d7e5b]

	Const correctness.


2019-07-18  Kohei Yoshida  <kohei.yoshida@gmail.com>  [f955248ed111d2e9bf762ce6bce59415538239ab]

	We don't really need direct access to the nodes that fields belong to.


2019-07-18  Kohei Yoshida  <kohei.yoshida@gmail.com>  [75812aadf9f2ffa2b609475868adde20e1ec1fa6]

	Add the logic of inserting row headers for linked ranges.

	It's not turned on yet.

2019-07-17  Kohei Yoshida  <kohei.yoshida@gmail.com>  [7bf1b1165c4aca8c1e1e85751b3955b41f813f9e]

	How about this?


2019-07-17  Kohei Yoshida  <kohei.yoshida@gmail.com>  [545ebb279ba10920b23d0fde0cc93924ea7438e7]

	Another try.


2019-07-17  Kohei Yoshida  <kohei.yoshida@gmail.com>  [c4af63f3ea9d053d9804e55981f4466719d379b1]

	Remove this.  This is no longer needed.


2019-07-17  Kohei Yoshida  <kohei.yoshida@gmail.com>  [751f92468eaad544e43051a5099682d53bdaacc8]

	Revert "Try to query the distro name."

	This reverts commit 4f318070c57fa2d498284531d7dc635b37d4922e.

2019-07-17  Kohei Yoshida  <kohei.yoshida@gmail.com>  [4f318070c57fa2d498284531d7dc635b37d4922e]

	Try to query the distro name.


2019-07-17  Kohei Yoshida  <kohei.yoshida@gmail.com>  [e71a600d640ff51db009857c88979bdcb1bdfaa9]

	Move odf-styles-context-test from src/liborcus to src.

	If you get build issues, be sure to nuke the .deps directories and
	re-run configure.

2019-07-17  Kohei Yoshida  <kohei.yoshida@gmail.com>  [61feccca10d201b25d27a0334453396f3956170d]

	Empty array can happen.


2019-07-17  Kohei Yoshida  <kohei.yoshida@gmail.com>  [c5a217875c966bd89d31dc9f0cbb102fdfac8342]

	Trynig to figure out the base distro for this runner.


2019-07-17  Kohei Yoshida  <kohei.yoshida@gmail.com>  [5c1179a72ef9790ccc4b092812cdbec5c04da74b]

	Maybe I need to specify -8 (?)


2019-07-17  Kohei Yoshida  <kohei.yoshida@gmail.com>  [b077114e31266f120aa91caf481e07cce2260767]

	Put gfortran first.


2019-07-17  Kohei Yoshida  <kohei.yoshida@gmail.com>  [536d3580797ac8a598fef851515785eecfe162d5]

	Not git, but apt.


2019-07-17  Kohei Yoshida  <kohei.yoshida@gmail.com>  [46c521ce775c8d0e398423d8dec036d449524faf]

	Let's see what happens if I try to install gfortran separately...


2019-07-17  Kohei Yoshida  <kohei.yoshida@gmail.com>  [b25b52a92ce6ab8d325ff582874889fd06f0fc88]

	Add another test case for triply-nested repeats.


2019-07-17  Kohei Yoshida  <kohei.yoshida@gmail.com>  [1828703b38b5e008faf2eee11a2f792563113c0d]

	Correctly handle loading of invalid json map file.


2019-07-16  Kohei Yoshida  <kohei.yoshida@gmail.com>  [d1d88d2972e17987f96e49f6e2af5b15d2e4b5f1]

	Another test case for nested repeats.

	This one has three nested levels.

2019-07-16  Kohei Yoshida  <kohei.yoshida@gmail.com>  [bb48c1b3d72522b16535444c14cf0dd95766a12a]

	Add the nested-repeats to the list of tested cases for imports.


2019-07-16  Kohei Yoshida  <kohei.yoshida@gmail.com>  [c381373959ab3c39b8cb6a6bf2008ae3e7498f09]

	Perform fill-downs for real.


2019-07-16  Kohei Yoshida  <kohei.yoshida@gmail.com>  [d5d2e61e7b95e3ff38bfb4729f7df3a2cd18960e]

	Anchor linked field nodes to their respective row group node.

	This information will be used to figure out which fields need to be
	filled when they need to.

2019-07-16  Kohei Yoshida  <kohei.yoshida@gmail.com>  [35b68659245858fb15058f52905fc71dbba5c016]

	Have get_or_create_destination_node() to return the whole stack.

	Rather than just returning the destination node, we need access to the
	whole stack from the root to the destination.

2019-07-16  Kohei Yoshida  <kohei.yoshida@gmail.com>  [d12b91606e02e5b96b6e644bc1cad2c7e30ef360]

	Commit row-group paths first before the range field paths.


2019-07-16  Kohei Yoshida  <kohei.yoshida@gmail.com>  [2f8c338fc3bac86658f70cd83539092006d7e597]

	Start the start row position of each row group ...

	... and identify the code location in which to fill down the rows.

2019-07-16  Kohei Yoshida  <kohei.yoshida@gmail.com>  [e411f7bf7c13fe19b431e7068cac99fc64a9af3f]

	Add more records to the test file.


2019-07-15  Kohei Yoshida  <kohei.yoshida@gmail.com>  [2793333f44b687740feeba08d845b1f89d4d4d3c]

	Revise the logic of when to increment row positions.

	This is necessary to support nested repeat nodes.

2019-07-15  Kohei Yoshida  <kohei.yoshida@gmail.com>  [d0aeb994164e5cf8ad163cc08e77bdacb3b3962d]

	New test case for nested repeat nodes.


2019-07-15  Kohei Yoshida  <kohei.yoshida@gmail.com>  [67593474ed3f4054ced9939ce45d52a4d58c37ae]

	Add test for object being the root of a tree.


2019-07-15  Kohei Yoshida  <kohei.yoshida@gmail.com>  [f0004cfefc3a7786b919d6d2f5cdc2a3e0315a63]

	Handle object node type in get_get_destination_node().


2019-07-12  Kohei Yoshida  <kohei.yoshida@gmail.com>  [ede18ded1acb8129a003c9973ee51b1644c5348f]

	Add another test case to the unit test.


2019-07-12  Kohei Yoshida  <kohei.yoshida@gmail.com>  [9f87a4ba552d74ff4b8961952a280763dd426f7b]

	Clean this up a bit.


2019-07-12  Kohei Yoshida  <kohei.yoshida@gmail.com>  [efab9712aa39cf2532dcea6c675e5ef2482880f5]

	Handle pushing and popping of objects.

	Now the mapping works with the current test file containing objects.

2019-07-12  Kohei Yoshida  <kohei.yoshida@gmail.com>  [38d402bccde665e0c3d80058f87f2dee03758dd9]

	Parse object keys and start handling paths with objects.

	Still WIP, with lots of TODO markers inserted.

2019-07-12  Kohei Yoshida  <kohei.yoshida@gmail.com>  [0a6430b64666f59f0b452c529671ec610fe95b85]

	Make the 'cells' and 'ranges' nodes optional in JSON map def file.


2019-07-12  Kohei Yoshida  <kohei.yoshida@gmail.com>  [e43d256f81ea04365a453fc48e57b8fe2247fe26]

	New set of test files for loading an array of objects, ...

	... which has yet to be implemented.

2019-07-11  Kohei Yoshida  <kohei.yoshida@gmail.com>  [c9f4e5da6169646da8591980a2c470c17bd0091b]

	Remove debug statements. I don't think I need them any more.


2019-07-11  Kohei Yoshida  <kohei.yoshida@gmail.com>  [af76aa2cb667596c6c3ad30b2e8d549d8449c705]

	Clean up the code a bit.

	Remove the try - catch block since that was intended for the CLI
	usage.

2019-07-11  Kohei Yoshida  <kohei.yoshida@gmail.com>  [ec3ca441d74a1578094fae126f6644b4e6e92870]

	Set up a basic unit test framework for json mapping.

	And move the code that loads entire map difinition from map file to
	orcus_json so that we can call it from the test code.

2019-07-11  Kohei Yoshida  <kohei.yoshida@gmail.com>  [ed5700c5d39e06157963899b2a2d4518c4dae9b1]

	Use boost filesystem on these guys...


2019-07-11  Kohei Yoshida  <kohei.yoshida@gmail.com>  [528455eb5b18fd0688f7ffa1a4ba42c07e1c0ba0]

	Handle the 'check' format in the document::dump() as well.


2019-07-11  Kohei Yoshida  <kohei.yoshida@gmail.com>  [31106a729709fe7f6f7f5390384bbbf65e58d0e6]

	Handle 'none' format correctly without errors.


2019-07-11  Kohei Yoshida  <kohei.yoshida@gmail.com>  [2195dbf159b9c14709850a0a98ca32b2b17d986d]

	Support dumping of document content the same way the other orcus-* do.


2019-07-11  Kohei Yoshida  <kohei.yoshida@gmail.com>  [6b36332f199e3bb1f32b871d13c55ab2f90ee41d]

	Move output directory handling into the document class implementation.


2019-07-11  Kohei Yoshida  <kohei.yoshida@gmail.com>  [e31acf0372ce0ff6ddc2ab72948806deddc70a19]

	Merge json_config::output_format_type with dump_format_t.


2019-07-11  Kohei Yoshida  <kohei.yoshida@gmail.com>  [911bb8ad12bba4b67004b0c8c568111c627d3d84]

	Move output stream creation to cmd_params.


2019-07-10  Kohei Yoshida  <kohei.yoshida@gmail.com>  [43b166f6f90c0cb775fb6267e412cdf6c5891dc5]

	Import the linked values to spreadsheet document.


2019-07-10  Kohei Yoshida  <kohei.yoshida@gmail.com>  [f005a284c0a49874187e8d251f53cd3c67e052b1]

	Handle value nodes in json input ...

	... and ensure that the traversal of the map tree works correctly.

2019-07-10  Kohei Yoshida  <kohei.yoshida@gmail.com>  [521d9497826f5295f89105ddb21ad1d83c59bb8d]

	Implement pop_node() but it has some issues I need to fix.


2019-07-09  Kohei Yoshida  <kohei.yoshida@gmail.com>  [f295f50e5bfc2bd7122301f2f3dc092fd81a59c5]

	Set up a walker class and handle pushing of array nodes.

	I still need to handle array popping, which is my next task.

2019-07-09  Kohei Yoshida  <kohei.yoshida@gmail.com>  [fb63caa85a7022c927c8a06a6308f64339d59cf0]

	Check the row group attribute too.


2019-07-09  Kohei Yoshida  <kohei.yoshida@gmail.com>  [e564866391af2616d041cd85a753358a258e3269]

	Add a test case for linking a range and fix one bug discovered.

	It's always good to write test for your code.

2019-07-08  Kohei Yoshida  <kohei.yoshida@gmail.com>  [38b105a8655d5376da0105128f9929f1eed2dd71]

	Support linking of range references.


2019-07-08  Kohei Yoshida  <kohei.yoshida@gmail.com>  [8c5608fc95a7a14d729ed4a3ab4cfb5368a5c32d]

	No need to handle named tokens anymore.


2019-07-08  Kohei Yoshida  <kohei.yoshida@gmail.com>  [c21f6ade61fdfd7a1a7b1b45ed84cdd6e3d50172]

	Add another test case and address the issue discovered.


2019-07-08  Kohei Yoshida  <kohei.yoshida@gmail.com>  [3eeb296ee34a4b10e6c8949d77226a5593e7ae51]

	Add a get_link() method to retrieve linked nodes ...

	... and add one test case for it.

2019-07-03  Kohei Yoshida  <kohei.yoshida@gmail.com>  [9d04f7ff4e2fc847f09bb12b852bcd48ab5eb626]

	Re-arrange this code a bit, to make it easier to follow.


2019-07-03  Kohei Yoshida  <kohei.yoshida@gmail.com>  [6b953bbbd8df63464efb9e44bde6dd1474d18e8e]

	Move this code into a method, for future re-usability.


2019-07-03  Kohei Yoshida  <kohei.yoshida@gmail.com>  [1e60a25c25242c05e8ac41c96825310875576297]

	Give this special child position a name.


2019-07-03  Kohei Yoshida  <kohei.yoshida@gmail.com>  [e3630f0b6b18bb9de264652218b76fe4e38f3420]

	WIP: manage to link single cell references at root array.


2019-07-03  Kohei Yoshida  <kohei.yoshida@gmail.com>  [0420e804f73da8fcf4e296de2c9adf3125043725]

	Let's use JSONPath for the paths in the map file.

	I believe we can use slightly modified JSONPath for mapping definition.
	I'll decide what to do for the paths in the structure output.

2019-07-03  Kohei Yoshida  <kohei.yoshida@gmail.com>  [1fbae5c1b49f20ef1154a7e90b07c32f4ff2af12]

	WIP: Fully parse array elements at root level.


2019-07-03  Kohei Yoshida  <kohei.yoshida@gmail.com>  [f383334d83e1550a8a8812e24675fe49c9118073]

	Regenerate the expected values for json structure outputs.


2019-07-02  Kohei Yoshida  <kohei.yoshida@gmail.com>  [a386016b58b9a163c1149a941a951c758c61c2dc]

	WIP: Start writing a json path parser. Still incomplete.

	It's enough to parse the first 'array' token.

2019-07-02  Kohei Yoshida  <kohei.yoshida@gmail.com>  [563e0e0ae492e102f499ec55a163b152d1c060e8]

	I forgot to add this file to the slickedit project.


2019-07-02  Kohei Yoshida  <kohei.yoshida@gmail.com>  [3dd58d95ea0eeee7dac6b8d7b536c62645c3dcf6]

	Display the array size for all array nodes.


2019-07-02  Kohei Yoshida  <kohei.yoshida@gmail.com>  [79569b1e208c8bfb92b937e67336a366105dc0db]

	Handle appending of sheets.


2019-07-02  Kohei Yoshida  <kohei.yoshida@gmail.com>  [7c2b70cccb9b652000c3ccde864c184f448bce13]

	Route mapping all calls to the json_map_tree instance.


2019-07-02  Kohei Yoshida  <kohei.yoshida@gmail.com>  [fd19cea13342ff3a91c0e9411c67c5d4800bb90f]

	Complete the parsing of the map file.


2019-06-28  Kohei Yoshida  <kohei.yoshida@gmail.com>  [9ab30c284d2b1907d4b2972d0b586474bd750e1d]

	Remove duplicated code blocks.


2019-06-28  Kohei Yoshida  <kohei.yoshida@gmail.com>  [524a0b3ab036d1b1f094a80f5f28ef64f231cdbb]

	Add tests for this const_node_iterator and add an assignment operator.


2019-06-28  Kohei Yoshida  <kohei.yoshida@gmail.com>  [5020b19f47d5bf277e1b90431a44c2d676bb7eba]

	Add iterator support to json::const_node.

	And switch to using ranged for loop where applicable.

2019-06-28  Kohei Yoshida  <kohei.yoshida@gmail.com>  [83dc8c68879fdd142084390339813b7fa4ad2fff]

	Iterate through the field nodes.


2019-06-27  Kohei Yoshida  <kohei.yoshida@gmail.com>  [3cdb05f30d16c4067b73a5af8aa95a645292528e]

	Start putting things into orcus_json app instance. Not finished yet.


2019-06-27  Kohei Yoshida  <kohei.yoshida@gmail.com>  [5bfc32d0bae5e71565ba44131b2cf6a41dc04709]

	Move the code that maps json to spreadsheet in a separate source file.


2019-06-27  Kohei Yoshida  <kohei.yoshida@gmail.com>  [6d3e6f4fab1b3e681433dc039fff8de246acfbf4]

	Rename orcus_json_main.cpp to orcus_json_cli.cpp.


2019-06-27  Kohei Yoshida  <kohei.yoshida@gmail.com>  [640e6371d0ad131706dbc2574726de98cec874f4]

	Start parsing the map file.


2019-06-27  Kohei Yoshida  <kohei.yoshida@gmail.com>  [cb13554678e8b2bdb4d8039970e71e6a9ad79b6a]

	We can safely ignore these files.


2019-06-27  Kohei Yoshida  <kohei.yoshida@gmail.com>  [8956f84b8aaf5c2c4dc6eafdfa159654caa56969]

	Add skeleton orcus_json and json_map_tree class definitions.


2019-06-27  Kohei Yoshida  <kohei.yoshida@gmail.com>  [c5293894aca06edc8a00b370f9ef5edd1a9478c2]

	Pick up the map file content and make file_content movable.


2019-06-26  Kohei Yoshida  <kohei.yoshida@gmail.com>  [a78d8eed96b6d48aab55f4b5e6fc3b1f6c710341]

	Parse CLI parameters for the map mode.


2019-06-26  Kohei Yoshida  <kohei.yoshida@gmail.com>  [73eb4ec6220e295d996e5220f2a32da5231b911a]

	Very first test data set for json mapping. Still subject to change.


2019-06-26  Kohei Yoshida  <kohei.yoshida@gmail.com>  [0f8211062e271992341d3180ad6d0b2e7944ddc2]

	This is probably wrong too, since we are parsing an object...


2019-06-26  Kohei Yoshida  <kohei.yoshida@gmail.com>  [fe11df7199c7a1816e9dec6994e04e6906d139b3]

	Set the expectation straight.

	The code was expecting either '}' or ',' for sure, but that's not what
	the exception message said.

2019-06-26  Kohei Yoshida  <kohei.yoshida@gmail.com>  [89c3a9f4b4e398042a9b8ddd29e338f3c935aee9]

	Capture json parse error in a single place.

	Both for convert and structure mode, and probably for the future
	map mode implementation.

2019-06-25  Kohei Yoshida  <kohei.yoshida@gmail.com>  [58688aa83cb4570bc607d88641aec262646af771]

	Extract the convert mode arg parsing into its own function.


2019-06-25  Kohei Yoshida  <kohei.yoshida@gmail.com>  [3e877c8a463e5f17b3c4f8a913b67631eeec3276]

	Add 'map' mode and adjust the parsing code accordingly.


2019-06-24  Kohei Yoshida  <kohei.yoshida@gmail.com>  [11ce5652ca7319842b7ab27c1cf8b0178a049c6d]

	Make sure we handle empty structures correctly.


2019-06-24  Kohei Yoshida  <kohei.yoshida@gmail.com>  [e9dd23339d8304dbabe1c2829de4f920a6723858]

	Regen the expected outputs for unit tests.


2019-06-24  Kohei Yoshida  <kohei.yoshida@gmail.com>  [5a24c87547e6224ffdf2933c912066784128182a]

	Change the structure output to make the paths look a bit like JSONPath.

	Not exactly identical to JSONPath, but close...

2019-06-24  Kohei Yoshida  <kohei.yoshida@gmail.com>  [3b525e46bdd6dfdcd3aeedd7f1e5e3283c24f390]

	Omit the final 'value' node in json structure output when displaying.


2019-06-22  Kohei Yoshida  <kohei.yoshida@gmail.com>  [934f44292c8c215b1c75843a6caea6f779c84bb5]

	Handle transient strings properly.


2019-06-22  Kohei Yoshida  <kohei.yoshida@gmail.com>  [58076df48d65fbcdbac3cc8224ae80e0e9aed37b]

	I forgot to remove these debug statements.


2019-06-22  Kohei Yoshida  <kohei.yoshida@gmail.com>  [e7abe5b5799af707fdd0f2f5cb82a88317771f88]

	Add test for json::structure_tree::dump_compact().


2019-06-22  Kohei Yoshida  <kohei.yoshida@gmail.com>  [0abaa6858c6be983c1c9f4abf3292160886e67be]

	Expected output file should be named check.txt.


2019-06-22  Kohei Yoshida  <kohei.yoshida@gmail.com>  [45eaf06c7c28a4668ec338221d43c6c0cf3d12ea]

	Generate expected outputs.


2019-06-22  Kohei Yoshida  <kohei.yoshida@gmail.com>  [adda2250f03d394f4b2981ec4485ea181661d141]

	Three more test json contents.


2019-06-22  Kohei Yoshida  <kohei.yoshida@gmail.com>  [e48ec10665b6166d62e22639c544f60e2c8b3dc3]

	Slight format tweak.


2019-06-21  Kohei Yoshida  <kohei.yoshida@gmail.com>  [e8027fe541715510c1e2aed2eafcdaf60a8ba7cd]

	Let's make sure we handle all value types equally.


2019-06-21  Kohei Yoshida  <kohei.yoshida@gmail.com>  [71f1be032a2d273983a7ea6220b2c251a88900aa]

	Handle object key nodes.

	Object key nodes are special non-leaf nodes in that they can only store
	one child node.  As such, we need to immediately move up the scope
	whenever the scope position moves up to an object key node.

2019-06-21  Kohei Yoshida  <kohei.yoshida@gmail.com>  [39bcaf55f95df286cf5d895cdc6ad44a2313cc5e]

	Pick up the output file path parameter also for the structure mode.


2019-06-21  Kohei Yoshida  <kohei.yoshida@gmail.com>  [4cfc4a815ab9166990d5a3a156777e9d83266129]

	Record array widths in the JSON structure tree.

	A width of an array node in a structure tree is the maximum width of
	an array for that particular node.

2019-06-21  Kohei Yoshida  <kohei.yoshida@gmail.com>  [0ed5d32c00a5914bea1081950c0ccfbc7af87f0d]

	Handle repeating structure nodes.

	The current prevailing rule is that only an object or array node that
	is a child of an array node can be repeatable.

2019-06-20  Kohei Yoshida  <kohei.yoshida@gmail.com>  [3ddfb30dc7dcfcb9154ba32b403ff94e47cd71fa]

	Implement dumping of tree for simple nested arrays.

	Still incomplete.

2019-06-20  Kohei Yoshida  <kohei.yoshida@gmail.com>  [84e3ac0542a18fad26f513c7dae5b43263877852]

	Allow equality check for object key nodes.

	Object key nodes must be compared by the key value as well.

2019-06-20  Kohei Yoshida  <kohei.yoshida@gmail.com>  [206954e1f488d267119265e91d56e3524330f621]

	First test JSON content.

	This one consists of simple nested arrays with numeric values.

2019-06-19  Kohei Yoshida  <kohei.yoshida@gmail.com>  [87850b9912a8f36037169cc6e478018573361141]

	WIP: start parsing json to build structure tree.


2019-06-18  Kohei Yoshida  <kohei.yoshida@gmail.com>  [22616dd8df24d033e50533ba455e40117e91d0e7]

	Set up an empty json parser handler.


2019-06-18  Kohei Yoshida  <kohei.yoshida@gmail.com>  [73d600fd9c8e4545b3f4c64041e56fb7fca9e305]

	More on switching to using std::unique_ptr from raw pointer.


2019-06-18  Kohei Yoshida  <kohei.yoshida@gmail.com>  [5838d0e5d2e2a1ba34097b8ebbeb7a15637f632b]

	Avoid use of raw pointer here...


2019-06-18  Kohei Yoshida  <kohei.yoshida@gmail.com>  [d3eec7b0b48ef37a887fc916bd0f8f87d7482cfd]

	Modernize the code a bit.


2019-06-18  Kohei Yoshida  <kohei.yoshida@gmail.com>  [9af9bc083f6efc545c525210e2bedc9ffac3c75a]

	Use sorted_string_map here.


2019-06-17  Kohei Yoshida  <kohei.yoshida@gmail.com>  [2dff8a8ed020574ff03fda6fb463ca1ebae1e376]

	Make sure an input file is given even for the structure mode.

	Also, let's just put the whole main function body in a try block...

2019-06-17  Kohei Yoshida  <kohei.yoshida@gmail.com>  [d996681295b0dc723391043839d0bdf0ac3693f9]

	Add empty json_structure_tree class and use it from the cli main code.


2019-06-17  Kohei Yoshida  <kohei.yoshida@gmail.com>  [ddc4758d6065241877f800665998c95d500aa057]

	cmd_context -> cmd_params. The word 'context' is overused (by me).


2019-06-17  Kohei Yoshida  <kohei.yoshida@gmail.com>  [bc2af2a456e6b978090f7583ba4bcb453cd45b05]

	Output to stdout when the output file path is not given.


2019-06-17  Kohei Yoshida  <kohei.yoshida@gmail.com>  [bb8960335a493e38bdade8fb096f07d14f85f4da]

	Add --mode option to orcus-json.


2019-06-17  Kohei Yoshida  <kohei.yoshida@gmail.com>  [e430f3d826e41344f5482bb93cb56d1efc619eea]

	Correct my English.


2019-06-17  Kohei Yoshida  <kohei.yoshida@gmail.com>  [4c85aef95ed01728fe68a9daa2f20752db46e328]

	Generate better error message on missing map file.

	Also, improve the help output a bit.

2019-06-17  Kohei Yoshida  <kohei.yoshida@gmail.com>  [840aae66d7bdc2ec66b62f2fccc25cb01aab9d5b]

	Use ORCUS_ASCII here.


2019-06-17  Kohei Yoshida  <kohei.yoshida@gmail.com>  [ebb73553c11cb7763b60a1c36303bd44186a7b5a]

	Remove duplicated code blocks. Related to #83.


2019-06-17  Kohei Yoshida  <kohei.yoshida@gmail.com>  [93a0f6d091d643462788a7faaf064854dc1c797f]

	Correctly handle ']' that occurs right after '['.

	Also, make sure that we only recognize 0x09, 0x0A, 0x0D and 0x20 to be
	whitespace characters when parsing JSON.

	This fixes #83.

2019-06-16  Kohei Yoshida  <kohei.yoshida@gmail.com>  [8db6eabdbad399369696887d2b59d444ed030685]

	Some formatting change.


2019-03-21  Kohei Yoshida  <kohei.yoshida@gmail.com>  [c3d4ef51d24e09162d6e2918cb45d1168f2c74de]

	Add some inline docs.


2019-03-21  Kohei Yoshida  <kohei.yoshida@gmail.com>  [a1231ee9a50a9ae58d185a5b67c3b82fd15cf352]

	Remove the remaining uses of load_file_content(), and remove the function.


2019-03-20  Kohei Yoshida  <kohei.yoshida@gmail.com>  [e895a34ce74b0572e48e48f5a6c4f9c480fa7978]

	More on replacing load_file_content().


2019-03-19  Kohei Yoshida  <kohei.yoshida@gmail.com>  [34d78934298a272c35fb703803e6dbc3aa375fc8]

	More on replacing use of load_file_content() with file_content class.


2019-03-19  Kohei Yoshida  <kohei.yoshida@gmail.com>  [4d641016acc051c2308e775f4900fc92f2a8de71]

	Use file_content for css loading.


2019-03-19  Kohei Yoshida  <kohei.yoshida@gmail.com>  [395b1cd6188ef7796a9adc72d19f6a5e39944e86]

	Move the utf-8 conversion function to file_content class.

	It makes more sense this way.

2019-03-19  Kohei Yoshida  <kohei.yoshida@gmail.com>  [3a70aef91ecee787ee72f6921c4afb29899b3650]

	Workaround for MSVC.

	Without this, you'd get a linker error for undefined function.

2019-03-18  Kohei Yoshida  <kohei.yoshida@gmail.com>  [88052e205828d63a211a06d3d94d1b66e4411912]

	Create a file_content that memory-maps file instead of loading to memory.

	And use this class in orcus_csv first.

2019-03-15  Kohei Yoshida  <kohei.yoshida@gmail.com>  [c9479978417ab13dc75c68005240e585eb387258]

	Let's also handle UTF-16 little-endian as well.

	This is related to #80.

2019-03-14  Kohei Yoshida  <kohei.yoshida@gmail.com>  [38ff668bff16f7cacfc9639ea62ad82199a2aad1]

	Annotate the function.


2019-03-14  Kohei Yoshida  <kohei.yoshida@gmail.com>  [5829b0d5a1610ce42aacdffe48f1025614f1f8b3]

	Convert UTF-16 big-endian file per BOM.

	This resolves #80.

2019-03-13  Kohei Yoshida  <kohei.yoshida@gmail.com>  [b2646739d9ac1922cb4cc8d981b70655b7f94e40]

	Add a test case for the upper-case color names.


2019-03-13  Kohei Yoshida  <kohei.yoshida@gmail.com>  [c3a757f1d9c3dbf5622e985181a4d541081c75f1]

	Make sure the colored names are evaluated in a case-insensitive manner.


2019-03-13  Kohei Yoshida  <kohei.yoshida@gmail.com>  [cdbfa702e1808053536cf8fca957e4ea29cf3ceb]

	Add a test case to ensure that the colors are imported properly.


2019-03-13  Kohei Yoshida  <kohei.yoshida@gmail.com>  [e29c252e0d10065b173ff8edadab5720bfb415e6]

	Add named-color to the list of content checks.


2019-03-13  Kohei Yoshida  <kohei.yoshida@gmail.com>  [effc2ad5fc3cc84e4163e3f51a94ebc3297d2e74]

	Make use of to_color_rgb_from_name() to handle named colors properly.


2019-03-12  Kohei Yoshida  <kohei.yoshida@gmail.com>  [d7f2ee12936e055ac071b540d43bad49cecab239]

	Add a new public utility function to convert color name to RGB.

	Still not tested yet.

2019-03-12  Kohei Yoshida  <kohei.yoshida@gmail.com>  [66ce2c1dc30086ab7c039c66a8d650a465b6ef85]

	Create a valid test file with named colors.

	* saved-by-excel.xml - original source XMLSS file saved by Excel.
	* input.xml - source file with the raw RGB values replaced with their
	  respective color names.  Excel can still open this file without errors
	  and their colors intact. So I assume this file is valid.

2019-03-12  Kohei Yoshida  <kohei.yoshida@gmail.com>  [78065b9e750b0b31fa0f3d521933d07e36aadc96]

	Script to replace raw RGB values to their respective color names.


2019-03-11  Kohei Yoshida  <kohei.yoshida@gmail.com>  [da521afc9297597b5ee9b33a98f7f25d2a9e20aa]

	Test file that contains all named colors from CSS color 3.

	This is the original file saved from Excel.  I need to find a way
	to auto-convert the raw RGB values to their named equivalents.

2019-03-11  Kohei Yoshida  <kohei.yoshida@gmail.com>  [9fa69b43db0aba9330fb463f932c6f5200b11461]

	Be specific about the ixion API version it requires.


2019-03-08  Kohei Yoshida  <kohei.yoshida@gmail.com>  [c635930d63b6e0f0b051ab7f4c7e150c1e790f8d]

	Use virtual dtor when using class inheritance with virtual methods.


2019-03-08  Kohei Yoshida  <kohei.yoshida@gmail.com>  [3c1f94102bbba5140f86e5d38268f40e1cf19630]

	I forgot to add this file.


2019-03-08  Kohei Yoshida  <kohei.yoshida@gmail.com>  [781d993bf1b1f97369c6dc28ae0bf08e7d9fced8]

	Add another test case for triply-nested row groups.

	Also, let's not write output xml unless we want to compare input to
	output.

2019-03-08  Kohei Yoshida  <kohei.yoshida@gmail.com>  [16e40f5078dfce1823c0e113e738588a01c4c857]

	Don't forget to initialize this data member.

	Now the test passes.

2019-03-08  Kohei Yoshida  <kohei.yoshida@gmail.com>  [bef98a78886c3604ba7ff977a1c76e0a1ad467c5]

	Use lossless numeric format for dump-check.

	Also modify the nested row-group test.  It currently fails.

2019-03-08  Kohei Yoshida  <kohei.yoshida@gmail.com>  [fe6f72a45b8256a9e2d56440bd82b9f021b25076]

	This is no longer needed. Remove it.


2019-03-08  Kohei Yoshida  <kohei.yoshida@gmail.com>  [dc84d5eb886f10fb22ed9889f25dafce1736f1ec]

	Properly implement filling down of parent row-group element values.


2019-03-08  Kohei Yoshida  <kohei.yoshida@gmail.com>  [eb1e47c38dd943ce677ef1354a072df7a31c0126]

	Rename row_size to row_position. The latter sounds more appropriate.


2019-03-06  Kohei Yoshida  <kohei.yoshida@gmail.com>  [d6fa3d8051daf6bbe7134ec6ceba6bea90b4bbb7]

	Add logic & hook to copy cell values down the columns for parent values.

	For now I'm setting "---" value to those cells that need to be filled.  Next
	step is to implement copying down of the values.

2019-03-06  Kohei Yoshida  <kohei.yoshida@gmail.com>  [7b2b5b2c58d3d5b69914def175c673028c3f1944]

	Add a bit of annotation.


2019-03-05  Kohei Yoshida  <kohei.yoshida@gmail.com>  [76f7810a725659f22c517856a309ef0442a45c1b]

	Add a central place to manage numeric value formatting for file output.

	And this format _must_ be lossless.

2019-03-01  Kohei Yoshida  <kohei.yoshida@gmail.com>  [a883b55101f9288a39151bd5427b234b7f2c1433]

	Revise the logic of incrementing the row position to support nested groups.

	We now require explicit row-group definitions in the map file.

2019-02-28  Kohei Yoshida  <kohei.yoshida@gmail.com>  [b04b664adc873de6cf80fccc252710b7c6cea6aa]

	Remove excessive typedef.


2019-02-27  Kohei Yoshida  <kohei.yoshida@gmail.com>  [7c0e62fb076985aa8c08fcc6c1261fef2755df86]

	Rename get_element_stack() to get_linked_node() ...

	... and have it return both the element stack and the linked node pointer.

2019-02-27  Kohei Yoshida  <kohei.yoshida@gmail.com>  [c9f1f34425b7b80494b6a4e482daa098833b3859]

	Another place we can use get_or_create_child().


2019-02-27  Kohei Yoshida  <kohei.yoshida@gmail.com>  [c39c7e2ce21b08ddc108216433eb89525858e069]

	Extract a method here as well.


2019-02-27  Kohei Yoshida  <kohei.yoshida@gmail.com>  [99eaddc7d0171e890e1114cb9343b5a81aa953ed]

	Extract method for ease of read.


2019-02-26  Kohei Yoshida  <kohei.yoshida@gmail.com>  [6e12e838f8c074c6cc4315e3765fae87fa7a8134]

	intern() can take a pstring instance now.


2019-02-26  Kohei Yoshida  <kohei.yoshida@gmail.com>  [b9a67db431b506fe4fe603138fb65e0693d0fbcb]

	Use unique_ptr for the root element instance as well.


2019-02-26  Kohei Yoshida  <kohei.yoshida@gmail.com>  [6da475db306466c138d1c33d271e75cbb7d59c2f]

	Use unique_ptr to replace raw pointer with new.


2019-02-26  Kohei Yoshida  <kohei.yoshida@gmail.com>  [144122558aa79daabfafc9cc1ad2909a793552ec]

	Use unique_ptr for this pimpl idiom.


2019-02-25  Kohei Yoshida  <kohei.yoshida@gmail.com>  [49899c9b8e924950477ce959724715874d40a319]

	Test file to use to implement nested repeat elements.


2019-02-21  Kohei Yoshida  <kohei.yoshida@gmail.com>  [ecd6bc630bf946bc78820073d297407a4703ca6d]

	Point to the readthedocs doc.


2019-02-21  Kohei Yoshida  <kohei.yoshida@gmail.com>  [21992002cfae64ac941bbeb84b8a3fc13f502602]

	Adjust the doc configuration for readthedocs build.


2019-02-20  Kohei Yoshida  <kohei.yoshida@gmail.com>  [37bfd4efa28d712c2d7217347d46c1fae1797e55]

	Enable sax-token-parser-test in cmake build.


2019-02-20  Kohei Yoshida  <kohei.yoshida@gmail.com>  [0e2be8524b1d1bbccfbba2e39bb426b062e0b20a]

	Add sax-parser-test to the cmake test.


2019-02-20  Kohei Yoshida  <kohei.yoshida@gmail.com>  [bf0c6b115531287d4ba5f522a7e7ab48600d572e]

	Fix cmake build.


2019-02-20  Kohei Yoshida  <kohei.yoshida@gmail.com>  [c93e27e211fc5221df24cf648942954607c4030a]

	Finally make use of the output format in orcus-xml.


2019-02-20  Kohei Yoshida  <kohei.yoshida@gmail.com>  [7a8ece3b4f9ba9c8f0cd4eca716530794fd17ce3]

	Remove the unnecessary virtual method interfaces.


2019-02-20  Kohei Yoshida  <kohei.yoshida@gmail.com>  [2b4b4f679d540cde2d21f4a1d93b1370999cf9ce]

	Add dump() method interface that takes dump format type as parameter.


2019-02-20  Kohei Yoshida  <kohei.yoshida@gmail.com>  [f81876c49ec6fc56bdc454790c126618a29ecacd]

	I shouldn't use argv here...


2019-02-19  Kohei Yoshida  <kohei.yoshida@gmail.com>  [a94c5a58fdbeab3d683f3c26ab064e0d030c2bcc]

	Add output-format option to orcus-xml. Not used yet.


2019-02-19  Kohei Yoshida  <kohei.yoshida@gmail.com>  [d79acf35b0d05303d1e0cdd9cb1172f0beeb6274]

	A bit more simplification.


2019-02-19  Kohei Yoshida  <kohei.yoshida@gmail.com>  [a23f0f4258af7a535deee5fcce2ea239ec49096e]

	Move doc_output_format::type to a public place and call it dump_format_t.

	And use it where doc_output_format::type was expected.

2019-02-19  Kohei Yoshida  <kohei.yoshida@gmail.com>  [841a812040b35b99cb38c3645d13eee16355ad7f]

	Use std::unique_ptr to replace a naked pointer.


2019-02-18  Kohei Yoshida  <kohei.yoshida@gmail.com>  [fc16018f874c0026c24530c53f9d2c4d7cd4bdab]

	Add the ability to dump the XML structure information.


2019-02-18  Kohei Yoshida  <kohei.yoshida@gmail.com>  [c2c5bcecf098d6f643d55f561e928f30f568e8df]

	Make use of the --output option.


2019-02-18  Kohei Yoshida  <kohei.yoshida@gmail.com>  [f43bfaab083a8b66f800a559be660b872888abb8]

	Switch to using boost::program_options for handling CLI arguments.


2019-02-14  Kohei Yoshida  <kohei.yoshida@gmail.com>  [7adfed69d1627f3962f404bc3e03455ec229502a]

	Use memcmp over strncmp for slightly better performance.


2019-02-14  Kohei Yoshida  <kohei.yoshida@gmail.com>  [8101665fd75efbeef1824b78a0579143c40f4860]

	Prevent integer overflow going from size_t to int.

	For a very large stream, the length can be greater than the max value
	of 32-bit signed integer...

2019-02-14  Kohei Yoshida  <kohei.yoshida@gmail.com>  [91753487b67c1c9904f20c8797c65b2ca3eed018]

	Append offset value to the exception message.


2019-02-13  Kohei Yoshida  <kohei.yoshida@gmail.com>  [e4941bc995e0bae31a736d9a33e248bd4a6851eb]

	Use skip_space_and_control() over its own blank().

	This seems to slightly improve the XML parsing performance.

2019-02-13  Kohei Yoshida  <kohei.yoshida@gmail.com>  [470130f7a17f218dcf1f7dac1c9fcc2e05971c21]

	Use SSE 4.2 to parse XML element names.

	This one does make the XML parsing slightly but noticeably faster.

2019-02-12  Kohei Yoshida  <kohei.yoshida@gmail.com>  [53f3976500594a61972aeb42baea79034bdd36a8]

	Fix a bug in pstring's equality check.

	Pointing to the same buffer doesn't necessary mean equality; we still
	need to check their sizes.

2019-02-11  Kohei Yoshida  <kohei.yoshida@gmail.com>  [649b0c10d6ebd511b4799b953b88e7036ada620b]

	This callback method is no longer used.


2019-02-11  Kohei Yoshida  <kohei.yoshida@gmail.com>  [96edfa8b460f1ed3af4779eed01e68b5c20a1613]

	Add test case for transient stream handling in sax_parser.


2019-02-11  Kohei Yoshida  <kohei.yoshida@gmail.com>  [4a286c8c3240d2572d1f8c54f52421f4fb226a01]

	Have dom::document_tree to support transient streams.


2019-02-11  Kohei Yoshida  <kohei.yoshida@gmail.com>  [c6f29b32b0685cea25e18a94f1750645c93e5ce0]

	Propagate the transient_stream parser flag up to sax_token_parser.

	A test case (or two) has yet to be added.

2019-02-10  Kohei Yoshida  <kohei.yoshida@gmail.com>  [2408e745ce581421eb1c78ec7384499915de6a44]

	Add a boolean flag to specify whether the stream itself is transient.

	And use this flag in the sax_parser code to determine the transient
	flag for each call site.  This *should* cover all of sax_parser,
	sax_ns_parser and sax_token_parser since the latter two do not do
	their own transient flag handling.

2019-02-08  Kohei Yoshida  <kohei.yoshida@gmail.com>  [e4cbec0954318ecce8eb0affd33840c9abb3efbf]

	This assertion is simply incorrect.

	It's valid for an XML attribute to have an encoded character
	immediately followed by a ';'.

	This fixes #77.

2019-02-06  Kohei Yoshida  <kohei.yoshida@gmail.com>  [6067fa45d90fb913c39c04fb75c7b14fdb62b479]

	dom_tree -> dom::document_tree.


2019-02-06  Kohei Yoshida  <kohei.yoshida@gmail.com>  [f5c862ec3c6cfb1e7b6424d5bff1d43eb835d57b]

	A bit more test code...


2019-02-06  Kohei Yoshida  <kohei.yoshida@gmail.com>  [80af553aad903a0f60bcf7ab5c55b352c89a6c68]

	When no parent exists, the node type becomes unset.


2019-02-06  Kohei Yoshida  <kohei.yoshida@gmail.com>  [4e3bf672fa3dc4026552d98e12647a0d9555b987]

	Remove 'content' node type.

	Also make sure the copying works.

2019-02-06  Kohei Yoshida  <kohei.yoshida@gmail.com>  [f8ceee372e0ef5b36931abc0added4002f1c4ce7]

	The attribute node type is no longer applicable.


2019-02-06  Kohei Yoshida  <kohei.yoshida@gmail.com>  [421de16eb842b55ee940fac48e5c51aef5ff0203]

	Add parent() method and equality and non-equality methods.


2019-02-06  Kohei Yoshida  <kohei.yoshida@gmail.com>  [c9ff699663df5660812ddf3dcd7ca1dde8e5af16]

	Add attribute_count().

	It returns non-zero only from declaration and element instances.

2019-02-05  Kohei Yoshida  <kohei.yoshida@gmail.com>  [7add5706f4c6d79cca775625584b5c712be897c8]

	Start supporting element hierarchy traversal. Not finished yet.


2019-02-05  Kohei Yoshida  <kohei.yoshida@gmail.com>  [9dfccd3f5526751a5231c068e9ebe6bdbca7bf74]

	Support element name retrieval.


2019-02-05  Kohei Yoshida  <kohei.yoshida@gmail.com>  [95a6a2168661eb9d7ed0f55f5fde0ed630ab627c]

	Have declaration support attribute() instead.

	This feels more natural & the code becomes more concise.

2019-02-05  Kohei Yoshida  <kohei.yoshida@gmail.com>  [95d4c97a26b9fc3fbdecb06ffe248da71cade9d7]

	Implement the hash function for entity_name.


2019-02-05  Kohei Yoshida  <kohei.yoshida@gmail.com>  [b2d188d5ebda9083e805148c718f0a5738a8691c]

	Test for a non-existing attribute.


2019-02-05  Kohei Yoshida  <kohei.yoshida@gmail.com>  [69d3be4318e51a7aa7652731d7b5491ef9929bc0]

	Support attribute() method in const_node.


2019-02-05  Kohei Yoshida  <kohei.yoshida@gmail.com>  [6a80e1bed1eb6ff0431a0217b86bf45a3ae70500]

	Get the root() method functional.


2019-02-05  Kohei Yoshida  <kohei.yoshida@gmail.com>  [fdede58252f54edc8dbfa115788ea5620df380dd]

	Modernize the code a bit.


2019-02-05  Kohei Yoshida  <kohei.yoshida@gmail.com>  [6556833571bbaddb4c4cecd5bd837a24c6240e26]

	Use std::deque here to avoid memory fragmentation.


2019-02-05  Kohei Yoshida  <kohei.yoshida@gmail.com>  [2c2e3a93a850a19d3c851c2218553f7699a7e1a1]

	Move up the dom_tree::impl method code & use lambda for std::sort.


2019-02-05  Kohei Yoshida  <kohei.yoshida@gmail.com>  [69e616f56c335e674699a19e10ae8a493af94557]

	Move the internal structure types into hiding.


2019-02-04  Kohei Yoshida  <kohei.yoshida@gmail.com>  [2cae144f9e0cdfc99232fc9948602abe445a8cf2]

	Move the print() function for attr into a private space.


2019-02-04  Kohei Yoshida  <kohei.yoshida@gmail.com>  [66c1324cae88eca0e7b46c02ff141f0a27c054c2]

	Use dom::entity_name instead of dom_tree::entity_name.


2019-02-04  Kohei Yoshida  <kohei.yoshida@gmail.com>  [c0038a90008516cec4627ce2aefdadae0e5f8e82]

	Use the node-based traversal method.

	And remove the old get_declaration_attributes() method.

2019-02-04  Kohei Yoshida  <kohei.yoshida@gmail.com>  [03030add98c0362b645caca9b1fd483beee0c447]

	Add test case for traversing declarations.


2019-02-04  Kohei Yoshida  <kohei.yoshida@gmail.com>  [1e29beac50e959765f4b26c39debf842822b85d0]

	This type is an implementation detail. Hide it.


2019-02-01  Kohei Yoshida  <kohei.yoshida@gmail.com>  [95fb6095a860c733558bee5b920b99b6e972e14d]

	Use std::unique_ptr instead of naked new.


2019-02-01  Kohei Yoshida  <kohei.yoshida@gmail.com>  [2b5acf44b578f6ce59c4421774e6560c5147a157]

	Use dom_tree::impl as the handler for the sax parser.

	And move dom_tree's original handler methods to its impl counterpart.
	Now its interface looks a lot cleaner.

2019-02-01  Kohei Yoshida  <kohei.yoshida@gmail.com>  [c74d4e765b1c46e1945a0a18bfdffb5b5d786adb]

	Remove these files from the slickedit project.


2019-02-01  Kohei Yoshida  <kohei.yoshida@gmail.com>  [795b79a66d01c7fd4bd2fff73f92a86bcc8bb470]

	Fix AVX2 version of skip_space_and_control().

	Turns out that _mm256_cmpgt_epi8() is a comparison of *signed*
	integers, which means any value greater than 0x7F is considered
	smaller than whitespace thus to be skipped.  We need to work around
	this by checking for the signed bit and mark that char disqualified
	if it's on.

	If there is an equivalent AVX intrinsic for unsigned integers, we
	chould use that instead. But so far I couldn't find one.

2019-01-31  Kohei Yoshida  <kohei.yoshida@gmail.com>  [80c29d71c16b3791fcfd5d15c2446c0193284fc3]

	Use dom_tree directly. Now dom_tree_sax_handler is no longer used.


2019-01-31  Kohei Yoshida  <kohei.yoshida@gmail.com>  [bc109ad09d5c9abac32004d4dcf3824ff45d29cd]

	dom_tree_impl -> dom_tree::impl.


2019-01-30  Kohei Yoshida  <kohei.yoshida@gmail.com>  [057492a8fd724c0b1bfeb91d32ef9bc5ef791bca]

	Add AVX2 variant of skip_space_and_control().


2019-01-29  Kohei Yoshida  <kohei.yoshida@gmail.com>  [2ae22680b94d86fb2856d0b74bdb918673b24d30]

	Add compiler flag for AVX2 for cmake-based build.


2019-01-29  Kohei Yoshida  <kohei.yoshida@gmail.com>  [64c995ad3c2ed877580abad6fb7fd4f08f3f4e37]

	Simply use cmake's configure_file for this.


2019-01-29  Kohei Yoshida  <kohei.yoshida@gmail.com>  [7432760f2e2db8b7b5222f2075960f8a55c31933]

	option() is for boolean flags. set() is for string options.


2019-01-29  Kohei Yoshida  <kohei.yoshida@gmail.com>  [09843f7e5676d22e0bd7f5178c328a623e79d1f5]

	Boost_USE_STATIC_LIBS should be set externally.

	Also run the tests in quiet mode during the build.

2019-01-22  Kohei Yoshida  <kohei.yoshida@gmail.com>  [5f3ef41a96bb6f6237cd945bcdbd41c832935eea]

	Fix the make check build on the Linux side.


2019-01-22  Kohei Yoshida  <kohei.yoshida@gmail.com>  [c1c433eced50838f15246551d1a1eee2bfad42d9]

	Use boost::filesystem::remove() to remove files.


2019-01-22  Kohei Yoshida  <kohei.yoshida@gmail.com>  [06ece7dbb8c6d10361aa18032c6e138fa4831262]

	Add option to turn on SSE 4.2 with CMake-based build.


2019-01-22  Kohei Yoshida  <kohei.yoshida@gmail.com>  [ff96ba9ff6474ff75fbe9e49ca038f43052e05d7]

	Add test programs in src to CMake-based build.


2019-01-18  Kohei Yoshida  <kohei.yoshida@gmail.com>  [7a4d23c547a8b0d2bd384983fb9694c986a61791]

	Actually I can use const_cast hack to make the node non-copyable.

	This is a legitimate workaround for the time being, until we have a
	moveable initializer_list.

	c.f. http://www.open-std.org/jtc1/sc22/wg21/docs/papers/2014/n4166.pdf

2019-01-18  Kohei Yoshida  <kohei.yoshida@gmail.com>  [457819b751275e1a044046bc67fc62919d1fd58a]

	Fix json document initialization with nested initializer lists.

	This type of initialization

	    json::document_tree doc = {
	        { true, false, nullptr },
	        { 1.1, 2.2, "text" }
	    };

	failed previously because the inner initializer list instance would
	delete all the enclosing node instances before handing them to the
	outer initializer list.  The code was "moving" the inner initializer
	list to the outer one, which seems to have worked with gcc, but MSVC
	does not move the values.

	This change makes the initialization node copyable, and copy them
	before handing them over to the outer list.  Not ideal, but better
	than not working...

2019-01-18  Kohei Yoshida  <kohei.yoshida@gmail.com>  [bda930efeff53fc7dff0c083f1776321c091ce59]

	A bit more helpful exception message.


2019-01-18  Kohei Yoshida  <kohei.yoshida@gmail.com>  [c45632ee68832e87982ba4f740d1f5b19c57bbd3]

	Add most of the test programs for the liborcus target.


2019-01-18  Kohei Yoshida  <kohei.yoshida@gmail.com>  [289deb50be72eae854f2e27b7bee0a0966ff7ee6]

	Use the python interpreter the builder has specified.


2019-01-18  Kohei Yoshida  <kohei.yoshida@gmail.com>  [e1b8fa3f0e1704e3eda3790f930d53fcac10afa9]

	No need to specify full source paths. CMake looks into current dir.

	And if one needs to specify full path, you can always use the
	CMAKE_CURRENT_SOURCE_DIR variable.

2019-01-18  Kohei Yoshida  <kohei.yoshida@gmail.com>  [348a4c2bda1c1b87cc1ce0d22fcc58593796a250]

	Specify the full path of each test source file.


2019-01-17  Kohei Yoshida  <kohei.yoshida@gmail.com>  [c915d16370e6743ea69db37c5d5420a2d95807fc]

	Add parser tests to the CMake-based test framework.


2019-01-17  Kohei Yoshida  <kohei.yoshida@gmail.com>  [3020b5906a12ca150fac79693100fafcc9ebaad5]

	Split CMakeLists.txt into multiple, one per directory.

	And use add_directory() to link them all together.

2019-01-17  Kohei Yoshida  <kohei.yoshida@gmail.com>  [c1ba3926cf3d15b0cb8d61badf27dffecae7274e]

	More on fixing the build with MSVC.

	* Disable warnings on implicit type casting.
	* Disable warnings on "unsafe" C API calls.
	* Fix inconsistent linkage issue with certain public symbols.

2019-01-16  Kohei Yoshida  <kohei.yoshida@gmail.com>  [048d872aeb7db9b3547030475475a4c2cd4ea544]

	Get orcus to build again on Windows via CMake.


2019-01-12  Kohei Yoshida  <kohei.yoshida@gmail.com>  [23a11e8c209480739da8e370f8fd31d716503efa]

	Use 32-bit int type instead of size_t for better hashing performance.

	Also use int values for loop condition.

2019-01-12  Kohei Yoshida  <kohei.yoshida@gmail.com>  [8a29df751e620f102def548703bb8a3ad4bb3380]

	Take advantage of the fact that most pstring instances are pooled.

	This slightly improves parsing performance.

2019-01-12  Kohei Yoshida  <kohei.yoshida@gmail.com>  [77420c6a6615f7173d97ad27880cf2f7a5fe74ea]

	Up the size of the initial memory block.


2019-01-12  Kohei Yoshida  <kohei.yoshida@gmail.com>  [2d8bbda2507249eac4755a1c075338b3b8704802]

	Use boost::object_pool in the implementation of string_pool.

	This addresses #69.  Unfortunately this change doesn't give us
	noticeable performance improvement I was hoping to see.  But it
	at least keeps the implementation a bit cleaner.

2019-01-12  Kohei Yoshida  <kohei.yoshida@gmail.com>  [4195360c482dc158f9ff606aa76d3a84a62132d6]

	Use ranged for loop instead of for_each.


2019-01-12  Kohei Yoshida  <kohei.yoshida@gmail.com>  [09d014425056cad6a2b30a920b32f4e629004f39]

	Set a default null date value.

	Turns out a null date is not always specified in the document.

2019-01-12  Kohei Yoshida  <kohei.yoshida@gmail.com>  [3fd8e011bca9fec6aedac33e0fffa8fb0e9e8c67]

	Optionally support debug levels. Not used in the code yet.


2019-01-11  Kohei Yoshida  <kohei.yoshida@gmail.com>  [4a28670be7fd750e38c9ff62fbc066b30b584cde]

	Remove unused method.


2019-01-09  Kohei Yoshida  <kohei.yoshida@gmail.com>  [c0e1b73635303f88a69d8ff95b32ac786afbd341]

	Inline frequently used simple methods.


2019-01-08  Kohei Yoshida  <kohei.yoshida@gmail.com>  [92f8b61b06b6987f58d6763715209299c44ee575]

	Update the method doc to match the parameter addition.


2019-01-08  Kohei Yoshida  <kohei.yoshida@gmail.com>  [276c91bc2fc51ea5bf1eb0d08cbd17029435e69b]

	Implement parse_expected using SSE4.2 intrinsics.


2019-01-08  Kohei Yoshida  <kohei.yoshida@gmail.com>  [ae2834ac3dac4888231a05d754096b34ee26f8aa]

	Pass the length of the string since we already know it ahead of time.


2019-01-08  Kohei Yoshida  <kohei.yoshida@gmail.com>  [0bee80ee946000480e7deba28883d7f6ea65d0f7]

	Delay clipping of the segment length until before it's really needed.


2019-01-07  Kohei Yoshida  <kohei.yoshida@gmail.com>  [4ecbc9dae1ae889bdc7a658db839d8f015e4b925]

	Finally convert json_value_array, and remove 'store' from json_value.


2019-01-07  Kohei Yoshida  <kohei.yoshida@gmail.com>  [f8aaf8f1b472a573af5c28a590063e71ba88d4d1]

	Use object_pool for json_value_object.

	This actually makes the code slightly slower with document with many objects.

2019-01-07  Kohei Yoshida  <kohei.yoshida@gmail.com>  [64feb4d03869c8ab3f0e256045a8aed6f3f64508]

	Remove json_value_kvp and store key-value pair directly with json_value.

	This will not affect the performance of json document loading since this
	node type is only used when initializing a json document via initializer.

2019-01-07  Kohei Yoshida  <kohei.yoshida@gmail.com>  [90acef58b43121677ad0c4f295d2854203fba2fe]

	Store a json string value directly with the json_value instance.

	This shaves off roughly 0.7 seconds in my environment with

	  perf-test/files/files/json/many-string-values.json

	as the input file.

2019-01-07  Kohei Yoshida  <kohei.yoshida@gmail.com>  [00fa950d783a71446f22b2803fecaf11a1c3888a]

	Store numeric value directly in json_value.

	This shaves off roughly 0.5 seconds in my environment.

2019-01-07  Kohei Yoshida  <kohei.yoshida@gmail.com>  [2072eda5d2578c0811d170036db4d5f97ad47c2e]

	Use object pool to manage all json_value instances.


2019-01-07  Kohei Yoshida  <kohei.yoshida@gmail.com>  [a5f1c5b69025eaf7ea01ab029f0da6153647eb7f]

	Add object pool for json_value to the resource instance.

	Also rename string_pool instance from pool to str_pool.

2019-01-07  Kohei Yoshida  <kohei.yoshida@gmail.com>  [7e4680fd6351ceae86c54e734ddd073926b13032]

	Wrap document's string_pool within document_resource struct.


2019-01-06  Markus Mohrhard  <markus.mohrhard@googlemail.com>  [7f15dfb26e451228f5bf42b2fab4ed776aed4064]

	enable more fixed json validation tests


2019-01-06  Markus Mohrhard  <markus.mohrhard@googlemail.com>  [6d7570f9e24e7e293cbd61eb8a4663759d14c7fd]

	for signed char this comparison would catch too many characters


2019-01-06  Markus Mohrhard  <markus.mohrhard@googlemail.com>  [3ff8120238a87cd070bf5564bf9b5ad2924c56e6]

	parse_number: don't eat the 'e' if exponent parsing fails


2019-01-06  Markus Mohrhard  <markus.mohrhard@googlemail.com>  [90def344a8144c035449789298dc2ba12ebd16e7]

	reorganize parse_number test cases


2019-01-06  Markus Mohrhard  <markus.mohrhard@googlemail.com>  [2bb670f937bf4cafa3838dea35fa2a483d0865e9]

	don't accept numbers without a digit

	The following would be an invalid number "+." or "-.".

2019-01-06  Markus Mohrhard  <markus.mohrhard@googlemail.com>  [3d4f564c90294d504f0ccfba8019b7713e7f361d]

	add a few tests for the orcus::parse_numeric method


2019-01-06  Markus Mohrhard  <markus.mohrhard@googlemail.com>  [2e4a66a297ffd3bc59b364d75bed78c7cacf3ac0]

	json: at least one digit is needed for a valid number


2019-01-06  Markus Mohrhard  <markus.mohrhard@googlemail.com>  [ae18da54dbb8bc44cac32ecb954efd395acf0b08]

	json: enable fixed tests


2019-01-06  Markus Mohrhard  <markus.mohrhard@googlemail.com>  [b0f789e322e854087fe91eaf493179ce75bd3a20]

	json: at least some json content is required in a valid document


2019-01-05  Markus Mohrhard  <markus.mohrhard@googlemail.com>  [a984f9b0f4ff17cd28cae9608cf689f31d9f41aa]

	json: after trailing comma in object a new key is expected


2019-01-05  Markus Mohrhard  <markus.mohrhard@googlemail.com>  [5132158b17b3a14200eed612f6d3b4a0eebb5898]

	json: trailing comma in array is forbidden

	We already handled the case where a space was following the comma. This now
	also covers the case that the trailing ']' is directly following the comma.

2019-01-05  Markus Mohrhard  <markus.mohrhard@googlemail.com>  [d57a142e6136cd89cd860646c91fd74bf9f50ad3]

	Add validation test cases from nst/JSONTestSuite

	Fixes #61.

2019-01-03  Kohei Yoshida  <kohei.yoshida@gmail.com>  [e9a4479b44e4709fe4bb62b99690152b8b7ad4ba]

	Add MPL 2.0 full license text.


2019-01-03  Kohei Yoshida  <kohei.yoshida@gmail.com>  [7a14fe48d7f61788dfc4aa5c62996763652c5c13]

	This was wrong.  n was already clipped at 16 at all times.


2019-01-03  Kohei Yoshida  <kohei.yoshida@gmail.com>  [2a02e8e2b169ef98857c2253c4d4bee3d548d5ff]

	Add simple unit test for skip_space_and_control().


2019-01-03  Kohei Yoshida  <kohei.yoshida@gmail.com>  [e8374cacf0cf0c34e8c339c36e5902df4dc98c22]

	I believe we can simply subtract 16 here.

	Since the only way the code path reaches here is when the segment
	length is 16 (full length) and the whole segment consists of skippable
	characters.

2019-01-03  Kohei Yoshida  <kohei.yoshida@gmail.com>  [105c5af87996a7c9b256c6249df33022ef65877a]

	Fix --enable-debug-utils configure switch.

	Now, not specifying the switch will set its flag to 'no' (as it should).

2019-01-03  Kohei Yoshida  <kohei.yoshida@gmail.com>  [4dcb2bd13d18318345fad50f6c9e5a2253c964be]

	Add this file to the slickedit project.


2018-12-10  Kohei Yoshida  <kohei.yoshida@gmail.com>  [da2f88a1a2e95aa61f36baddda0fcbba98ebc138]

	Initialize this only once.


2018-12-10  Kohei Yoshida  <kohei.yoshida@gmail.com>  [8e6c6686f7882b071e852c2cf376e6f712e65177]

	Remove unnecessary branching.


2018-12-10  Kohei Yoshida  <kohei.yoshida@gmail.com>  [4291c7b5c75e137d5e293974846abd9396403cea]

	available_size() is actually correct here.


2018-12-10  Kohei Yoshida  <kohei.yoshida@gmail.com>  [8ca4f060fb81078623ebc7c73755f3136eb2df28]

	Try to reduce the number of function calls.


2018-12-07  Kohei Yoshida  <kohei.yoshida@gmail.com>  [df27b948db4b1b854d01e93c7aca0e4db9563ac1]

	Use SSE4.2 for skipping space and control characters.


2018-12-07  Kohei Yoshida  <kohei.yoshida@gmail.com>  [fa1cc351e1dccdd9c1512753373e2fa4f32d09e4]

	Implement SSE4.2 version of parser_base::skip().

	And have json::parser_base::skip_blanks() use it.  Unfortunately this
	causes the parser to be a bit slower even with the speedup with the
	SSE4.2 intrinsics.

2018-12-05  Kohei Yoshida  <kohei.yoshida@gmail.com>  [8f2a6857c94bc4a0aec89fab8c7d04b2340c1b97]

	Introduce available_size() to check the available character.

	This one includes the current character so it's the same as
	remaining_size() + 1.

2018-12-05  Kohei Yoshida  <kohei.yoshida@gmail.com>  [8ed6b8954ead8b1e0355f0574ea1b2e60d532289]

	Add a debug util facility to  start adding some extra checks.

	Useful during development.

2018-12-05  Kohei Yoshida  <kohei.yoshida@gmail.com>  [57c0937ea7be9174533c28bd4e0369574a486c75]

	is_in(...) to take additional parameter for the length of char array.

	To support non-null-terminated char array and also in the future avoid
	having to call strlen() before SIMD call each and every time.

2018-12-04  Kohei Yoshida  <kohei.yoshida@gmail.com>  [3f408d170110f0efb073415026ebd47ab582283d]

	These functions ought to be constexpr.


2018-12-04  Kohei Yoshida  <kohei.yoshida@gmail.com>  [4155a70335629f14b795e33426d8f6ac11287980]

	Let's determine CPU features at compile time rather than run-time.


2018-12-04  Kohei Yoshida  <kohei.yoshida@gmail.com>  [b629feded161afcff41b643d606b4a29ddb42485]

	Let's not forget to add this file.


2018-12-04  Kohei Yoshida  <kohei.yoshida@gmail.com>  [0e5f5db5845441edd2e944405539f8718e4b2319]

	Use cpu_features to query for SSE 4.2 availability.


2018-12-04  Kohei Yoshida  <kohei.yoshida@gmail.com>  [cff162fd3e744718c993890abc0e655ad7e923d7]

	Set up a simple CPU feature bucket and a utility to dump it for debugging.


2018-12-04  Kohei Yoshida  <kohei.yoshida@gmail.com>  [f75265c09d678b95984ce76bac2f74c889b28aba]

	Add --with-cpu-features configure switch.


2018-12-04  Kohei Yoshida  <kohei.yoshida@gmail.com>  [cf1d91dcb9a3c1737bca91565ce7eadd39f09790]

	Use std::unique_ptr for cell format storage.


2018-12-03  Kohei Yoshida  <kohei.yoshida@gmail.com>  [b1abd72e01bfb96a1fdd9c8ec2572861891e6603]

	Let's not require the sheet ID be passed twice.


2018-12-03  Kohei Yoshida  <kohei.yoshida@gmail.com>  [781de319107ff7beb1441dd8f8d1eb240c725c7e]

	Overlapped ranges are only used in the html dumper code. Move it there.


2018-12-03  Kohei Yoshida  <kohei.yoshida@gmail.com>  [67d885478d0f1218dfc4ab569dd6b5486d5f2162]

	Move the html dumper code into its own files.


2018-11-29  Kohei Yoshida  <kohei.yoshida@gmail.com>  [ce1d82fe24e2c58f672796e2159ea5d774e87fdc]

	Let's use a simple vector instead of multi_type_matrix.

	Since we are only dealing with one element-type matrix, a simple
	vector will do & and it's much faster this way.

	This is related to #66.

2018-11-29  Kohei Yoshida  <kohei.yoshida@gmail.com>  [f4cf5e21509d525064c7e1b2da883318466911f7]

	Avoid duplicate block searches for each element position.

	This is related to #66.

2018-11-29  Kohei Yoshida  <kohei.yoshida@gmail.com>  [b6c96fbcbc1087a1c3f95ee509c20d0f2bc0e0da]

	Refactor flat dumper for better performance.

	This is related to #66.

2018-11-24  Kohei Yoshida  <kohei.yoshida@gmail.com>  [fd8ec37c9555e3af770b4b7c929aea99439fc950]

	Move the flat dump code into its own source file.


2018-11-21  Kohei Yoshida  <kohei.yoshida@gmail.com>  [c6b2e38467758f58119d271d0958b721bf5fc108]

	Support convertion from millimeters to twips.


2018-11-21  Kohei Yoshida  <kohei.yoshida@gmail.com>  [ee11571f50e1dcde51908e2f73423a7499905e52]

	Generate a more useful error message.


2018-11-20  Kohei Yoshida  <kohei.yoshida@gmail.com>  [283fb19885c41948b924c22c9313f3ac7b011887]

	Add pivot table section.


2018-11-19  Kohei Yoshida  <kohei.yoshida@gmail.com>  [991dfcc9e1ccb3085006813148eeecc83071176e]

	A bit more editing.


2018-11-19  Kohei Yoshida  <kohei.yoshida@gmail.com>  [4a0063c296c5356ff4481991f8791ac01dae5e34]

	Add more missing types and functions.

	Also predefine ORCUS_DLLPUBLIC to be empty in order to improve some
	symbol generations.

2018-11-19  Kohei Yoshida  <kohei.yoshida@gmail.com>  [ab0ddd18cb9666a10616e1ad10c7f33d4a3acdac]

	Add missing interface types.

	A whole bunch more interfaces have been added since 0.13.

2018-11-19  Kohei Yoshida  <kohei.yoshida@gmail.com>  [07a2b9701e70032ff31bda1fc3b4429128d5df8a]

	Split out the types and interfaces into separate file.

	And a bit more editing.

2018-11-16  Kohei Yoshida  <kohei.yoshida@gmail.com>  [6f2f19a4b912f96aee3ca331fe2e6d367ac13d0a]

	Author the formula interface section.


2018-11-16  Kohei Yoshida  <kohei.yoshida@gmail.com>  [181d5294e23862e8e26798ee03ee9b3a35a588f9]

	Annotate formula_grammar_t.


2018-11-15  Kohei Yoshida  <kohei.yoshida@gmail.com>  [231de5c4de1dd9937df7063a9dca6a884dbfe1ab]

	Finish up the example code for receiving formula cells.


2018-11-15  Kohei Yoshida  <kohei.yoshida@gmail.com>  [8c3227af01b7dc2cbb65c7027cd29075380a8b2d]

	Add operator<< overload for formula_grammar_t enum type.


2018-11-15  Kohei Yoshida  <kohei.yoshida@gmail.com>  [8277686257696458e654194ad76495c0cc5d02d0]

	Let's not differentiate xlsx 2007 from xlsx 2010.

	That would be too much of a hassle for a very little gain.

2018-11-14  Kohei Yoshida  <kohei.yoshida@gmail.com>  [ccf916c9310e96193d7ae11310101e37333adc2b]

	Add a new example code to illustrate how to receive formula data.

	Still WIP.

2018-11-14  Kohei Yoshida  <kohei.yoshida@gmail.com>  [5300d50d2b2de7236d12e221f29a1338ba322b8b]

	Write a segway into the import_formula interface.


2018-11-14  Kohei Yoshida  <kohei.yoshida@gmail.com>  [b1ffd08a1062eea73aa5057e123ca30f51a6ab77]

	Finish up the section.


2018-11-14  Kohei Yoshida  <kohei.yoshida@gmail.com>  [c2e3b31c734009bff9ba57850cdae613319b1c71]

	Rewording a bit & add more method docs.


2018-11-13  Kohei Yoshida  <kohei.yoshida@gmail.com>  [7c05c1132015ad9358eb5839906963c83b700a8d]

	More on documenting the shared strings interface. Still not finished.


2018-11-13  Kohei Yoshida  <kohei.yoshida@gmail.com>  [fb51e2236fc2be46f70b868ab5608308a51f91e0]

	A bit more editing on sheet interface & shared strings doc.


2018-11-12  Kohei Yoshida  <kohei.yoshida@gmail.com>  [6d2ae67f1bf3966f11c4a0970a4ef0e36200ed29]

	Add an example code for string pool import.


2018-11-12  Kohei Yoshida  <kohei.yoshida@gmail.com>  [547d4681500a3e51dd72f79c495daa0c23d62579]

	More on authoring the sheet accessor documentation.

	Still not finished yet.

2018-11-09  Kohei Yoshida  <kohei.yoshida@gmail.com>  [eb2f009ed7d4df5648cfabf1a2eb61fc49ec352b]

	More on documenting the sheet accessor.


2018-11-08  Kohei Yoshida  <kohei.yoshida@gmail.com>  [8d319578c2945ecdf058517cdf544ab4a4b5db92]

	Update the example code and the file being used in that code.

	This is to be used in the documentation.

2018-11-07  Kohei Yoshida  <kohei.yoshida@gmail.com>  [e160737d0bbe179467982f94c1c7bbb6772f3782]

	Add a test case which previously caused unsigned integer underflow.

	It's basically an empty stream with a few whitespace characters.

2018-11-07  Kohei Yoshida  <kohei.yoshida@gmail.com>  [3876e8bff097620f8612f1b27f7881e3e1ce0694]

	Prevent unsigned integer underflow.


2018-11-07  Kohei Yoshida  <kohei.yoshida@gmail.com>  [bbbc39e72c01536831d787441091699e8f5d6080]

	Set up a mechanism to parse invalid css files.


2018-11-07  Kohei Yoshida  <kohei.yoshida@gmail.com>  [5d8875ca0afeaefdac3bf3387cff4affec3a5fb1]

	Move this up since this can be used outside of XML specific code.


2018-11-07  Kohei Yoshida  <kohei.yoshida@gmail.com>  [2c52e2992f105c882c2371dd2a2620c033267b71]

	Switch the documentation theme to cloud theme.


2018-11-07  Kohei Yoshida  <kohei.yoshida@gmail.com>  [479952f420e2493fdedfdffc4245c6836a567b7d]

	Switch to mdds-1.5.

	No other code changes necessary.  Quite uneventful.

2018-11-07  Kohei Yoshida  <kohei.yoshida@gmail.com>  [f96240206ca5246914483a455a572c792705ec1b]

	ixion needs spdlog now.


2018-11-07  Kohei Yoshida  <kohei.yoshida@gmail.com>  [bd51a375241cab623cb1632ce273ed1807aaf425]

	Adjust CI to use ixion from the master branch.


2018-11-07  Kohei Yoshida  <kohei.yoshida@gmail.com>  [b2636937c1f759e1662ee25143d18f15ec12f52e]

	Switch to using ixion-0.15.


2018-10-31  Kohei Yoshida  <kohei.yoshida@gmail.com>  [e3a6e29bafe4161e3f97e72d356cb101631a008b]

	Fix all shadowed variables and make it buildable with -Wshadow.

	Also up the version and the API version.

2018-10-03  Kohei Yoshida  <kohei.yoshida@gmail.com>  [0dfa88f2adca7887dbe44bdb7025985777c89673]

	Remove unused VERSION file.

	Thanks to Stephan Bergmann for pointing this out.

2018-09-14  Kohei Yoshida  <kohei.yoshida@gmail.com>  [e2bfc774801f7dffb734d3f47efa12ccb0bde9cb]

	Add URL's to the 0.14.1 packages.


2018-09-14  Kohei Yoshida  <kohei.yoshida@gmail.com>  [4ff564ab58c4525648371ffd9430232e366ed26d]

	Up the version to 0.14.1, and fix configure error with werror enabled.


2018-09-14  Kohei Yoshida  <kohei.yoshida@gmail.com>  [a832279652f5b59d9983abd51ed0392c5c951b55]

	Update boost.m4 from http://github.com/tsuna/boost.m4.


2018-09-13  Kohei Yoshida  <kohei.yoshida@gmail.com>  [2970d026e52f84e7c7a824826ff186a56ea30a0d]

	Updated.


2018-09-13  Kohei Yoshida  <kohei.yoshida@gmail.com>  [b4e561504be8af5ff4ec09aaf37244aebcfc946f]

	CID#191680: Wrapper object use after free (WRAPPER_ESCAPE)

	The coverity report says:

	  3. escape: The internal representation of local jv escapes into
	  const_node->parent, but is destroyed when it exits scope.

	but jv itself is returned from the function *moved*, and it lives on
	in the caller's scope (as intended).  I'm pretty certain that this
	one is false positive.

	The additional code added here verifies that the pointers stored in
	the child nodes match that of the core of the parent.

2018-09-12  Kohei Yoshida  <kohei.yoshida@gmail.com>  [a8b3e09bf08a3c0c5c417b14c4049309a75be4a2]

	CID 191672 (#1 of 1): Uninitialized scalar field (UNINIT_CTOR)

	2. uninit_member: Non-static class member field m_panes.m_selection
	   is not initialized in this constructor nor in any functions that
	   it calls.
	4. uninit_member: Non-static class member field m_split_pane.top_left_cell
	   is not initialized in this constructor nor in any functions that
	   it calls.
	6. uninit_member: Non-static class member field m_frozen_pane.top_left_cell
	   is not initialized in this constructor nor in any functions that
	   it calls.

2018-09-12  Kohei Yoshida  <kohei.yoshida@gmail.com>  [cc06d201a9855305692cb260afba361f84130ae6]

	CID#191675: Not restoring ostream format (STREAM_FORMAT_STATE)

	end_of_path: Changing format state of stream os for categories
	uppercase, basefield without later restoring it.

2018-09-12  Kohei Yoshida  <kohei.yoshida@gmail.com>  [831b146a8486d29a8b2211bc5d7c6d56d38f6484]

	The name of the second column may be empty too.


2018-09-12  Kohei Yoshida  <kohei.yoshida@gmail.com>  [d44e514fe848c773b1834db1d90ffac8a2872f29]

	CID#89231: Improper use of negative value (NEGATIVE_RETURNS)

	negative_returns: col1_index is passed to a parameter that cannot be
	negative.

2018-09-11  Kohei Yoshida  <kohei.yoshida@gmail.com>  [fd7bc42587bd005735e6dbeda76088fe233c1bd4]

	CID#191681: Uninitialized scalar variable (UNINIT)

	uninit_use: Using uninitialized value ret. Field ret.transient is
	uninitialized.

2018-09-11  Kohei Yoshida  <kohei.yoshida@gmail.com>  [5420e08bbb0b6e7bb4abba80afc906e50dad27be]

	CID#149339: Uncaught exception (UNCAUGHT_EXCEPT)

	root_function: In function main(int, char **) an exception of type
	orcus::general_error is thrown and never caught.

2018-09-11  Kohei Yoshida  <kohei.yoshida@gmail.com>  [56b6c15629783e0fdc880a6c20c7c7c29293407d]

	CID#149314: Uncaught exception (UNCAUGHT_EXCEPT)

	root_function: In function main(int, char **) an exception of type
	boost::exception_detail::clone_impl<boost::exception_detail::error_info_injector<boost::bad_any_cast> >
	is thrown and never caught.

2018-09-11  Kohei Yoshida  <kohei.yoshida@gmail.com>  [1999f8823bdf769a5366cb8ac721082057950888]

	CID#164674: Uncaught exception (UNCAUGHT_EXCEPT)

	root_function: In function main(int, char **) an exception of type
	mdds::type_error is thrown and never caught.

2018-09-11  Kohei Yoshida  <kohei.yoshida@gmail.com>  [bdbdfe7c604153819f30cbd0e8aeab1593813d2f]

	CID#149342: Uncaught exception (UNCAUGHT_EXCEPT)

	root_function: In function main(int, char **) an exception of type
	orcus::xml_map_tree::xpath_error is thrown and never caught.

2018-09-10  Kohei Yoshida  <kohei.yoshida@gmail.com>  [ea3c29e8cc43858ffe7053a9af7b36cdb8234c66]

	CID#191671: Uncaught exception (UNCAUGHT_EXCEPT)

	root_function: In function main(int, char **) an exception of type
	std::invalid_argument is thrown and never caught.

2018-09-10  Kohei Yoshida  <kohei.yoshida@gmail.com>  [7a9b818264b3d18937b0c42381cdc5b84b94f24f]

	CID#191673: Uncaught exception (UNCAUGHT_EXCEPT)

	root_function: In function main(int, char **) an exception of type
	orcus::general_error is thrown and never caught.

2018-09-10  Kohei Yoshida  <kohei.yoshida@gmail.com>  [b107a20722b48f096efc0cd4253b3ee8089b3d3c]

	CID#149337: Uncaught exception (UNCAUGHT_EXCEPT)

	root_function: In function main(int, char **) an exception of type
	boost::exception_detail::clone_impl<boost::exception_detail::error_info_injector<boost::bad_any_cast> >
	is thrown and never caught.

2018-09-10  Kohei Yoshida  <kohei.yoshida@gmail.com>  [d821b83af344d74bbba7e4fb47c46be8414d3c7f]

	CID#89234: Uncaught exception (UNCAUGHT_EXCEPT)

	root_function: In function main(int, char **) an exception of type
	orcus::general_error is thrown and never caught.

2018-09-10  Kohei Yoshida  <kohei.yoshida@gmail.com>  [53292c46f8a271c2405664d2fa2f8f50b5e0432e]

	CID#89230: Unchecked return value (CHECKED_RETURN)

	2. check_return: Calling to_rgb without checking return value (as is
	   done elsewhere 4 out of 5 times).

	This change also simplifies the code a bit.

2018-09-10  Kohei Yoshida  <kohei.yoshida@gmail.com>  [829813863730c6908813edb3c14f170245ca8848]

	CID#54448: Uninitialized scalar field (UNINIT_CTOR)

	2. uninit_member: Non-static class member field m_cur_array_range.first
	   is not initialized in this constructor nor in any functions that it
	   calls.

	4. uninit_member: Non-static class member field m_cur_array_range.last
	   is not initialized in this constructor nor in any functions that it
	   calls.

	6. uninit_member: Non-static class member m_active_pane is not
	   initialized in this constructor nor in any functions that it calls.

2018-09-10  Kohei Yoshida  <kohei.yoshida@gmail.com>  [57942a5f6807ecf88d79eb2d3973bb9f4b6ad189]

	CI to use ixion-0.14 for now.

	The ixion master branch is gearing toward ixion-0.15, but orcus is
	not yet ready to move on to it just yet.

2018-09-10  Kohei Yoshida  <kohei.yoshida@gmail.com>  [9c92565a47aceee82eb1470a3630a270b9835a6b]

	Missing header for std::tolower.


2018-09-04  Kohei Yoshida  <kohei.yoshida@gmail.com>  [a3e472464753f0eada274feb6bb8a02a8e6e07f4]

	CID 191674 (#1 of 1): Uninitialized scalar field (UNINIT_CTOR)


2018-09-04  Kohei Yoshida  <kohei.yoshida@gmail.com>  [3341786c0777105a0c00bc1772503bbb95bcb322]

	CID 191677 (#1 of 1): Uninitialized scalar field (UNINIT_CTOR)

	2. uninit_member: Non-static class member pattern_type is not
	initialized in this constructor nor in any functions that it calls.

2018-09-04  Kohei Yoshida  <kohei.yoshida@gmail.com>  [5aefa964f73abee0c7a9a147d9318198e243cd40]

	CID#191684: Side effect in assertion (ASSERT_SIDE_EFFECT)

	assert_side_effect: Argument ++it of assert() has a side effect.
	The containing function might work differently in a non-debug
	build.

2018-08-29  Kohei Yoshida  <kohei.yoshida@gmail.com>  [87bb64f1723831a47211dc006c539e8494ffd1a7]

	0.14.0 is already out & talk about improved numeric precision.


2018-08-29  Kohei Yoshida  <kohei.yoshida@gmail.com>  [1d30abeb74dd07f1398f586b7b0ab2bd047cf237]

	No idea why I applied an extra indent on all lines...


2018-08-29  Kohei Yoshida  <kohei.yoshida@gmail.com>  [bd87f46ba21669b175517cc80af4aa3d0e6f8c4e]

	Reduce the number of numeric operations when converting points to twips.

	Hopefully this will fix #65.

2018-08-23  Kohei Yoshida  <kohei.yoshida@gmail.com>  [2316ecc3ccb3149ff9a53d584582a4a9d5dda8f2]

	Add URL's to the 0.14.0 packages.


2018-08-23  Kohei Yoshida  <kohei.yoshida@gmail.com>  [63452e56e01b793686c719360fcd073e3f63fa3c]

	Up the version to 0.14.0.


2018-08-22  Kohei Yoshida  <kohei.yoshida@gmail.com>  [50652df4c6a5c495c0b8801a4462d7136f8628c6]

	Fix 'make distcheck'.


2018-08-22  Kohei Yoshida  <kohei.yoshida@gmail.com>  [92d5c0f9da5fa65b51d48425e98bc372a2703e36]

	Add a few items for the new release.


2018-08-22  Kohei Yoshida  <kohei.yoshida@gmail.com>  [2e6db4525dceb34f643ee919b2e2145e2ac8e1f9]

	ixion 0.14.0 (API version 0.14) is released.


2018-08-21  Kohei Yoshida  <kohei.yoshida@gmail.com>  [e86a1ea1f69841580405e53973240f822592f028]

	mdds 1.4.0 is released.


2018-07-23  Kohei Yoshida  <kohei.yoshida@gmail.com>  [e6a7fa8f828ebdaad57998a96b993b12e8768c8f]

	xlsx: Add a test case for #63.


2018-07-23  Kohei Yoshida  <kohei.yoshida@gmail.com>  [9bda3a966d657fe0f80de477ccbb83b6026291a6]

	xlsx: Count the sheet and use its counter as sheet index.

	Excel's internal sheet indices are not necessarily sequential in
	increasing order esp. when the sheets get shuffled around after they
	have been created.

	This fixes #63.

2018-07-23  Kohei Yoshida  <kohei.yoshida@gmail.com>  [9666c0c4af9c11f6180c895aa6fe368063bbc208]

	xlsx: Modernize it a bit.


2018-06-12  Kohei Yoshida  <kohei.yoshida@gmail.com>  [c1816fef9b4e458a5b3c77b6fc0dffd1605118e2]

	Use nproc for ixion build.


2018-06-12  Kohei Yoshida  <kohei.yoshida@gmail.com>  [2039a4c18177ee76a2e3cfe03b8ee164da21a523]

	It now depends on the master branch of mdds.


2018-06-12  Kohei Yoshida  <kohei.yoshida@gmail.com>  [45e18ee358dcd4a2e325d66916479baf791733fd]

	Use get_all_namespaces() method in the example code.


2018-06-12  Kohei Yoshida  <kohei.yoshida@gmail.com>  [2dd2f17e0e6530afed76b262a5331f76c7ede798]

	get_all_namespaces() to return a vector.


2018-06-12  Kohei Yoshida  <kohei.yoshida@gmail.com>  [ab52b4cb077378edd99026b828c7a6d69fe4a2b7]

	Add code example for stacked namespaces.


2018-06-12  Kohei Yoshida  <kohei.yoshida@gmail.com>  [6f71d44fa5b12f581a4f87a720c6eb9961cf33ed]

	Use unique_ptr for pimpl.


2018-06-12  Kohei Yoshida  <kohei.yoshida@gmail.com>  [6dddb95c1815f12bfb551582e5b6ab74bec6e9ed]

	Simple example on how to use xml namespace classes.


2018-05-23  Adam Majer  <amajer@suse.de>  [f7485813af8e50f88c77312fb29b7bb489a0a17d]

	Fix build with Boost 1.67

	Boost:DateTime that no longer accepts non-integer types.
	In the past, these types were implicitly cast down to integer
	values. Now this requires explicit cast.

	https://svn.boost.org/trac10/ticket/11168

	This fixes #60

2018-04-13  Kohei Yoshida  <kohei.yoshida@gmail.com>  [8d885d135667c412475fb88695fec322fe36ab66]

	Wrong license header. This is supposed to be MPL.


2018-04-13  Kohei Yoshida  <kohei.yoshida@gmail.com>  [6fa535308bf55d7c4a1caffbf8a324b0a0b69ce5]

	We don't really need to fully-qualify these types with orcus::spreadsheet.

	Remove'em.

2018-04-13  Kohei Yoshida  <kohei.yoshida@gmail.com>  [11a25c9e2925c7fc713dbf3c234f869f33244a1b]

	Add the bits about the import_formula interface class.

	And re-organize the items a bit.

2018-04-13  Kohei Yoshida  <kohei.yoshida@gmail.com>  [2479d637e646eab37fe9e8986f47f5e08fadf4a0]

	Those set_formula_result() methods are no longer necessary.

	Nuke'em.

2018-04-13  Kohei Yoshida  <kohei.yoshida@gmail.com>  [5b3fa87a3b0d031ae7a7bd9b5a641bd0c1ebc53c]

	Remove set_shared_formula in favor of import_formula.


2018-04-13  Kohei Yoshida  <kohei.yoshida@gmail.com>  [d2777c7126a8e37fa6b3f9331acddee0e5106c21]

	Remove set_formula and replace its use with import_formula interface.


2018-04-13  Kohei Yoshida  <kohei.yoshida@gmail.com>  [6f45d887cbf66be54475b6bc7aaabc8246e3ea4b]

	Add import_formula interface class.  Not used yet.


2018-04-13  Kohei Yoshida  <kohei.yoshida@gmail.com>  [b73d55c361dcde0ad810fedaa1f59e18177b407f]

	Remove duplicated code blocks.


2018-04-12  Kohei Yoshida  <kohei.yoshida@gmail.com>  [bcaa2597385dd87a943b091d0759ba42989c3406]

	Talk about the array formula interface change.


2018-04-12  Kohei Yoshida  <kohei.yoshida@gmail.com>  [b9c6d01c2cee4738a493cfc71d00d2ad38e98469]

	Add a new feature.


2018-04-12  Kohei Yoshida  <kohei.yoshida@gmail.com>  [21945a5ff6917e0cd980776aa96312a8a5cf2da4]

	xls-xml: add unit test for the array formula import.


2018-04-12  Kohei Yoshida  <kohei.yoshida@gmail.com>  [adeb28f5e1cdbd1b8bff3f404096b26687abfec9]

	xls-xml: remove duplicate code blocks.


2018-04-12  Kohei Yoshida  <kohei.yoshida@gmail.com>  [76fc6847d85d4f83fa265875bfd0415a1824e325]

	xls-xml: check the array formula store at the end of each table...

	... and push them as needed.

2018-04-12  Kohei Yoshida  <kohei.yoshida@gmail.com>  [5dd96d0770e95d610ab8b7f7837ae1fb4159a6ea]

	Manage to store and push array formulas to the model.

	Still not without issues.  The last array formula won't get pushed
	unless there is a cell following it.

2018-04-11  Kohei Yoshida  <kohei.yoshida@gmail.com>  [f49315729a1c6ee1e152f4dd875d48a6ffbf7e3a]

	Add a dedicated import interface class for array formulas.


2018-04-11  Kohei Yoshida  <kohei.yoshida@gmail.com>  [8a2187a3187dd0baa21bb91b8667e6269c70e435]

	xls-xml: get the formula string from the parent context as well.


2018-04-11  Kohei Yoshida  <kohei.yoshida@gmail.com>  [ff1b89707df456a1f8453a0598d22405017eefbc]

	xls-xml: get the current cell position from the parent context.


2018-04-11  Kohei Yoshida  <kohei.yoshida@gmail.com>  [93b9cc800397b6395c70f8d35a75c850c2757b32]

	xls-xml: get the sheet interface from the parent context.


2018-04-11  Kohei Yoshida  <kohei.yoshida@gmail.com>  [be940db5abb5c4889d18c79de2ab535a7d7208d5]

	xls-xml: pass refernce to the parent context to the data context.

	This way there is no need to pass the import factory pointer.

2018-04-11  Kohei Yoshida  <kohei.yoshida@gmail.com>  [869221727fad81927452f90686c8a2f9784e53b5]

	xls-xml: pick up the array formula range.

	It is not utilized yet.

2018-04-10  Kohei Yoshida  <kohei.yoshida@gmail.com>  [7d8aced0b24bcc5c8c4a083894d0fa0acec63471]

	xls-xml: New test file for array formula import.


2018-04-10  Kohei Yoshida  <kohei.yoshida@gmail.com>  [5183e1487e8ff01be420ad9b5b5497c05635e173]

	Another item to add to CHANGELOG.


2018-04-10  Kohei Yoshida  <kohei.yoshida@gmail.com>  [d4b9dc58e366a92971a8fb6d7afab6a9a1aab219]

	Let's not forget to pass on the character set when appending a sheet.


2018-04-10  Kohei Yoshida  <kohei.yoshida@gmail.com>  [19b99a6ee42ce54dde9d72ab11111625d8a26a98]

	Add new items to CHANGELOG.


2018-04-10  Kohei Yoshida  <kohei.yoshida@gmail.com>  [1d9caf728ea511ea4372ab079a119935e2dfc28f]

	Store the charset with the factory too. And add a test case for it.


2018-04-10  Kohei Yoshida  <kohei.yoshida@gmail.com>  [af7cfe4707d829e334fc8880343880c0770563fe]

	Use unique_ptr for this impl.


2018-04-10  Kohei Yoshida  <kohei.yoshida@gmail.com>  [8dcec9d1699a65509af980bf7cb4a28640d054b0]

	Pass the charset value to the sheets who need it.


2018-04-10  Kohei Yoshida  <kohei.yoshida@gmail.com>  [6f4cc8ebe3a6469d4294ba4507933c347c9044e7]

	Manage to pass the character set all the way to the import factory.

	Also, import_global_settings does not have to be exposed in public.

2018-04-10  Kohei Yoshida  <kohei.yoshida@gmail.com>  [ac487227a38b3b52de92b1394fae5593d17f15db]

	Rename char_encoding_t to character_set_t.


2018-04-09  Kohei Yoshida  <kohei.yoshida@gmail.com>  [c9099eb337eab7edf764d2357cdd7afbfb78d3e7]

	Rename xml_encoding_t -> char_encoding_t.

	This is not specific to XML documents.

2018-04-09  Kohei Yoshida  <kohei.yoshida@gmail.com>  [7ee154b64ad83876c26929498f40e2f4ec833a32]

	Add test cases for the XML declaration parsing.


2018-04-09  Kohei Yoshida  <kohei.yoshida@gmail.com>  [f512a90655f17fe67daf25962972c686a0fdef05]

	Pass the parsed XML declaration content to the handler.

	This adds an additional method declaration() that the handler is
	required to provide.

2018-04-09  Kohei Yoshida  <kohei.yoshida@gmail.com>  [ed98b02877b9aa1c1b23a880b1af676029cab9a5]

	Parse XML declaration and store the results into xml_declaration_t.


2018-04-09  Kohei Yoshida  <kohei.yoshida@gmail.com>  [025dacf453a8ee51abc44c10876a0a30975fc51d]

	Adjust for the recent ixion change.


2018-04-08  Kohei Yoshida  <kohei.yoshida@gmail.com>  [1123c5b1e67564ca1f3942fee691c79215839539]

	Add formula array test case to the automated test.


2018-04-08  Kohei Yoshida  <kohei.yoshida@gmail.com>  [48f5433fdebf1626addf6fde57605dc143abd8cc]

	Handle dumping of array formula strings correctly.


2018-04-08  Kohei Yoshida  <kohei.yoshida@gmail.com>  [2bf46b6e15fd5e7803df27ab745cb48a905f95b9]

	Let's not forget to add override to this method as well.


2018-04-07  Kohei Yoshida  <kohei.yoshida@gmail.com>  [80511a90172287c665f5cd0b0e824a4f0a12007d]

	Add more cells below the first matrix formula cells.


2018-04-07  Kohei Yoshida  <kohei.yoshida@gmail.com>  [7d8255f7b75ef9da01d6ddf2a4e0ed575a44db03]

	Fix the flat dump wrt matrix results.


2018-04-07  Kohei Yoshida  <kohei.yoshida@gmail.com>  [05940cf71c8f02c84490e79f3931bad96e7f574e]

	Put array formula cells into the sheet model for real.


2018-04-07  Kohei Yoshida  <kohei.yoshida@gmail.com>  [1fa57fadd30c4c6826261a5f2d03338248166818]

	Add mechanism to send array formula results to the client app.

	This adds a new interface called import_formula_result, which optionally
	gets returned from the set_array_formula() interface method.

2018-04-07  Kohei Yoshida  <kohei.yoshida@gmail.com>  [4e9674164b05293579aee883f773d28d8db08212]

	xlsx: Store cached array formula results during the load.


2018-04-05  Kohei Yoshida  <kohei.yoshida@gmail.com>  [b577a311ebf1c363ee1aa4c40ccc98e54e6affcb]

	Store array formulas separately from the regular formula cells.


2018-04-05  Kohei Yoshida  <kohei.yoshida@gmail.com>  [502b8165f16f1745b622f5cca4a14489701c5a7f]

	New structures to store cached formula results.

	Not used yet.

2018-04-05  Kohei Yoshida  <kohei.yoshida@gmail.com>  [6567b290ab7360bca562da0ed47cd7907300fe85]

	xlsx: Resolve formula reference range earlier to avoid string copies.


2018-04-05  Kohei Yoshida  <kohei.yoshida@gmail.com>  [c2b866922a49be3416a6ef52a4744f1bd4152fcf]

	Pass range_t to data range's set_range() interface method.


2018-04-05  Kohei Yoshida  <kohei.yoshida@gmail.com>  [805989dbbec5bc7fea394cca8eb8a743c5501ff9]

	Potentially intern these attribute strings.


2018-04-05  Kohei Yoshida  <kohei.yoshida@gmail.com>  [df4dcd963558fcf83b33fb5aafb2e37d60d65d85]

	Use sorted_string_map for this string to enum conversion.


2018-04-05  Kohei Yoshida  <kohei.yoshida@gmail.com>  [c2148660fe4d54a486098d450ad38a446b73afe8]

	Let's not forget to check the namespace value.


2018-04-05  Kohei Yoshida  <kohei.yoshida@gmail.com>  [9b80ae96e0397fbe2787986d20168e391f1d29f7]

	Use range-based for loop over function object with for_each.


2018-04-04  Kohei Yoshida  <kohei.yoshida@gmail.com>  [cf71adf47a58bc12514ecb556928271b3c3c190f]

	Unify the previosly two set_array_formula() interface methods.

	This fixes #54.

2018-04-04  Kohei Yoshida  <kohei.yoshida@gmail.com>  [140bf38551a1b857aaa23ef0785cf8113396181a]

	New Excel file containing a group of array formula cells.


2018-04-04  Kohei Yoshida  <kohei.yoshida@gmail.com>  [6da8bfbd3b913430469b0d0ba37b84c5f07fc5f8]

	xlsx: Add permanent test case for shared formulas.


2018-04-04  Kohei Yoshida  <kohei.yoshida@gmail.com>  [0bd44f3d9dd33fcd7ee95be610a05813c07c6890]

	Remove the variant of set_shared_formula with a range.

	As promised in #58.

2018-04-04  Kohei Yoshida  <kohei.yoshida@gmail.com>  [fd6da05deab540d158a475598a41165d8a5d0ea3]

	Handle regular formula cells on the factory side as well.


2018-04-04  Kohei Yoshida  <kohei.yoshida@gmail.com>  [0aab32342e9df4b6d6c4fb7cc8c0d9d6e28a5667]

	Manage shared formula pool on the orcus side.

	This was previosly managed on the ixion side, but now we do this in
	orcus.  It makes more sense this way.

2018-04-04  Kohei Yoshida  <kohei.yoshida@gmail.com>  [cad45fda50b6d8892bb2077f4d6015d28728ba4f]

	Get a single result value here as well.


2018-04-02  Kohei Yoshida  <kohei.yoshida@gmail.com>  [e9078d37f6ac91d2e17455b8e6bf26ec7cd04cf5]

	Get it to build again against the latest ixion.

	I still need to fix the shared formula handling in the sheet backend.

2018-03-10  Kohei Yoshida  <kohei.yoshida@gmail.com>  [2729ff4cc863262234412fd3f88d1e94711bc116]

	Switch import_auto_filter::set_range() to take range_t parameter.

	This is more generic than taking a range string whose style may be
	different depending on the filter type.

	This addresses #49.

2018-03-10  Kohei Yoshida  <kohei.yoshida@gmail.com>  [6274f11529ec97433215047f691c6dd7c63c9cf2]

	Use range-based loop.


